2010-07-31  Martin Baulig  <martin@ximian.com>

	Welcome to GitHub :-)

2010-06-09  Martin Baulig  <martin@ximian.com>

	* backend/ProcessServant.cs: When attaching, compute initial
	stackframe for all threads.

2010-06-07  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-linux-ptrace.c: Use
	mono_debugger_get_thread_abort_signal() instead of
	mono_thread_get_abort_signal().

	* backend/server/darwin-ptrace.c: Likewise.

2010-06-07  Martin Baulig  <martin@ximian.com>

	* configure.in: Require `mono-2', not `mono'.

2010-07-15  Martin Baulig  <martin@ximian.com>

	* configure.in: Support both 2.6 and trunk.

	* backend/EventQueue.cs: Use the managed Monitor class instead of
	glib's threading functions.

	* backend/server/mutex.[ch]: Removed.

2010-03-03  Miguel de Icaza  <miguel@novell.com>

	* Apply patch from Priit Laes <plaes@plaes.org> to build with make -j

2010-02-23  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.DoAbortInvocation): Use Thread.Abort() to abort the
	invocation if we have runtime support for it.

2010-02-24  Martin Baulig  <martin@ximian.com>

	* frontend/Main.cs: Don't deadlock when leaving a nested
	break state.

	* backend/SingleSteppingEngine.cs
	(SSE.ProcessEvent): On `ChildEventType.RUNTIME_INVOKE_DONE':
	terminate the current operation if it's different from the rti.

	* classes/Operation.cs
	(OperationCommandResult.Completed): Send the result before
	signalling the wait handle.

2010-02-24  Martin Baulig  <martin@ximian.com>

	* backend/server/x86_64-arch.c
	(server_ptrace_call_method_invoke): Set correct return address to
	make this work even if the stack is executable.

2010-02-23  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.DoAbortInvocation): Disallow aborting if there are any
	non-managed frames on the stack.

2010-02-23  Martin Baulig  <martin@ximian.com>

	* languages/TargetNullObject.cs: New file.
	(TargetNullObject): New public class.

	* languages/mono/MonoNullObject.cs: Removed.
	(MonoNullObject): Removed; use `TargetNullObject' instead.

2010-02-23  Martin Baulig  <martin@ximian.com>

	* backend/os/DwarfReader.cs
	(DwarfReader): Don't crash, if the .debug_aranges,
	.debug_pubnames, .debug_pubtypes or .debug_str section is
	missing.

2010-01-08  Martin Baulig  <martin@ximian.com>

	Fix #559045.

	* languages/mono/MonoArrayType.cs
	(MonoArrayType.GetElementSize): Add support for enums.

	* languages/mono/MonoArrayObject.cs
	(MonoArrayObject.GetDynamicSize): Use
	MonoArrayTpe.GetElementSize().

2010-01-08  Martin Baulig  <martin@ximian.com>

	Fix #510995.

	* frontend/Expression.cs
	(CastExpression.DoCast): Allow `object' -> 'object'.
	(Convert.ImplicitConversion): Allow `string' -> `object'.

2009-12-04  Martin Baulig  <martin@ximian.com>

	* backend/BreakpointHandle.cs
	(FunctionBreakpointHandle): Make this class abstract.

	* languages/TargetFunctionType.cs
	(TargetFunctionType): Replace InsertBreakpoint() and
	RemoveBreakpoint() with a new GetBreakpointHandle() API which
	returns a `FunctionBreakpointHandle'.

2009-11-29  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration.LoadConfigurationFromStream): Use
	Report.Error() to report errors instead of throwing an exception.
	(DebuggerConfiguration.UserNotifications): New public property.
	(DebuggerConfiguration.NotifyUser_ThreadCreation): Mark as obsolete.
	(DebuggerConfiguration.UserNotificationType): New public enum.

	* frontend/Command.cs
	(ConfigCommand): Add `user-notifications' option to modify the new
	`DebuggerConfiguration.UserNotifications'.

2009-11-25  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration.IsCLI): New public property to check
	whether we're running the CLI or a GUI.

	* classes/DebuggerSession.cs
	(DebuggerSession.ctor): Only auto-insert the
	`MainMethodBreakpoint' in the CLI.

2009-11-25  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerSession.GetEvent): Return null if the event doesn't
	exist, don't throw any exception.

	* frontend/ScriptingContext.cs
	(ScriptingContext.ActivatePendingBreakpoint): New internal method;
	activate pending breakpoints and wait for its completion.

	* frontend/Command.cs
	(BreakpointDeleteCommand.ActionDone): Call it here ...
	(BreakCommand.DoExecute): ... and here.

	* test/testsuite/TestMethodLookup.cs: This fixes a race condition here.

2009-11-25  Martin Baulig  <martin@ximian.com>

	Hardware breakpoints are per-thread and not per-process; allow
	having both a hardware and a regular breakpoint on the same
	instruction.

	* backend/server/x86_64-arch.c
	(ArchInfo): Add `BreakpointManager *hw_bpm'.
	(server_ptrace_current_insn_is_bpt): Check both `arch->hw_bpm' and
	`handle->bpm'; we may now have both a hardware and a regular
	breakpoint on the same instruction.
	(lookup_breakpoint): New static function to look in both
	`arch->hw_bpm' and `handle->bpm'; use this everywhere instead of
	calling mono_debugger_breakpoint_manager_lookup_by_id() directly.

2009-11-25  Martin Baulig  <martin@ximian.com>

	Don't activate address breakpoints twice.

	* classes/AddressBreakpoint.cs
	(AddressBreakpoint.NeedsActivation): Overwrite and return `false'.

	* frontend/Command.cs
	(BreakCommand.DoExecute): Check `Breakpoint.NeedsActivation' before
	calling Activate() on it.

2009-10-19  Martin Baulig  <martin@ximian.com>

	* backend/Inferior.cs
	(Inferior.SignalInfo): Add `SIGWINCH'.
	(Inferior.Has_SIGWINCH): New public property.
	(Inferior.SIGWINCH): New public property.

	* backend/server.h
	(SignalInfo): Add `sigwinch'.

	* backend/ThreadManager.cs
	(ThreadManager.HandleChildEvent): Ignore `SIGWINCH'.

2009-10-19  Martin Baulig  <martin@ximian.com>

	Detach after exec() if we don't have permission to debug the
	child; this happens if the exec()d binary is setuid/setgid.

	* backend/Inferior.cs
	(Inferior.ProcessEvent): Removed child_execd().
	(Inferior.InitializeAfterExec): Call GetApplication() and
	start.SetupApplication() here.

	* backend/ProcessServant.cs
	(ProcessServant.ChildExecd): Catch `TargetError.PermissionDenied'
	and detach from the process; this happens when exec()ing
	setuid/setgid applications.

	* classes/TargetException.cs
	(TargetError): Add `PermissionDenied'.

	* backend/server/x86-linux-ptrace.c
	(_server_ptrace_setup_inferior): Check `EACCES' and return
	`COMMAND_ERROR_PERMISSION_DENIED'.

2009-10-14  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.OperationMonoTrampoline): Fix bug #544935; the runtime now
	supports a new trampoline notification which also gives us the
	address of the callsite, so we can detect recursive invocations of
	mono_generic_trampoline().

2009-11-05  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.Notification): On `LoadModule': don't crash
	if load_symfile() failed.

2009-10-08  Martin Baulig  <martin@ximian.com>

	* build/mdb: Use the full pathname to invoke mono.
	* build/mdb-symbolreader: Likewise.

	* backend/ProcessStart.cs
	(ProcessStart.SetupEnvironment): Don't set `MONO_GAC_PREFIX',
	`MONO_PATH', `LD_LIBRARY_PATH' and `PATH'.

2009-10-08  Martin Baulig  <martin@ximian.com>

	Improve follow-fork(), allow following exec() without fork()ing
	first; shell scripts, for instance, use this technique.

	* classes/Thread.cs
	(ThreadCommandResult): Use a private `ManualResetEvent'.

	* classes/Operation.cs
	(OperationCommandResult): Make this class abstract.
	(OperationCommandResult.Host): Make this property abstract.
	(OperationCommandResult.OnExecd): New internal abstract method.

	* backend/Inferior.cs
	(Inferior.SetupInferior): Call GetApplication() instead of using
	`start.TargetApplication'.

	* backend/ProcessStart.cs
	(ProcessStart.StopInMain): Add internal setter.
	(ProcessStart.SetupApplication): Don't set StopInMain to false.

	* backend/ProcessServant.cs
	(ProcessServant.ChildForked): Set `StopInMain' to false here ...
	(ProcessServant.ChildExecd): ... but not here.
	(ProcessServant.ChildExecd): Don't clone the session and reuse the
	`OperationCommandResult', only call OnExecd() on it to change its
	`Host' if necessary.

	* classes/DebuggerSession.cs
	(DebuggerSession.OnProcessExecd): New internal method.
	(DebuggerSession.OnProcessExited): Unload all modules if we're the
	main process.

	* backend/ProcessServant.cs
	(ProcessServant.ProcessCommandResult): New protected class.

	* backend/DebuggerServant.cs
	(DebuggerServant.GlobalCommandResult): New protected class.

	* test/testsuite/testnativenoforkexec.cs: New test.
	* test/src/testnativenoforkexec.c: New test.

	* test/testsuite/TestDontFollowFork.cs: Increase timeout.

	* test/testsuite/testnativefork.cs: Remove "NotWorking".

2009-10-01  Martin Baulig  <martin@ximian.com>

	* classes/ProcessStart.cs
	(ProcessStart.cctor): Use `BuildInfo.mono' to set `MonoPath'
	instead of computing it here.

2009-09-29  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerSession.GetPendingBreakpoints): Small fix; make this work
	for native applications.

2009-09-23  Martin Baulig  <martin@ximian.com>

	* classes/ExpressionEvaluator.cs
	(EE.EvaluationResult): Add `NotInitialized'.

	* classes/Thread.cs
	(RuntimeInvokeResult): Add `TargetException'.

	* backend/SingleSteppingEngine.cs
	(OperationRuntimeInvoke): Set 'RuntimeInvokeResult.TargetException'
	on error.

2009-09-24  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerSession.ctor): Always insert the `MainMethodBreakpoint';
	we need it to correctly set the stack pointer.

	* backend/SingleSteppingEngine.cs
	(SSE.child_breakpoint): Set `main_retaddr' if we're the
	`MainMethodBreakpoint'.

2009-09-22  Martin Baulig  <martin@ximian.com>

	* languages/TargetStructType.cs
	(TargetStructType.IsClassInitialized): New public property.

2009-09-22  Martin Baulig  <martin@ximian.com>

	Fix #528160.

	* backend/ThreadManager.cs
	(ThreadManager.HasPendingSigstopForNewThread): New internal method.

	* backend/Inferior.cs
	(Inferior.InitializeThread): Call it here to see whether we
	already received the SIGSTOP for the new thread.

2009-09-22  Martin Baulig  <martin@ximian.com>

	* frontend/ScriptingContext.cs: Some more `TargetClassType' ->
	`TargetStructType'.

	* frontend/Expression.cs: Likewise.

2009-09-17  Martin Baulig  <martin@ximian.com>

	* languages/TargetClassType.cs: Renamed `TargetClassType' into
	`TargetStructType' and add a new empty `TargetClassType'.

	* languages/TargetClassObject.cs: Renamed `TargetClassObject' into
	`TargetStructObject' and add a new empty `TargetClassObject'.

2009-09-15  Martin Baulig  <martin@ximian.com>

	* backend/mono/MonoRuntime.cs: Renamed into MetadataHelper.cs.
	(MonoRuntime): Renamed into `MetadataHelper'.

2009-09-15  Martin Baulig  <martin@ximian.com>

	* backend/mono/: Moved all the Mono Runtime code here.

	* backend/MonoThreadManager.cs: Moved to backend/mono/.
	* languages/mono/MonoLanguageBackend.cs: Likewise.
	* languages/mono/MonoRuntime.cs: Likewise.

2009-09-15  Martin Baulig  <martin@ximian.com>

	* languages/TargetStructType.cs: Removed.
	(TargetStructType): Moved everything into `TargetClassType'.

	* languages/TargetStructObject.cs: Removed.
	(TargetStructObject): Moved everything into `TargetClassObject'.

	* languages/mono/MonoStructType: New file.

2009-09-08  Jonathan Chambers  <joncham@gmail.com>

	* backend/server/i386-arch.h: Define register access for CONTEXT on Windows.

	* backend/server/server.h: Add SERVER_TYPE_WIN32.

	* backend/server/x86-windows.c: Merge of work from Unity.

	Unity is releasing all the sourcecode that Friedrich Dominicus has
	done on the mono debugger, as part of a contracting agreement with
	Unity, under the MIT-X11 license.

	Joachim Ante, CTO Unity

2009-09-26  Jonathan Chambers  <joncham@gmail.com>

	* build/mdb.csproj: Add ExpressionParser.cs.

	* build/Mono.Debugger.Frontend.csproj: Add ExpressionParser.cs.
	
	Contributed under MIT/X11 license.

2009-08-18  Martin Baulig  <martin@ximian.com>

	Fix #531062; correctly handle methods in compiler-generated files.

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile.GetMethods): Use the compilation unit from the
	symbol file as the method's source file.

	* classes/SourceInfo.cs
	(SourceFile.GetMethod): Check whether the method is in the correct
	source file.

2009-08-12  Martin Baulig  <martin@ximian.com>

	* doc/README.breakpoints: Add documentation about the new
	breakpoint API.

2009-08-06  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerSession.ActivateEventAsync): New public method.
	(DebuggerSession.DeactivateEventAsync): New public method.

2009-08-06  Martin Baulig  <martin@ximian.com>

	Don't require the target to be stopped to detach; allow detaching
	from any target on Linux.

	* backend/server/server.h
	(ServerCapabilities): Add `SERVER_CAPABILITIES_CAN_DETACH_ANY'.

	* backend/server/x86-linux-ptrace.c
	(server_ptrace_get_capabilities):  ... and add it here.

	* backend/Inferior.cs
	(Inferior.CanDetachAny): New public static property.

	* backend/ProcessServant.cs
	(ProcessServant.CanDetach): New property.
	(ProcessServant.Detach): Can `CanDetach', not `IsAttach'.

	* backend/SingleSteppingEngine.cs
	(SSE.Detach): Don't require the target to be stopped.

	* classes/Debugger.cs
	(Debugger.CanDetach): New public property.

2009-08-06  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs:
	(ConfigCommand): Add "redirect-output" here, this was missing.

2009-08-05  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.ManagedCallback): If we found a managed frame, check whether
	we can do all the work immediately or whether we need to start an
	operation for it.

2009-08-05  Martin Baulig  <martin@ximian.com>

	Support removing breakpoints while the target is running.

	* backend/ProcessServant.cs
	(ProcessServant.ExceptionCatchPoints): Removed; the session now
	maintains exception catchpoints.

	* backend/SingleSteppingEngine.cs
	(SSE.ActivatePendingBreakpoints): We now also handle removals.
	(SSE.OperationRemoveBreakpoint): New operation to remove a managed
	breakpoint.

	* classes/Breakpoint.cs
	(Breakpoint.NeedsActivation): New public property; event handlers
	don't need any activation.

	* classes/DebuggerSession.cs
	(DebuggerSession.InsertExceptionCatchPoint): Exception catchpoints
	don't need to be activated.
	(DebuggerSession.ExceptionCatchPoints): The session now maintains
	all exception catchpoints; moved here from `ProcessServant'.
	(DebuggerSession.RemoveBreakpoint): Immediately remove the
	breakpoint from our list, but don't actually delete it - the
	target doesn't need to be stopped to call this method, the method
	is queued for removal during Process.ActivatePendingBreakpoints().

	* classes/Process.cs
	(Process.ActivatePendingBreakpoints): Don't block, return a
	`CommandResult' you can wait on.

2009-08-05  Martin Baulig  <martin@ximian.com>

	* backend/server/x86_64-arch.c
	(find_code_buffer_slot): Return a different slot each time we're
	called until we iterated over the entire buffer; it looks like
	there's a very weird race condition somewhere in the kernel which
	doesn't always flush the cpu's instruction cache when modifying
	the current instruction and then immediately executing it.
	(x86_arch_child_stopped): Return `STOP_ACTION_INTERNAL_ERROR' if
	we stopped at an unexpected location inside the code buffer.

	* backend/server/i386-arch.c
	(find_code_buffer_slot): No idea whether we need this here as
	well, but it doesn't hurt doing it here as well.

	* backend/server/x86-arch.h
	(ChildStoppedAction): Added `STOP_ACTION_INTERNAL_ERROR'.

	* backend/server/server.h
	(ServerStatusMessageType): Added `MESSAGE_INTERNAL_ERROR'.

	* backend/Inferior.cs
	(Inferior.ChildEventType): Added `INTERNAL_ERROR'.

2009-08-05  Martin Baulig  <martin@ximian.com>

	Add error checks to enforce managed context for func-eval.

	NOTE: This patch intentionally ``breaks'' breakpoints in
	MonoDevelop; func-eval cannot be allowed when stopped at random
	locations in unmanaged code, the result would be completely
	unpredictable.

	It looks like there were some misunderstandings about the
	debugger's breakpoint API:

	-> DebuggerSession.AddEvent() adds an event / breakpoint to the
	session, but does not activate it.

	-> Event.Activate() activates the event / breakpoint and requires
	you to be stopped *in managed code* (the only exception is address
	breakpoints which work everywhere).

	-> Process.ActivatePendingBreakpoints() is the correct API to
	activate breakpoints while the target is running.  This is an
	expensive operation, so if you have multiple breakpoints, you
	should DebuggerSession.AddEvent() them all then then call
	Process.ActivatePendingBreakpoints() only once when done.

	* classes/TargetException.cs
	(TargetError): Added `InvalidContext'.

	* backend/SingleSteppingEngine.cs
	(SSE): Add enforce_managed_context() calls to all CallMethod()
	overloads and to RuntimeInvoke().

2009-08-04  Martin Baulig  <martin@ximian.com>

	* frontend/ExpressionParser.cs
	(ExpressionParser): Rename `MyExpression' -> `Expression' and make
	it public; rename `MyExpressionWrapper' -> `ExpressionWrapper' and
	make it public; rename `MyAsycResult' -> `AsyncResult' and make it
	public.

2009-08-04  Martin Baulig  <martin@ximian.com>

	* frontend/ExpressionParser.cs: New file.
	(ExpressionParser): Moved here from Expression.cs.
	(ExpressionParser.GetVariableAccessExpression): Added.
	(ExpressionParser.GetMemberAccessExpression): Added.

	* frontend/Expression.cs
	(StructAccessExpression): Made the .ctor public.

	* classes/ExpressionEvaluator.cs
	(EE.IExpression): Renamed `EvaluateAsync' -> `Evaluate'.
	(EE.IExpression): Added `Assign'.

2009-08-04  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.OperationRuntimeInvokeHelper): Improve error handling.

2009-07-08  Martin Baulig  <martin@ximian.com>

	Martin's new Threading Model.

	* classes/GUIManager.cs
	(GUIManager): Made this obsolete, it's now just a tiny wrapper
	around the new API.

	* classes/Operation.cs: New file.
	(ThreadingModel): New public enum.
	(CommandResult): New public abstract class.
	(OperationHost): New internal interface.
	(OperationCommandResult): New public class.

	* backend/ThreadServant.cs
	(ThreadServant.StepInstruction): Removed, use the new Step() API.
	(ThreadServant.StepNativeInstruction): Likewise.
	(ThreadServant.NextInstruction): Likewise.
	(ThreadServant.StepLine): Likewise.
	(ThreadServant.NextLine): Likewise.
	(ThreadServant.Finish): Removed, use the new Step() API.

	* backend/SingleSteppingEngine.cs
	(SSE.OperationStep): Add support for `StepMode.Run'; this
	obsoletes `OperationRun'.
	(SSE.OperationRun): Removed; use `OperationStep' with `StepMode.Run'.
	(SSE.OperationFinish): Removed; use `OperationStep' with
	`StepMode.Finish' or `StepMode.FinishNative'.

	* backend/StepFrame.cs: Moved to ../classes/StepFrame.cs.

	* classes/StepFrame.cs
	(StepMode): Made this public.
	(StepFrame): Make this public and [Serializable].
	(StepMode.Run): Added.
	(StepMode.FinishNative): Added.
	(StepFrame.Until): New public property; only valid in`
	StepMode.Run'.

	* classes/Thread.cs
	(Thread.Step): New public function.
	(Thread.StepInstruction): Obsolete, use the new Step() API.
	(Thread.StepNativeInstruction): Likewise.
	(Thread.NextInstruction): Likewise.
	(Thread.StepLine): Likewise.
	(Thread.NextLine): Likewise.
	(Thread.Continue): Use `Step (StepMode.Run)'.
	(Thread.Background): Obsolete; this was never implemented and
	always the same as Continue().
	(Thread.Finish): Obsolete, use the new Step() API.

	* backend/ThreadServant.cs
	(ThreadServant.Step): New public function.

2009-07-13  Jonathan Chambers  <joncham@gmail.com>

	* backend/Inferior.cs: Add and handle WINDOWS server type.

2009-07-13  Jonathan Chambers  <joncham@gmail.com>

	* backend/os/PEReader.cs: Add.

	* backend/os/WindowsOperatingSystem.cs: Add.
	
	Contributed under MIT/X11 license.

2009-07-03  Jonathan Chambers  <joncham@gmail.com>

	* build/Mono.Debugger.csproj: Add backend/os directory.

	* frontend/CSharpExpressionParser.cs.win: Update.

2009-07-07  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.TargetState): Return `TargetState.Busy' while being thread-locked.
	(SSE.StartOperation): Disallow starting any new operation while
	being thread-locked.

2009-07-07  Martin Baulig  <martin@ximian.com>

	Make exception catchpoints per-process and not per-thread.

	* classes/Process.cs
	(Process.AddExceptionCatchPoint): New public method.
	(Process.RemoveExceptionCatchPoint): Likewise.

	* classes/Thread.cs
	(Thread.AddEventHandler): Removed.
	(Thread.RemoveEventHandler): Removed.

	* backend/ProcessServant.cs
	(ProcessServant.AddExceptionCatchPoint): New internal method.
	(ProcessServant.RemoveExceptionCatchPoint): Likewise.
	(ProcessServant.ExceptionCatchPoints): New internal property.

	* backend/ThreadServant.cs
	(ThreadServant.AddEventHandler): Removed.
	(ThreadServant.RemoveEventHandler): Removed.

2009-07-01  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoRuntime.cs
	(MonoRuntime.GetGenericParameter): Check whether the name field is
	non-null and use `!0' etc. otherwise.

2009-06-30  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.Kill): Stop the target before killing it; for some reason,
	`ptrace (PTRACE_KILL)' doens't work while the target is running.

2009-06-30  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs
	(MonoThreadManager.HandleChildEvent): In
	`NotificationType.GcThreadExited', resume the target and ignore
	any errors; for some reason, the thread may have died already by
	the time we get the notification.

2009-06-30  Martin Baulig  <martin@ximian.com>

	* classes/Debugger.cs
	(Debugger.HasTarget): New public property.

	* frontend/Interpreter.cs
	(Interpreter.HasTarget): Also check 'debugger.HasTarget'.

2009-06-30  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-linux-ptrace.c
	(server_ptrace_kill): Don't call kill(), `ptrace (PTRACE_KILL)'
	should be enough.

2009-06-30  Martin Baulig  <martin@ximian.com>

	* test/testsuite/TestAttach.cs: Removed the `MARTIN_PRIVATE'
	conditional for this test and increased the timeout to 10 seconds.

	* test/testsuite/testnativeattach.cs: Likewise.

2009-06-30  Martin Baulig  <martin@ximian.com>

	Officially enable attaching again - we check whether the target
	runtime actually supports it and attach in native mode if not.

	* configure.in: Check whether the current runtime supports
	attaching and enable the attaching tests; note that the check is
	only used to determine whether or not to run the tests, not
	whether the feature as such is included.

	* classes/DebuggerConfiguration.cs: Removed the private
	configuration option to enable attaching; attaching is now enabled
	by default if the target runtime supports it.

	* test/testsuite/TestAttach.cs: Start the child process with
	`-O=-gshared'.

	* backend/MonoThreadManager.cs
	(MonoThreadManager.ctor): Don't call read_thread_table().
	(MonoThreadManager.read_thread_table): Renamed into
	InitializeThreads() and made it internal.

	* backend/ProcessServant.cs
	(ProcessServant.InitializeMono): Call
	`MonoThreadManager.InitializeThreads()' after our
	InitializeThreads().

2009-06-30  Martin Baulig  <martin@ximian.com>

	Run each test in a separate process to reduce memory requirements
	and also be more robust against crashes.

	* test/framework/DebuggerTextFixture.cs: Formerly known as
	../testsuite/NUnit.cs.

	* test/framework/LibGTop.cs: Formerly known as ../misc/LibGTop.cs.

	* test/framework/DebuggerTestFixtureAttribute.cs: New file.
	* test/framework/DebuggerTestHost.cs: New file.
	* test/framework/DebuggerTestServer.cs: New file.
	* test/framework/ProxyListener.cs: New file.
	* test/framework/RemotingContract.cs: New file.

	* test/testsuite/NUnitAddIn.cs: New file; this is an add-in for
	nunit which takes care of running the tests.

	* test/testsuite/*.cs: Use [DebuggerTestFixture] instead of
	[TestSuite]; the attribute takes optional `Timeout' and `Repeat'
	arguments.

	* build/Makefile.am: Build Mono.Debugger.Test.Framework.dll to
	contain the test framework; Mono.Debugger.Test.dll now only
	contains the actual test cases.

2009-06-29  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassInfo.cs
	(MonoClassInfo.GetFields): Don't throw an exception if the class
	doesn't have any fields.

2009-06-25  jonas echterhoff  <jonas@unity3d.com>
	
	* backend/os/DarwinOperatingSystem.cs
	Add support for detecting dynamic library loads on OS X,
	will detect dynamically linked libmono.
	
	* backend/os/bfd/mach-o.c
	Don't give errors on some load symbols common for OS X
	dynamic libraries

2009-06-29  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassInfo.cs
	(MonoClassInfo.GetFields): Don't throw an exception if the class
	doesn't have any fields.

2009-06-22  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassInfo.cs
	(MonoClassInfo.GetFields): Check whether the class is already
	initialized and throw an exception on error.

2009-06-20  Martin Baulig  <martin@ximian.com>

	* classes/Debugger.cs
	(Debugger.ManagedThreadCreatedEvent): New public event.

	* frontend/Interpreter.cs
	(Interpreter.WaitAll): Wait on all the threads we auto-stopped.
	(Interpreter.InterpreterEventSink): Also listen for
	`ManagedThreadCreatedEvents'; 'ThreadCreatedEvent' is emitted for
	any thread, including native deamon threads.

2009-06-20  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.StartOperation): Fix a regression introduced in r135640:
	reset `operation_completed_event' when starting a new operation.

2009-06-20  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs: Reflect latest runtime changes; if
	the target runtime is at least 81.3, check the new 'thread_flags'
	field in the 'MonoDebuggerThreadInfo' to detect daemon threads.

2009-06-20  Martin Baulig  <martin@ximian.com>

	Fix attaching support.

	* backend/MonoThreadManager.cs
	(MonoThreadManager.Initialize): New public static method to create
	a new `MonoThreadManager' instance, we do some error checking here
	and return null on failure; the .ctor is now private.
	(MonoThreadManager.read_thread_table): Moved here from
	ProcessServant.cs.
	(MonoThreadManager.MonoDebuggerInfo.Create): Return null on
	failure instead of throwing an exception.
	(MonoThreadManager.MonoDebuggerInfo.CheckRuntimeVersion): New
	public method.

	* backend/ProcessServant.cs
	(ProcessServant.MonoRuntimeFound): New internal property; returns
	whether we already found a mono runtime, even if we could not use
	this runtime for some reason and are thus running in native mode.
	(ProcessServant.ThreadCreated): Added `bool resume_thread'
	argument to specify whether the new thread should be resumed or
	remain stopped.
	(ProcessServant.InitializeMono): Improve error handling.
	(ProcessServant.InitializeThreads): This may now be called
	multiple times.
	(ProcessServant.DropGlobalThreadLock): New internal method;
	release the `thread_lock' mutex in SSE.Detach() since disposing
	the still-locked mutex would throw an exception.

	* backend/SingleSteppingEngine.cs
	(SSE.StartThread): Add `bool resume_thread' argument to specify
	whether the new thread should be resumed or remain stopped.
	(SSE.Detach): Call `process.DropGlobalThreadLock()'.

2009-06-20  Martin Baulig  <martin@ximian.com>

	* classes/Backtrace.cs
	(Backtrace.IsFrameOkForMode): `Mode.Default' defaults to native
	unless we're debugging a managed application.

2009-06-18  Martin Baulig  <martin@ximian.com>

	* backend/os/Bfd.cs
	(Bfd.ctor): Fix #510031, don't crash when some native library
	doesn't contain a '.text' or '.bfd' section.

2009-06-18  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-ptrace.c
	(server_ptrace_step): Moved into x86-linux-ptrace.c.
	(server_ptrace_continue): Likewise.
	(server_ptrace_kill): Likewise.
	(server_ptrace_write_memory): Likewise.
	(server_ptrace_poke_word): Likewise.

2009-06-18  Martin Baulig  <martin@ximian.com>

	* backend/server/server.h
	(ServerType): New public enum typedef.
	(mono_debugger_server_get_server_type): New global function.
	(InferiorVTable): Add `get_server_type'.

	* backend/Inferior.cs
	(Inferior.CreateOperatingSystemBackend): New public static method;
	calls mono_debugger_server_get_type() and creates the appropriate
	`OperatingSystemBackend'.

2009-06-18  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-ptrace.c: Moved some linux-specific code into
	x86-linux-ptrace.c.

	* backend/server/darwin-ptrace.c: Moved os-specific stuff from
	`InferiorHandle' into `OSData'.

2009-06-18  Martin Baulig  <martin@ximian.com>

	Mac OS X patches from jonas echterhoff <jonas@unity3d.com>.

	* backend/ProcessServant.cs: Detect threads on OS X.

	* backend/ThreadManager.cs: Detect threads on OS X.

	* backend/SingleSteppingEngine.cs
	(SSE.SetMainReturnAddress): Reset this when we exit.

	* backend/os/Bfd.cs: `LinuxOperatingSystem' -> `OperatingSystemBackend'.

	* backend/os/DarwinOperatingSystem.cs: New file.

	* backend/server/darwin-ptrace.c
	(server_ptrace_get_threads): Implemented.

2009-06-16  Martin Baulig  <martin@ximian.com>

	* classes/ExpressionEvaluator.cs
	(ExpressionParsingException): Removed `ErrorOutput'.

	* frontend/CSharpTokenizer.cs
	(SyntaxError): Removed.
	(Tokenizer): Throw a `yyParser.yyException' instead of returning
	`Token.ERROR'; killed `Error'.

	* frontend/jay/skeleton.cs: Killed `ErrorOutput', yyerror() now
	throws a `yyParser.yyException'.

	* frontend/CSharpExpressionParser.jay: Improved error handling.

	* frontend/skeleton: Removed.
	* frontend/jay/skeleton: Removed.

2009-06-15  Martin Baulig  <martin@ximian.com>

	* classes/GUIManager.cs
	(GUIManager.EvaluationDone): Invoke the callback directly, don't
	queue it as an event - it must be called before signalling the
	AsyncResult.

2009-06-10  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs
	(ExpressionParser.EvaluateAsync): Invoke the callback before
	signalling the wait handle.

2009-06-10  Martin Baulig  <martin@ximian.com>

	* classes/GUIManager.cs
	(GUIManager.EvaluateExpressionAsync): Return an
	`ExpressionEvaluator.AsyncResult'.

2009-06-08  Martin Baulig  <martin@ximian.com>

	* backend/ThreadServant.cs
	(ThreadServant.WaitHandle): New public abstract property.

	* classes/Thread.cs
	(Thread.WaitHandle): Use `servant.WaitHandle'.
	(Thread.operation_completed_event): Removed; use the SSE's
	wait handle instead.
	(CommandResult.Completed): Make this internal, not public.
	(OperationCommandResult): New public class; derives from
	`ThreadCommandResult', but has its own wait handle.  This is set
	when the operation is completed, which is not necessarily when the
	target is stopped.
	(RuntimeInvokeResult): Derive from `OperationCommandResult'.

2009-06-08  Martin Baulig  <martin@ximian.com>

	* backend/ThreadServant.cs
	(ThreadServant.GetRuntimeInvokedFunction): New internal function.

	* classes/Backtrace.cs
	(Backtrace.TryCallback): Print the name of the runtime-invoke'd
	function int the backtrace.

	* test/testsuite/NUnit/NUnit.cs
	(TestSuite.AssertRuntimeInvokeFrame): New public method.

2009-06-08  Martin Baulig  <martin@ximian.com>

	* test/{testsuite|src}/TestNestedBreakStates.cs: Add new testcase.

2009-06-08  Martin Baulig  <martin@ximian.com>

	* classes/Process.cs
	(ExceptionAction): Make this enum public.
	(ExceptionCatchPointHandler): Replaced `out bool stopped' with
	`out ExceptionAction action'.
	(Process.GenericExceptionCatchPoint): Likewise.

	* frontend/Expression.cs
	(ExpressionParser.EvaluateAsync): Check the flags and set
	`ScriptingFlags.NestedBreakStates' if requested.
	(ExpressionParser.DoEvaluate): Catch `InvocationException' here as
	well and report `EvaluationResult.Exception'.
	(InvocationExpression.DoInvoke): Throw an `InvocationException'
	instead of a `ScriptingException' if we received an exception.

	* frontend/ScriptingContext.cs
	(ScriptingContext.InvocationException): New public exception
	class; derives from `ScriptingException'.

2009-06-05  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs:
	(OperationMonoTrampoline.ResumeOperation): Resume operation in
	case we're interrupted unexpectedly, for instance because of a
	module load notification.

	* test/testsuite/TestBreakpoint2.cs: New testcase for it.

	* test/testsuite/NUnit.cs
	(TestSuite:AddSourceFile): New protected method to read automatic
	breakpoints in another source file.

2009-06-04  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE): Kill `stop_requested'.
	(SSE.AbortInvocation): Stop the target if necessary.

	* classes/Thread.cs

	* backend/ThreadServant.cs
	(ThreadServant.AbortInvocation): Make this internal.

	* classes/Thread.cs
	(Thread.RuntimeInvoke): Use `operation_completed_event' here as
	well, just like we're doing it for stepping operations.
	(Thread.AbortInvocation): Make this internal.
	(RuntimeInvokeResult): Derive from `ThreadCommandResult'.
	(RuntimeInvokeResult.Abort): Call Thread.AbortInvocation() and
	wait until it completed.

	* frontend/Expression.cs
	(ExpressionParser): Renamed Parse() -> ParseInternal() and added a
	new Parse() method returning `EE.IExpression'.
	(Expression): Don't implement `EE.IExpression'.

	* classes/ExpressionEvaluator.cs
	(ExpressionParsingException): New public class.
	(EE.IExpression.EvaluateAsync): Moved here from `IEvaluator'.
	(EE.IEvaluator): Removed.

	* classes/DebuggerSession.cs
	(IExpressionParser): Renamed Parse() -> ParseLocation().

	* frontend/CSharpExpressionParser.jay
	(ExpressionParser.Parse): Throw a `ExpressionParsingException' on
	error; redirect error output and include it in the exception.

	* frontend/Makefile.am: Use `$(srcdir)/jay/skeleton.cs' instead of
	`$(srcdir)/skeleton'.

	* frontend/ScriptingContext.cs
	(ScriptingContext.ParseExpression): New public method; use this to
	parse expressions inside the frontend, this throws a
	`ScriptingException' with a user-friendly error message.

2009-06-02  Martin Baulig  <martin@ximian.com>

	Fix #503989.

	* backend/server/x86_64-arch.c
	(x86_arch_child_stopped): Make this work when the NX-flag is
	disabled in the BIOS.

2009-05-28  Martin Baulig  <martin@ximian.com>

	* backend/os/LinuxOperatingSystem.cs
	(LinuxOperatingSystem.CheckForPendingMonoInit): Work around some
	dynamic loader madness; see documentation inside for details.

2009-05-28  Martin Baulig  <martin@ximian.com>

	* backend/ProcessServant.cs
	(ProcessServant.LoadLibrary): Disallow loading unmanaged
	libraries; this never worked since we obviously don't know their
	correct base address.

	* backend/os/OperatingSystemBackend.cs
	(OperatingSystemBackend.AddExecutableFile): Take an `Inferior'
	argument, not `TargetMemoryInfo', so we can do stuff with the
	library; we're called while the target is stopped.

	* backend/os/LinuxOperatingSystem.cs
	(LinuxOperatingSystem.check_loaded_library): New private method;
	moved the nptl_setxid() and mono runtime checks here.
	(LinuxOperatingSystem.AddExecutableFile): Call check_loaded_library(),
	so we check for the mono runtime each time a new shared library is
	loaded, unless we're already running managed.
	(LinuxOperatingSystem.read_dynamic_info): Call check_loaded_library()
	on the main module; this should usually find the mono runtime if
	we're not running embedded.

2009-05-28  Martin Baulig  <martin@ximian.com>

	* backend/ThreadManager.cs
	(ThreadManager.CreateProcess): Merged into StartApplication().
	(ThreadManager.HandleChildEvent): Don't call
	ProcessServant.Initialize() anymore; StartApplication() now takes
	care of that.

	* backend/ProcessServant.cs
	(ProcessServant.WaitForApplication): Removed.
	(ProcessServant.Initialize): Removed.
	(ProcessServant.StartApplication): New public method.

	* backend/SingleSteppingEngine.cs
	(SSE): We now have three methods to start things:
	StartApplication(), StartThread() and StartForkedChild(); each of
	them will start an appropriate operation.
	(SSE.OperationStart.DoExecute): Always run until `inferior.EntryPoint'.
	(SSE.OperationStart.DoProcessEvent): We should now be stopped at
	`inferior.EntryPoint', initialize shared libraries and modules,
	then push `OperationRun'.

	* backend/Inferior.cs
	(Inferior.Run): The target is now stopped when returning from this
	method; merged InitializeProcess() into this method.
	(Inferior.CreateThread): Add `int pid' and `bool do_attach' args.

	* backend/server/x86-ptrace.c
	(server_ptrace_spawn): Call _server_ptrace_wait_for_new_thread()
	to make sure the target is stopped before returning.

	* backend/server/x86-linux-ptrace.c
	(_server_ptrace_wait_for_new_thread): Accept SIGTRAP as well.

2009-05-28  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-linux-ptrace.c
	(_server_ptrace_setup_inferior): Moved call to
	x86_arch_remove_hardware_breakpoints() here.

	* backend/server/x86-ptrace.c
	(server_ptrace_dispatch_event): Don't call
	x86_arch_remove_hardware_breakpoints() when stopping the first time.

2009-05-27  Martin Baulig  <martin@ximian.com>

	* backend/os/bfdglue.c
	(bfd_glue_get_entry_point): New function.

	* backend/os/Bfd.cs
	(Bfd.EntryPoint): Use the executable's entry point from
	bfd_glue_get_entry_point() instead of doing a symbol lookup for
	"main".  The entry point address is stored in the ELF header, so
	this also works on stripped binaries.

	* backend/Inferior.cs
	(Inferior.MainMethodAddress): Renamed into `EntryPoint' to reflect
	the changed semantics.

	* backend/SingleSteppingEngine.cs
	(SSE.OperationStart): Run until the executable's entry point, then
	initialize the shared libraries.

2009-05-27  Martin Baulig  <martin@ximian.com>

	* backend/os/OperatingSystemBackend.cs: New file.
	(OperatingSystemBackend): New internal abstract class.

	* backend/os/LinuxOperatingSystem.cs: New file.
	(LinuxOperatingSystem): Linux implementation.

	* backend/os/Bfd.cs
	(Bfd): Moved the dynlink stuff into `LinuxOperatingSystem'.

	* languages/native/NativeLanguage.cs
	(NativeLanguage): Moved all the symbol file stuff into
	`OperatingSystemBackend'.

	* backend/SingleSteppingEngine.cs
	(SSE.OperationStart): Run until the native "main" method before
	initializing shared libraries.

2009-05-26  Martin Baulig  <martin@ximian.com>

	* languages/native/NativeLanguage.cs
	(NativeLanguage): Replace the indexer with a LookupModule() method.

2009-05-26  Martin Baulig  <martin@ximian.com>

	Moved everything bfd-related from backend/arch to backend/os.

	* backend/arch/bfd/: Moved.
	* backend/arch/opcodes/: Moved.
	* backend/arch/libiberty/: Moved.

	* backend/arch/Bfd.cs: Moved.
	* backend/arch/BfdDisassembler.cs: Moved.
	* backend/arch/DwarfReader.cs: Moved.
	* backend/arch/DwarfFrameReader.cs: Moved.
	* backend/arch/bfdglue.[ch]: Moved.

	* backend/os/bfd/: Moved `opcodes' and `libiberty' inside the
	`bfd' directory and build these libraries here.

2009-05-26  Martin Baulig  <martin@ximian.com>

	* backend/os/NativeExecutableReader.cs: New abstract base class.

	* backend/arch/Bfd.cs (Bfd): Derive from `NativeExecutableReader'.

2009-05-26  Martin Baulig  <martin@ximian.com>

	Merge `BfdContainer' and `NativeLanguage'.

	* backend/arch/BfdContainer.cs: Removed.

	* backend/arch/Bfd.cs: Replaced `BfdContainer' by `NativeLanguage'.

2009-05-25  jonas echterhoff  <jonas@unity3d.com>

	Implement debugger for OS X

	*darwin-ptrace.c: Added for Darwin specific implementation.

	*darwin-thread-db.c: Added for Darwin specific implementation.

	*mach-o.c: Added Apple-specific definitions to supress error messages.

	*Bfd.cs: Changed to interpret Mach-O binaries.

	*i386-arch.c: Added code to make memory executable (needed in OS X).

2009-05-25  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-ptrace.c
	(server_ptrace_sem_*): Moved to x86-linux-ptrace.c.
	(sigint_signal_handler): Call server_ptrace_sem_post() instead of
	using sem_post() directly.

2009-05-25  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-linux-ptrace.c
	(_server_ptrace_make_memory_executable): New static method; this
	is a no-op on Linux.

	* backend/server/i386-arch.c
	(server_ptrace_call_method_*): Call
	_server_ptrace_make_memory_executable(), which is required on OSX.

2009-05-25  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-linux-ptrace.h: Moved function prototypes to
	x86-ptrace.h.	

2009-05-25  Martin Baulig  <martin@ximian.com>

	* backend/server/server.h
	(ServerCapabilities): New public enum.
	(InferiorVTable.get_capabilities): New method.

	* backend/server/library.c
	(mono_debugger_server_get_capabilities): New public function.

	* backend/Inferior.cs
	(Inferior.HasThreadEvents): New public static property.

2009-05-25  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-ptrace.h
	(InferiorHandle): Move struct definition here.
	(OSData): New typedef; moved `mem_fd' here from `InferiorHandle'.

2009-05-19  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs
	(InvocationExpression.DoInvoke): Add
	`RuntimeInvokeFlags.NestedBreakStates'.	

2009-05-19  Martin Baulig  <martin@ximian.com>

	* classes/Thread.cs
	(Thread.AbortInvocation): Added `long rti_id' argument.

	* backend/SingleSteppingEngine.cs
	(SSE.AbortInvocation): Implemented this using `OperationReturn'.

	* classes/TargetException.cs
	(TargetError): Added `NoInvocation'.

2009-05-19  Martin Baulig  <martin@ximian.com>

	* backend/Inferior.cs
	(Inferior.AbortInvoke): Only take `long rti_id' argument; we now
	abort one specific invocation and don't search on the stack.

	* backend/server/server.h
	(InferiorVTable.abort_invoke): Only take a `guint64 rti_id'
	argument, removed the `stack_pointer' and `*aborted_rti' ones.

	* backend/server/x86_64-arch.c
	(server_ptrace_abort_invoke): Only take a `guint64 rti_id'
	argument, removed the `stack_pointer' and `*aborted_rti' ones.

	* backend/server/i386-arch.c
	(server_ptrace_abort_invoke): Only take a `guint64 rti_id'
	argument, removed the `stack_pointer' and `*aborted_rti' ones.

	* backend/SingleSteppingEngine.cs
	(SSE.AbortRuntimeInvoke): Call `inferior.AbortInvoke()'.
	(SSE.Return): Implement `ReturnMode.Invocation'.
	(SSE.OperationReturn): Add support for aborting an entire
	invocation.

	* classes/Backtrace.cs
	(Backtrace.TryCallback): Take a `ref StackFrame last_frame'
	argument to allow the parent function to do some more checks on it
	before adding it.
	(Backtrace.TryUnwind): Improve handling of callback frames; also
	check `until'.

2009-05-18  Martin Baulig  <martin@ximian.com>

	* classes/Thread.cs
	(ReturnMode): New public enum.
	(Thread.Return): Replace the `bool run_finally' with a
	`ReturnMode' argument.

	* backend/SingleSteppingEngine.cs
	(SSE.Return): Start fixing the return mess.

	* classes/TargetException.cs
	(TargetError): Added `InvalidReturn'.

	* frontend/Command.cs
	(ReturnCommand): Add `-native' argument to allow returning from
	native frames while running managed code.

2009-05-14  Martin Baulig  <martin@ximian.com>

	* classes/StackFrame.cs
	(FrameType): New public enum.
	(StackFrame.ctor): Take an additional `FrameType' argument.

	* classes/Backtrace.cs
	(Backtrace.TryCallback): Set `FrameType.Callback' or
	`FrameType.RuntimeInvoke' depending on the callback type.

	* backend/arch/Architecture.cs
	(Architecture.CreateFrame): Take an additional `FrameType' argument.

	* backend/Inferior.cs
	(Inferior.CallbackFrame): New internal class.
	(Inferior.GetCallbackFrame): Return an `Inferior.CallbackFrame'.

	* backend/ThreadServant.cs
	(ThreadServant.GetCallbackFrame): Return an `Inferior.CallbackFrame'.

	* backend/server/server.h
	(CallbackInfo): New typedef.
	(InferiorVTable.get_callback_frame): Replace `guint64 *registers'
	with a `CallbackInfo *info'.
	(mono_debugger_server_get_callback_frame): Likewise.

2009-05-14  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs
	(MonoThreadManager.ThreadCreated): We seem to be creating 3 daemon
	threads again when using the latest runtime from trunk.

2009-05-02  Jonathan Chambers  <joncham@gmail.com>

	* README.win32: Update.

2009-05-02  Jonathan Chambers  <joncham@gmail.com>

	* backend/server/x86-windows.c
	(server_win32_spawn): Add CREATE_UNICODE_ENVIRONMENT flag.
	(server_win32_get_frame): Add.
	(server_win32_initialize_process): Add.

	* backend/server/monodebuggerserver.def: Export
	mono_debugger_server_get_frame and 
	mono_debugger_server_initialize_process.

2009-05-02  Jonathan Chambers  <joncham@gmail.com>

	* backend/Inferior.cs (Run): NULL terminate env
	and args arrays when P/Invoking.

2009-05-02  Jonathan Chambers  <joncham@gmail.com>

	* backend/EventQueue.cs (DebuggerEventQueue): Add timed Wait.

2009-05-02  Martin Baulig  <martin@ximian.com>

	Don't step into any signal handlers during source-level stepping.

	* backend/server/library.c
	(mono_debugger_server_get_pending_signal): New public function.

	* backend/server/server.h
	(InferiorVTable): Added `get_pending_signal'.

	* backend/Inferior.cs
	(Inferior.GetPendingSignal): New public method.

	* backend/SingleSteppingEngine.cs
	(SSE.do_next_native): Renamed into `do_next'.
	(SSE.do_step): New function; same as do_step_native(), but don't
	step into any signal handlers.
	(SSE.OperationStep): Use do_step() instead of do_step_native(),
	except when doing single-instruction stepping, don't step into any
	signal handlers when doing source-level stepping.

2009-05-03  Martin Baulig  <martin@ximian.com>

	* configure.in: Drop support for older nunit's.

2009-04-30  Martin Baulig  <martin@ximian.com>

	* classes/Breakpoint.cs
	(Breakpoint.OnResolveFailed): New protected internal method.

	* backend/SingleSteppingEngine.cs
	(SSE.ActivatePendingBreakpoint): Call Breakpoint.OnResolveFailed(),
	not OnBreakpointError() if we got a `TargetError.LocationInvalid'.

2009-04-30  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.create_appdomain): Make this work on i386.

2009-04-30  Martin Baulig  <martin@ximian.com>

	Merge status as of April 29th:

	- merged until 133023.

	- reverted revisions:
	128557, 128559, 132026, 132028, 132029, 132584, 132586.

	- broken revisions: 132585.

	- jchambers changes which will not be merged:
	129763, 129857, 131778, 131779, 132539, 132651, 132674,
	132697, 132803.

	- monodis and lesspipe have not yet been merged:
	130986, 130987, 130988, 130989, 131093.

	- experimental code which will not be merged:
	132841, 132843

2009-04-29  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoLineNumberTable.Lookup): If the symbol file doesn't contain
	any source ranges for the current method, default to traditional
	line-based lookup.

2009-04-29  Martin Baulig  <martin@ximian.com>

	* backend/BreakpointHandle.cs (FunctionBreakpointHandle): Fix a
	regression introduced in r132009.

2009-04-27  Jonathan Chambers  <joncham@gmail.com>

	* build/debugger.sln: Turn on monodebuggerserver project
	in AnyCPU target.

	* build/monodebuggerserver.vcproj: Copy glib dependencies
	to output directory.

2009-04-26  Jonathan Chambers  <joncham@gmail.com>

	* build/debugger.sln: Build as 32-bit for now.

	* build/Mono.Debugger.csproj: Build as 32-bit for now.

	* build/Mono.Debugger.SymbolWriter.csproj: Build as 32-bit for now.

	* build/mdb.csproj: Build as 32-bit for now.

	* build/Mono.Debugger.Frontend.csproj: Build as 32-bit for now.

2009-04-25  Jonathan Chambers  <joncham@gmail.com>

	* README.win32: Added.

2009-04-25  Jonathan Chambers  <joncham@gmail.com>

	* frontend/CSharpExpressionParser.cs.win: Update file.

	* build/Mono.Debugger.csproj: Add reference to Mono.GetOptions.

	* build/AssemblyInfo.cs.win: Add generated file.

	* build/Mono.Debugger.SymbolWriter.csproj: Add DEBUGGER_SOURCE
	definition. Add reference to Mono.GetOptions. Add prebuild step
	for AssemblyInfo.cs.win to AssemblyInfo.cs.

2009-04-24  Jonathan Chambers  <joncham@gmail.com>

	* configure.in: Add debug output to figure out why nunit
	fails to run on buildbots.

2009-04-23  Jonathan Chambers  <joncham@gmail.com>

	* backend/server/breakpoints.c: Add HAVE_UNISTD_H #ifdef.

	* backend/server/library.c: Add HAVE_UNISTD_H check and add Windows
	InferiorVTable.
	(mono_debugger_server_create_inferior): Access through vtable.
	(mono_debugger_server_get_current_pid): Access through vtable.
	(mono_debugger_server_get_current_thread): Access through vtable.
	(mono_debugger_server_static_init): Access through vtable.
	(mono_debugger_server_get_pending_sigint): Access through vtable.
	(mono_debugger_server_sem_init): Access through vtable.
	(mono_debugger_server_sem_wait): Access through vtable.
	(mono_debugger_server_sem_post): Access through vtable.
	(mono_debugger_server_sem_get_value): Access through vtable.

	* backend/server/monodebuggerserver.def: Add.

	* backend/server/mutex.c: Add mono_debugger_cond_timed_wait.

	* backend/server/server.h: Add declarations for vtable changes above.

	* backend/server/x86-ptrace.c: Implement vtable functions formerly in
	library.c.

	* backend/server/x86-windows.c: Added.

	* build/debugger.sln: Added.

	* build/mdb.csproj: Added.

	* build/Mono.Debugger.csproj: Added.

	* build/Mono.Debugger.Frontend.csproj: Added.

	* build/Mono.Debugger.SymbolWriter.csproj: Added.

	* build/monodebuggerserver.vcproj: Added.

2009-04-28  Martin Baulig  <martin@ximian.com>

	* build/ulimit-check.c: New helper program to check `ulimit -v';
	we'll add more checks to it later.

	* build/runtests.in: Refuse the run the tests if `ulimit-check' fails.

2009-04-17  Martin Baulig  <martin@ximian.com>

	* classes/LineNumberTable.cs
	(LineNumberTable.Lookup): Add overloaded virtual version taking a
	`column' argument.

	* classes/SourceLocation.cs
	(SourceLocation.Column): New public readonly field.
	(SourceLocation.ctor): Add overloaded versions taking a `column' arg.

	* backend/BreakpointHandle.cs
	(FunctionBreakpointHandle): Add `column' field.	

2009-04-16  Martin Baulig  <martin@ximian.com>

	Add support for 'source ranges' - instead of only using line
	numbers, we now use a struct containing 'StartLine', 'EndLine',
	'StartColumn' and 'EndColumn'.

	* classes/Method.cs
	(LineEntry.SourceRange): New public field.

	* classes/SourceAddress.cs
	(SourceAddress.HasSourceRange): New public property.
	(SourceAddress.SourceRange): New public property.
	(SourceRange): New public struct.

2009-04-15  Martin Baulig  <martin@ximian.com>

	* classes/SourceAddress.cs
	(SourceAddress): Rename `SourceOffset' -> `LineOffset' and
	`SourceRange' -> `LineRange'.

2009-04-15  Jonathan Chambers  <joncham@gmail.com>

	* backend/arch/Architecture.cs: Use Disassembler instead of BfdDisassembler
	and only create on non-Windows platforms.

	* backend/arch/BfdDisasembler.cs: Override Dispose since base now implements.

	* backend/arch/Disasembler.cs: Derive from IDisposable.

	* backend/arch/X86_Opcodes.cs: Use Disassembler instead of BfdDisassembler
	and only create on non-Windows platforms.

	* backend/Inferior.cs
	(IsRunningOnWindows): Add.
	(mono_debugger_server_get_application): Change out string to out IntPtr.
	(GetApplication): Marshal strings manually since on Windows they are freed
	via CoTaskMemFree instead of g_free.

2009-04-15  Jonathan Chambers  <joncham@gmail.com>

	* frontend/CSharpExpressionParser.cs.win: Add generated files for
	Windows to build easily in Visual Studio.

2009-04-15  Jonathan Chambers  <joncham@gmail.com>

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration): Use Environment.SpecialFolder.Personal
	instead of HOME environment variable.
	(LoadConfigurationFromStream): Verify file exists before trying to access it.

2009-04-15  Jonathan Chambers  <joncham@gmail.com>

	* frontend/Style.cs: Add braces to work around bug 478101.

	* languages/mono/MonoLanguageBackend.cs: Add braces to work around bug 478101.

2009-04-15  Martin Baulig  <martin@ximian.com>

	* symbolwriter/MonoSymbolTable.cs
	(LineNumberTable.DW_LNE_MONO__extensions_start): New const.
	(LineNumberTable.DW_LNE_MONO__extensions_end): New const.
	(LineNumberTable.DoRead): Ignore unknown extended opcodes if
	they're within the Mono extension range.

2009-04-14  Martin Baulig  <martin@ximian.com>

	* symbolwriter/ndesk-options.cs: New file; copied
	src/NDesk.Options/NDesk.Options/Options.cs from NDesk.Options.

	* symbolwriter/MdbSymbolReader.cs: Some more work on printing the
	contents of a symbol file instead of just verifying it.

	* build/mdb-symbolreader.in: New file; create a `mdb-symbolreader'
	wrapper script.

2009-04-06  Martin Baulig  <martin@ximian.com>

	* test/testsuite/NUnit.cs
	(TestSuite.ctor): Set `config.RedirectOutput' since we're
	examining it in the tests.

2009-04-06  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.ActivatePendingBreakpoint): Don't use Report.Error() to
	report breakpoint failures; `breakpoint.OnBreakpointError()' is
	all we need.

2009-04-03  Martin Baulig  <martin@ximian.com>

	* classes/LineNumberTable.cs
	(LineNumberTable.DumpLineNumbers): Added `TextWriter' argument.

2009-04-03  Martin Baulig  <martin@ximian.com>

	* classes/Utils.cs: New file.
	(LessPipe): New public class; derives from `TextWriter' and opens
	a pipe to `less'.

2009-04-03  Martin Baulig  <martin@ximian.com>

	Add `less' command to view a file with `less'.

	* frontend/Command.cs
	(LessCommand): New command to view a file.

	* classes/ThreadManager.cs: Ignore exit events from unknown
	children.	

2009-04-03  Martin Baulig  <martin@ximian.com>

	* configure.in: Check for monodis and AC_SUBST() `MONODIS' and
	`TARGET_MONODIS'.	

	* build/AssemblyInfo.cs.in
	(BuildInfo.monodis): New public static field.

2009-04-03  Martin Baulig  <martin@ximian.com>

	* configure.in: Kill the old pre-historic `server_only'.

2009-03-31  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs
	(NotificationType): Added `CreateAppDomain' and `UnloadAppDomain'.

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend): Make things work with shadow copied assemblies.
	(MonoLanguageBackend.GetShadowCopyLocation): New internal method.
	(MonoLanguageBackend.Notification): Add support for
	`CreateAppDomain' and `UnloadAppDomain'.

	* languages/mono/MonoRuntime.cs
	(MonoRuntime.GetAppDomainInfo): New public method.

2009-03-30  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerSession.AddUserModulePath): New public method.
	(DebuggerSession.CreateModule): Also check whether the module is
	located anywhere in the module paths.

2009-03-27  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-ptrace.c
	(server_ptrace_kill): Do a `kill (SIGKILL)' in addition to the
	`ptrace (PTRACE_KILL)'.

2009-03-24  Martin Baulig  <martin@ximian.com>

	* classes/Event.cs
	(Event.IsUserModule): New public property.

	* backend/SingleSteppingEngine.cs
	(SSE.ActivatePendingBreakpoints): When called during a
	module-load, only activate user-breakpoints if we're actually a
	user module.

2009-03-23  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration.CreateDefaultModuleGroups): Add new module
	group `user' for user code.

	* classes/DebuggerSession.cs
	(DebuggerSession.AddUserModule): New public method.
	(DebuggerSession.CreateModule): If the module's file name matches
	any of the user modules, use the `user' module group.

	* classes/Module.cs
	(SymbolFile.CodeBase): New abstract property; this is the absolute
	path name of the loaded module.

2009-03-20  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration.RedirectOutput): New configuration option.

	* classes/DebuggerOptions.cs
	(DebuggerOptions.RedirectOutput): Removed.
	(DebuggerOptions.ParseCommandLine): Removed `-no-redirect' command
	line argument; this is now a configuration option.

2009-03-19  Jonathan Chambers  <joncham@gmail.com>

	* frontend/Completer.cs: Switch from using GnuReadLine to LineReader.
	
	* frontend/GnuReadLine.cs: Make methods non-static. Now accessed via LineReader.
	
	* frontend/LineReader.cs: Added. Handles both GnuReadLine and ManagedReadLine.
	
	* frontend/Main.cs: Switch from using GnuReadLine to LineReader.
	
	* frontend/ManagedReadLine.cs: Beginning of managed ReadLine implementation.
	
	* classes/DebuggerOptions.cs: Add #if HAVE_XSP around xsp specific
	code.
	Fixes build.

	* build/Makefile.am: Add LineReader.cs and ManagedReadLine.cs.

2009-03-19  Jonathan Chambers  <joncham@gmail.com>

	* backend/server/i386-arch.h: Wrap include with #ifdef HAVE_SYS_USER_H
	
	* backend/server/x86-ptrace.c: Include config.h.

	* configure.in: Add check for sys/user.h.

	* winconfig.h: Added. Used to generate config.h on Windows.

2009-03-19  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerOptions.cs
	(DebuggerOptions.RedirectOutput): New public property.
	(DebuggerOptions.ParseCommandLine): Added `-no-redirect' command
	line argument to prevent redirecting stdin and stdout.

	* backend/ProcessStart.cs
	(ProcessStart.RedirectOutput): New public property.

	* backend/server/x86-ptrace.c
	(mono_debugger_server_spawn): Added `gboolean redirect_fds'.

2009-03-05  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile.GetMethod): Also search in all include files.

2009-03-09  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerSession.InsertExceptionCatchPoint): Add
	compatibility overload.

	* classes/Thread.cs
	(Thread.RuntimeInvoke): Add compatibility overload.

2009-02-28  Martin Baulig  <martin@ximian.com>

	* backend/arch/BfdContainer.cs
	(BfdContainer.GetSectionAddress): New public method.

	* backend/ProcessServant.cs
	(ProcessServant.get_thread_info): Silently fail if we're not a
	managed application.

2009-03-04  Martin Baulig  <martin@ximian.com>

	Implemented nested break states.

	* backend/SingleSteppingEngine.cs
	(SSE.ProcessChildEvent): Largely rework this to support nested
	break states.
	(SSE.Operation.EventResult): Added `SuspendOperation'.
	(SSE.Operation.CompletedOperation): New public virtual method.
	Compute the new stack frame here and also check for method operations.
	(SSE.InterruptibleOperation): New public abstract base class for
	operations which may be suspended in a nested break state.
	(SSE.OperationRuntimeInvoke): Derive from `InterruptibleOperation'.
	Moved all the low-level callbacks into a new private helper
	operation `OperationRuntimeInvokeHelper'.
	(SSE.OperationException): Return `EventResult.SuspendOperation' on
	completion to allow entering a nested break state; CompletedOperation()
	will check whether we may actually do that and fall back to a
	normal completion otherwise.

	* classes/Debugger.cs
	(Debugger.EnterNestedBreakStateEvent): New public event.
	(Debugger.LeaveNestedBreakStateEvent): New public event.

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration.NestedBreakStates): New configuration option.

	* classes/ExpressionEvaluator.cs
	(EE.EvaluationFlags): New public enum.
	(EE.IExpression): New public interface.
	(EE.IEvaluator): New public interface.
	(EE.EvaluationCallback): New public delegate.
	(EE.MonoObjectToString): Add `EvaluationFlags' argument.
	(EE.GetProperty): Add `EvaluationFlags' argument.

	* classes/TargetEvent.cs
	(TargetEventType): Added `RuntimeInvokeDone'.  This is only sent
	if explicitly requested via `RuntimeInvokeFlags.SendEventOnCompletion'.

	* classes/Thread.cs
	(RuntimeInvokeFlags): New public enum.
	(Thread.RuntimeInvoke): Replaced `is_virtual' and `debug' by
	`RuntimeInvokeFlags flags'.

	* frontend/Main.cs: Reworked the main loop to support nested break
	states.

	* frontend/Command.cs
	(PrintExpressionCommand): Add `-nested-break' argument.

	* backend/Inferior.cs
	(Inferior.AbortInvoke): Added `out long aborted_rti' argument.

	* backend/server/x86-ptrace.c
	(server_ptrace_abort_invoke): Added `guint64 *aborted_rti'.

2009-03-02  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(CatchCommand): Added `-unhandled' argument to only catch
	user-unhandled exceptions.

	* frontend/Interpreter.cs
	(Interpreter.InsertExceptionCatchPoint): Added `bool unhandled'.

	* classes/DebuggerSession.cs
	(DebuggerSession.InsertExceptionCatchPoint): Added `bool
	unhandled'.

	* classes/ExceptionCatchPoint.cs
	(ExceptionCatchPoint.Unhandled): New public property.

	* backend/SingleSteppingEngine.cs: Improve exception handling.

2009-03-04  Martin Baulig  <martin@ximian.com>

	* test/testsuite/testnativefork.cs: Add `[Category ("NotWorking")]'.

2009-03-03  Martin Baulig  <martin@ximian.com>

	* test/testsuite/NUnit.cs
	(NUnitInterpreter.IgnoreThreadCreation): New public property to
	disable tracking of child threads.

	* test/testsuite/TestAppDomain.cs: Use it here.
	* test/testsuite/TestAppDomain-Module.cs: And here.

2009-03-02  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoRuntime.cs
	(MonoRuntime.GetGenericClass): Reflect latest runtime changes:
	starting with version 81.0, `MonoGenericInst.type_argv' is a tail
	array and not a pointer anymore.  Check for the runtime version
	and support both versions here.

2009-03-02  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs
	(MonoDebuggerInfo): Accept runtime major versions 80 and 81.
	(MonoDebuggerInfo.MinorVersion): New public readonly field.
	(MonoDebuggerInfo.MajorVersion): New public readonly field.

2009-02-25  Martin Baulig  <martin@ximian.com>

	* backend/arch/X86_Instruction.cs
	(X86_Instruction.DecodeModRM): Correctly identify ip-relative
	addressing.

2009-02-09  Martin Baulig  <martin@ximian.com>

	* classes/Process.cs
	(ExceptionCatchPointHandler): New public delegate.
	(Process.InstallGenericExceptionCatchPoint): New public method.
	(Process.GenericExceptionCatchPoint): New public method.

	* backend/SingleSteppingEngine.cs
	(SSE.OperationException.DoProcessEvent): Create
	`TargetEventArgs(TargetEventType.Exception)' with the exception
	object as `TargetClassObject'.

2009-02-09  Martin Baulig  <martin@ximian.com>

	Fix #466012 and #423518.

	* backend/server/x86-linux-ptrace.c
	(_server_ptrace_wait_for_new_thread): New static function.  Wait
	for a newly created thread to stop.

	* backend/SingleSteppingEngine.cs
	(SSE.StartThread): Added `do_execute' argument and resume the
	target when it's true.
	(SSE.OperationInitAfterFork.DoExecute): Call `sse.do_continue ()'.

	* backend/ProcessServant.cs
	(ProcessServant.ThreadCreated): If `do_attach' is false, then the
	newly created thread has already stopped, so we tell the SSE to
	resume it.

	* backend/ThreadManager.cs
	(ThreadManager.wait_thread_main): Ignore `SIGSTOP' events for
	unknown threads.

2009-01-28  Martin Baulig  <martin@ximian.com>

	* frontend/ScriptingContext.cs
	(ScriptingContext.HandleDebuggerDisplay): Make this method static.
	(ScriptingContext.CheckTypeProxy): New public static method.

2009-01-28  Martin Baulig  <martin@ximian.com>

	* language/TargetStructType.cs
	(TargetStructType.ForceClassInitialization): New public method.

	* frontend/Expression.cs
	(StructAccessExpression.ResolveClass): Force a class init here.
	[The user wants something from this class, so it should be ok to
	initialize it.]

	* frontend/ScriptingContext.cs
	(ScriptingContext.GetNamespaces): If we have an `ImplicitInstance',
	only check the direct namespaces from the class name, not any
	using statements etc.

2009-01-27  Martin Baulig  <martin@ximian.com>

	* frontend/ScriptingContext.cs
	(ScriptingContext.HandleDebuggerDisplay): Improve API: take a
	`DebuggerDisplayAttribute' parameter and return both the value and
	the type.

2009-01-26  Martin Baulig  <martin@ximian.com>

	Add support for the [DebuggerTypeProxy] attribute.

	* languages/TargetStructType.cs
	(TargetStructType.DebuggerTypeProxyAttribute): New public
	property.

	* frontend/Expression.cs
	(TypeProxyExpression): New internal class.  This is used to
	evaluate a [DebuggerTypeProxy] attribute.

	* classes/ScriptingContext.cs
	(ScriptingContext.DoFormatObject): Check for [DebuggerTypeProxy].	

2009-01-26  Martin Baulig  <martin@ximian.com>

	Add support for the [DebuggerDisplay] attribute.

	* languages/TargetMember.cs
	(TargetMemberInfo.DebuggerDisplayAttribute): New public property.

	* languages/TargetStructType.cs
	(TargetStructType.DebuggerDisplayAttribute): New public property.

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile.CheckCustomAttributes): New internal method.

	* classes/MethodSource.cs
	(MethodSource.GetNamespaces): New public abstract method.

	* classes/ExpressionEvaluator.cs
	(ExpressionEvaluator.EvaluationResult): Added `InvalidExpression'.

	* frontend/ScriptingContext.cs
	(ScriptingContext.GetNamespaces): Removed the overloaded version
	with a `StackFrame' argument; only keep the parameterless one.
	(ScriptingContext.CurrentLanguage): Make this work without a frame.
	(ScriptingContext.ImplicitInstance): New public property; this can
	be used in expression contexts to implicitly set the `this'.
	(ScriptingContext.HandleDebuggerDisplay): New private method.
	(ScriptingContext.MonoObjectToString): Call
	HandleDebuggerDisplay() to check for the [DebuggerDisplay]
	attribute.

2009-01-21  Martin Baulig  <martin@ximian.com>

	Add support for the [DebuggerBrowsable] attribute.

	* languages/TargetMember.cs
	(TargetMemberInfo.DebuggerBrowsableState): New public property.

2009-01-21  Martin Baulig  <martin@ximian.com>

	Add support for nullable types.

	* languages/TargetNullableType.cs: New file.
	(TargetNullableType): New public abstract class.

	* languages/TargetNullableObject.cs: New file.
	(TargetNullableObject): New public abstract class.

	* languages/mono/MonoNullableType.cs: New file.
	* languages/mono/MonoNullableObject.cs: New file.

	* languages/TargetObjectKind.cs
	(TargetObjectKind): Added `Decimal'.

	* frontend/Expression.cs
	(Convert.ImplicitConversion): Add nullable conversions.
	(StructAccessExpression.DoAssign): Use
	Convert.ImplicitConversionRequired() rather than requiring the
	types to be identical.

2009-01-21  Martin Baulig  <martin@ximian.com>

	Add support for decimal.

	* languages/TargetFundamentalType.cs
	(FundamentalKind): Added `Decimal'.

	* languages/mono/MonoLanguageBackend.cs
	(MonoBuiltinTypeInfo): Added `DecimalType'.

2009-01-19  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoVariable.cs
	(MonoVariable.IsInScope): Don't check for `AddressMode.Dead' here.
	(MonoVariable.IsAlive): Also check for IsInScope() here.

	* languages/mono/MonoClassInfo.cs
	(MonoClassInfo.GetField): Return a `MonoNullObject' instead of `null'
	when the location is invalid.

	* frontend/ObjectFormatter.cs
	(ObjectFormatter.FormatVariable): Properly handle variables which
	have been optimized out.

2009-01-15  Martin Baulig  <martin@ximian.com>

	* backend/server/x86_64-arch.c
	(x86_arch_child_stopped): Fix the regression from r120992 (Dec 8th):
	Check for callbacks first because we expect to receive a SIGSEGV
	on the non-executable stack.

2009-01-15  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerOptions.cs
	(DebuggerOptions.ParseOption): Provide more meaningful error
	message if unknown `-debug-flags' arguments were given.

2009-01-08  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(BreakCommand.DoResolve): Don't allow any line-only breakpoints
	before target has been started.

2008-12-12  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs (Interpreter.WaitAll): Reset
	`seen_threads' and `wait_list' after receiving a process event; a
	process may have exited.

2008-12-12  Martin Baulig  <martin@ximian.com>

	* backend/EventQueue.cs (DebuggerWaitHandle): Implement
	IDisposable and free unmanaged resources.

	* backend/server/mutex.c
	(mono_debugger_mutex_free): New function.
	(mono_debugger_cond_free): New function.

2008-12-09  Martin Baulig  <martin@ximian.com>

	* languages/native/NativeLanguage.cs
	(NativeLanguage.CreateInstance): Add support for some very basic types.

2008-12-08  Martin Baulig  <martin@ximian.com>

	* backend/server/i386-arch.c (x86_arch_child_stopped): Send
	`STOP_ACTION_STOPPED' without checking for breakpoint if we didn't
	receive a SIGTRAP.

	* backend/server/x86_64-arch.c (x86_arch_child_stopped): Likewise.

2008-12-06  Martin Baulig  <martin@ximian.com>

	* mono-debugger-frontend.pc.in: New file.

	* configure.in: Create `mono-debugger-frontend.pc' for Visual Studio.

2008-12-03  Martin Baulig  <martin@ximian.com>

	* classes/ExpressionEvaluator.cs: Add some more error checking.

2008-12-02  Martin Baulig  <martin@ximian.com>

	* test/testsuite/*.cs: If there is more than one test in one file,
	NUnit 2.3 may run them in any random order.

	* backend/BreakpointManager.cs
	(BreakpointManager.InitializeAfterFork): Remove all non-global
	breakpoint, but don't force them to be `SourceBreakpoint's.

2008-12-02  Martin Baulig  <martin@ximian.com>

	* configure.in: Check which NUnit version we're using.

	* build/Makefile.am: Add support for NUnit 2.3.

2008-11-26  Martin Baulig  <martin@ximian.com>

	* languages/TargetMember.cs
	(TargetFieldInfo.IsCompilerGenerated): New public property.

	* frontend/ObjectFormatter.cs
	(ObjectFormatter.FormatClassObject): Skip compiler-generated
	fields.	

2008-11-26  Martin Baulig  <martin@ximian.com>

	* classes/ExpressionEvaluator.cs
	(ExpressionEvaluator.MonoObjectToString): Return the `raw'
	returned string rather than pretty formatting it.

	* frontend/ScriptingContext.cs
	(ScriptingContext.MonoObjectToString): Do that here.

2008-11-26  Martin Baulig  <martin@ximian.com>

	* classes/ExpressionEvaluator.cs
	(ExpressionEvaluator.GetProperty): New public method.

	* classes/GUIManager.cs
	(GUIManager.GetProperty): New public method.

2008-11-22  Martin Baulig  <martin@ximian.com>

	* backend/server/server.h
	(SignalInfo): Add `sigfpe', `sigquit', `sigabrt', `sigsegv',
	`sigill' and `sigbus'.

	* backend/Inferior.cs
	(Inferior.IsManagedSignal): New public method.

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration.StopOnManagedSignals): New configuration
	option.

	* backend/MonoThreadManager.cs
	(MonoThreadManager.HandleChildEvent): Add support for it here.

	* classes/GUIManager.cs
	(GUIManager.StartGUIManager): Set `StopOnManagedSignals' to false.

2008-11-19  Martin Baulig  <martin@ximian.com>

	* interface/Report.cs
	(DebugFlags.GUI): Add new debug flags.

	* classes/ExpressionEvaluator.cs
	(ExpressionEvaluator.MonoObjectToString): Abort the invocation if
	we stop unexpectedly.

	* classes/GUIManager.cs
	(GUIManager.MonoObjectToString): New public method; call
	ExpressionEvaluator.MonoObjectToString() and suppress sending any
	events if we stop unexpectedly.

2008-11-17  Martin Baulig  <martin@ximian.com>

	* classes/ExpressionEvaluator.cs: New file.
	(ExpressionEvaluator): New public static class.
	(ExpressionEvaluator.MonoObjectToString): Moved here from
	../frontend/Expression.cs.

	* frontend/Expression.cs
	(ExpressionParser.MonoObjectToString): Moved to
	../classes/ExpressionEvaluator.cs	

2008-11-17  Martin Baulig  <martin@ximian.com>

	Released version 2.2 "Sidney" of the Mono Debugger.

	* NEWS: Update to 2.2.

	* configure.in: Bump version number to 2.2.

2008-11-17  Martin Baulig  <martin@ximian.com>

	* configure.in: Add -fno-strict-aliasing to CFLAGS.

2008-11-11  Martin Baulig  <martin@ximian.com>

	* test/testsuite/NUnit.cs
	(TestSuite.EvaluateExpression): New public method.

	* frontend/Expression.cs
	(ExpressionParser.EvaluationResult): New public enum.
	(ExpressionParser.MonoObjectToString): New public method.

	* test/{src|testsuite}/TestToString2.cs: New tests.

2008-11-10  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture.cs
	(Architecture.GetLMF): Added `ref TargetAddress lmf_address'
	argument; return the address of the next LMF.

	* classes/Backtrace.cs
	(Backtrace.TryLMF): Allow multiple LMF frames.

2008-11-08  Martin Baulig  <martin@ximian.com>

	* interface/Report.cs
	(ReportWriter.ctor): Only use `MDB_DEBUG_FLAGS' and parse it like
	the `-debug-flags' command line argument; kill `MDB_DEBUG_OUTPUT'.

2008-11-08  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.ManagedCallback): Insert a breakpoint on the last managed
	frame to fix a race condition - see the comments in the source code.

2008-11-06  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture.cs
	(Architecture.AdjustReturnAddress): Removed.  This was a big hack
	and there was no guarantee that the "adjusted" return address was
	actually correct.
	(Architecture.CreateFrame): Removed the `adjust_retaddr' argument.

2008-11-06  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture_X86_64.cs
	(Architecture_X86_64.GetLMF): Fixed.

	* classes/Backtrace.cs
	(Backtrace.TryUnwind): Only check the LMF once.

2008-11-01  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoPointerType.cs: Use `*', not '&' (ie. `int*').

2008-10-28  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoVariable.cs
	(MonoVariable.IsAlive): Check `AddressMode.Dead'.
	(MonoVariable.IsInScope): Likewise.

2008-10-25  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoPointerObject.cs
	(MonoPointerObject.GetDereferencedObject): Dereference the
	location if the static type is a TargetPointerType.  This fixes
	pointer-to-pointer (`int** a', for instance).

2008-10-25  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(VariableInfo.AddressMode): Add `Dead'.	

2008-10-24  Martin Baulig  <martin@ximian.com>

	Fixes the XSP-issue in #423518.

	* backend/server/x86-linux-ptrace.c
	(server_ptrace_detach_after_fork): Use a non-blocking wait to make
	things work in case we already received the SIGSTOP before.

	* test/testsuite/TestDontFollowFork.cs: New test.

2008-10-23  Martin Baulig  <martin@ximian.com>

	* interface/Report.cs
	(Report.ParseDebugFlags): New public static method; parse the
	debug flags both as integers and as strings.

	* classes/DebuggerOptions.cs
	(DebuggerOptions.ParseDebugFlags): Call Report.ParseDebugFlags()
	to parse the debug flags; we can now also specify debug flags as a
	comma separated list of strings.

2008-10-23  Martin Baulig  <martin@ximian.com>

	Bug #423518.

	There is a race condition in the Linux kernel which shows up on >= 2.6.27:

	When creating a new thread, the initial stopping event of that thread is sometimes
	sent before sending the `PTRACE_EVENT_CLONE' for it.

	* backend/server/library.c
	(mono_debugger_server_dispatch_simple): New public function.  This
	function is safe to be called from any thread and only decodes the
	event into the basic stopped / signaled / exited etc.

	* backend/ThreadManager.cs: Queue stopping events from unknown
	threads for 200 seconds to work around the race condition.

2008-10-20  Martin Baulig  <martin@ximian.com>

	Applying a patch from Cedric Vivier <cedricv@neonux.com>

	* classes/Method.cs
	(Method.IsInvokeWrapper): New internal property.

	* backend/SingleSteppingEngine.cs
	(SSE.OperationStep): Enable stepping into method from objects
	deriving from MarshalByRefObject.

	* test/{testsuite|src}/TestSSE.cs: Added testcase.

2008-10-20  Martin Baulig  <martin@ximian.com>

	* interface/Report.cs: Include timestamps when writing to a file.

2008-10-19  Martin Baulig  <martin@ximian.com>

	* test/src/TestManagedTypes.cs
	(SimpleTypes): Move this into a separate class and use static
	variables, so the JIT can't optimize them away.

2008-10-19  Martin Baulig  <martin@ximian.com>

	* build/Makefile.am: Small fix from Ian Greenhoe; bug #431771.

2008-10-17  Cedric Vivier  <cedricv@neonux.com>

	* backend/SingleSteppingEngine.cs
	Enable StepInto for RemotingInvoke-wrapped methods.
	* classes/Method.cs
	(Method.IsInvokeWrapper): New public property.

2008-10-13  Martin Baulig  <martin@ximian.com>

	* classes/StackFrame.cs
	(Registers.ImportantRegisters): New public property.

2008-09-15  Martin Baulig  <martin@ximian.com>

	* languages/TargetObjectKind.cs (TargetObjectKind): Add `Null'.

	* languages/TargetObject.cs
	(TargetObject.Kind): Make this virtual.

	* languages/mono/MonoNullObject.cs
	(MonoNullObject.Kind): Override and return `TargetObjectKind.Null'.

2008-09-15  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoRuntime.cs
	(MonoRuntime.MonoArrayTypeGetBounds): New internal method; check
	whether the lower bounds are all zero.

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.ReadType): Call it here, only throw an
	exception if we have upper bounds or some of the lower bounds are
	non-zero.

2008-09-04  Martin Baulig  <martin@ximian.com>

	* classes/GUIManager.cs
	(GUIManager.ProcessExitedEvent): New public event.

	* classes/Process.cs
	(Process.Lookup): New public method to lookup a `Method' from a
	`TargetAddress'.	

2008-08-21  Martin Baulig  <martin@ximian.com>

	* classes/GUIManager.cs
	(GUIManager.Stop): New public method to stop a thread.

2008-08-21  Martin Baulig  <martin@ximian.com>

	* classes/GUIManager.cs
	(GUIManager.OnTargetEvent): Ignore `TargetInterrupted' if we are
	already in break mode; auto-stop on `Exception' and
	`UnhandledException'.

2008-08-19  Martin Baulig  <martin@ximian.com>

	Fix a race condition: correctly block until
	`ActivatePendingBreakpoints' has actually been completed.

	* classes/Process.cs
	(Process.ActivatePendingBreakpoints): Wait until the command has
	been completed.

	* backend/ProcessServant.cs
	(ProcessServant.ActivatePendingBreakpoints): Take a
	`CommandResult' argument, so we can block on the operation.

	* backend/SingleSteppingEngine.cs
	(SSE.ManagedCallback): Take an additional `CommandResult' argument.
	(SSE.OperationManagedCallback): Correctly implement multiple
	callbacks; each callback now also have a CommandResult which we need
	to set to completed when done.

2008-08-19  Martin Baulig  <martin@ximian.com>

	* backend/ThreadManager.cs: Fixed a hard to find race condition.

2008-08-14  Martin Baulig  <martin@ximian.com>

	* symbolwriter/MdbSymbolReader.cs: Add `-verbose' command line
	argument and improve the scope variables check.

2008-08-14  Martin Baulig  <martin@ximian.com>

	* build/Makefile.am
	(verify-local): New target.  Run the symfile verifier here.
	(check-local): Run `verify-local'.

2008-08-14  Martin Baulig  <martin@ximian.com>

	* test/{src|testsuite}/TestActivateBreakpoints2.cs: New test.

2008-08-14  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-ptrace.c
	(server_ptrace_resume): New method; use this after receiving a
	`STOP_ACTION_INTERRUPTED' to resume the previously running
	stepi/continue.

	* backend/server/library.c
	(mono_debugger_server_resume): New public method.

	* backend/Inferior.cs
	(Inferior.Resume): New public method.

	* backend/SingleSteppingEngine.cs
	(SSE.ReleaseThreadLock): Call `inferior.Resume()' if we received a
	`ChildEventType.CHILD_INTERRUPTED'.  This fixes a race condition,
	if we are executing a OperationExecuteInstruction, for instance.

2008-08-13  Martin Baulig  <martin@ximian.com>

	* test/testsuite/TestAttach.cs
	(TestAttach.TearDown): Call `child.WaitForExit()' here since
	TestAttach.Kill() may not be run if the test is disabled.

	* test/testsuite/testnativeattach.cs
	(testnativeattach.TearDown): Call `child.WaitForExit()' here since
	testnativeattach.Kill() may not be run if the test is disabled.

2008-08-12  Martin Baulig  <martin@ximian.com>

	* test/{src|testsuite}/TestActivateBreakpoints.cs: New test.

2008-08-11  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(BreakCommand): Add `-gui' option to allow inserting breakpoints
	while the target is running.

2008-08-11  Martin Baulig  <martin@ximian.com>

	* classes/Process.cs
	(Process.ActivatePendingBreakpoints): New public method.

	* backend/SingleSteppingEngine.cs
	(SSE.OnModuleLoaded): Moved functionality into
	ActivatePendingBreakpoints().
	(SSE.ActivatePendingBreakpoints): New internal method.
	(SSE.OperationInsertBreakpoint): Check the return value from the
	runtime and pass it to mono.RegisterMethodLoadHandler().

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.RegisterMethodLoadHandler): When called from
	the SSE, we now take an additional `TargetAddress argument' which
	is the return value from the runtime; call method_from_jit_info()
	if necessary.

	* backend/ProcessServant.cs
	(ProcessServant.ActivatePendingBreakpoints): New method.

2008-08-11  Martin Baulig  <martin@ximian.com>

	* test/testsuite/testnativefork.cs: Override debugger config; this
	test needs "broken-threading = false", "stay-in-thread = true".

2008-08-05  Martin Baulig  <martin@ximian.com>

	Released version 2.0 "Cologne" of the Mono Debugger :-)

	* NEWS: Updated to 2.0.

	* configure.in: This is trunk, bump the version number to 2.1.

2008-07-31  Martin Baulig  <martin@ximian.com>

	* classes/Debugger.cs
	(Debugger.ModuleLoadedEvent): New public event.
	(Debugger.ModuleUnLoadedEvent): New public event.

2008-07-31  Martin Baulig  <martin@ximian.com>

	**** The Debugger has been branched for Mono 2.0 ****

2008-07-30  Martin Baulig  <martin@ximian.com>

	* configure.in: Bump version number to 0.99; we're ready to branch.

2008-07-30  Martin Baulig  <martin@ximian.com>

	* configure.in (--with-host-mono): New configure option to
	override the mono used to run child applications.

	* build/Makefile.am: Link against a private copy of the symbol
	writer to make things more robust; you may now install the
	debugger to run with an older /usr/bin/mono.  Create a new
	command-line tool called `mdb-symbolreader.exe' which is the
	new symbol file verifier.

2008-07-30  Martin Baulig  <martin@ximian.com>

	* symbolwriter/MdbSymbolReader.cs: New file.  This is a symbol
	file verifier which reads everything in a symbol file and checks
	whether everything is ok.  You can run this inside mdb to debug
	symbol file bugs.

2008-07-30  Martin Baulig  <martin@ximian.com>

	* symbolwriter/: Created private copy for the debugger.

	* symbolwriter/MonoSymbolWriter.cs: Moved `ISourceFile',
	`ICompileUnit' and `IMethodDef' into MonoSymbolFile.cs.

	* symbolwriter/MonoSymbolFile.cs
	(MonoSymbolFile.AnonymousScopes): New public property.

2008-07-29  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile.read_variables): When inside an anonymous method,
	only allow accessing `this' if it has been captured.

2008-07-29  Martin Baulig  <martin@ximian.com>

	* backend/Inferior.cs
	(Inferior.HasSignals): New public property.
	(Inferior.Kernel_SIGRTMIN): New public property.

	* backend/ThreadManager.cs
	(ThreadManager.HandleChildEvent): `__SIGRTMIN' and `__SIGRTMIN+1'
	are used internally by glibc -> ignore __SIGRTMIN+1.

	* backend/server/server.h
	(SignalInfo): Add `kernel_sigrtmin'.

2008-07-29  Martin Baulig  <martin@ximian.com>

	* test/testsuite/testnative*.cs: Add "Native" category.

	* build/Makefile.am
	(EXCLUDED_TESTS): New variable to select tests which ware excluded
	from `make check';  exclude "NotWorking,Attach,Native,Threads,AppDomain"
	for everyone and a little bit less for me.

2008-07-28  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.IsExceptionType): Correctly resolve
	`type.BaseType'.

	* test/testsuite/TestException.cs: Added testcase for user-defined
	exception classes.	

2008-07-28  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs
	(MemberAccessExpression.ResolveMemberAccess): When resolving an
	invocation expression on a value-type, also check `System.Object'.

	* test/testsuite/TestManagedTypes.cs: Added testcase.

2008-07-28  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassType.cs
	(MonoClassType.HasFixedSize) Set to true: 

	* test/testsuite/TestManagedTypes.cs: Added testcase.

2008-07-28  Martin Baulig  <martin@ximian.com>

	* test/testsuite/TestManagedTypes.cs: Added testcases for boxing
	valuetypes.	

2008-07-25  Martin Baulig  <martin@ximian.com>

	* configure.in: Disable XSP support by default.

2008-07-25  Martin Baulig  <martin@ximian.com>

	* languages/Language.cs
	(Language.CreateBoxedObject): New public method.

	* frontend/Expression.cs
	(CastExpression.DoCast): Add support for valuetype -> object.

	* backend/Inferior.cs
	(Inferior.CallMethod): Added overloaded version taking a `long'
	and a `TargetObject' argument; the object will be copied to the
	stack if it's stored in a register.

	* classes/Thread.cs
	(Thread.CallMethod): Added overloaded version taking a
	`TargetAddress' and a `TargetObject' argument; the object will be
	copied to the stack if it's stored in a register.

	* backend/SingleSteppingEngine.cs
	(SSE.OperationCallMethod): Add support for the new address /
	object marshaller.

	* backend/server/server.h
	(mono_debugger_server_call_method_3): New public method; added
	method-call marshaller for methods taking an address and a
	`MonoObject * '.

2008-07-23  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.OperationStepCompilerGenerated): New operation.
	(SSE.frame_changed): Check whether we're in compiler-generated
	code and keep stepping if necessary.

2008-07-23  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(ShowLocationCommand): Improve `show location' a bit to support
	struct fields.	

2008-07-19  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(DisassembleCommand): Add `-frame' option to show disassembly for
	the current step frame, ie. all code which belongs to the current
	source line.

2008-07-19  Martin Baulig  <martin@ximian.com>

	* configure.in: Require Mono and XSP from the 2.0 branch.

2008-07-11  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.ThreadLockData): New protected class; moved `stopped' and
	`stop_event' here from the SSE.
	(SSE): Replaced `has_thread_lock' with `ThreadLockData thread_lock'.
	(SSE.EventResult): Add `ParentResumed' -> the child operation has
	completed, but the target is running (ie. kill the child operation
	and then return `EventResult.Running').
	(SSE.ManagedCallback): New method; this is private for the moment,
	but I'd like to have this in SVN before flying back to Germany.
	(SSE.OperationManagedCallback): New operation.

2008-07-10  Martin Baulig  <martin@ximian.com>

	* backend/ProcessStart.cs
	(ProcessStart.SetupEnvironment): Set `MONO_GENERIC_SHARING = none'.

	* frontend/Command.cs (Attach): Effective immediately, attaching
	is no longer supported and has been disabled.

2008-07-04  Martin Baulig  <martin@ximian.com>

	* classes/GUIManager.cs
	(GUIManager): New public class; handles stopping / resuming all
	threads for a GUI.

	* classes/Process.cs
	(Process.StartGUIManager): New public method.

2008-07-02  Martin Baulig  <martin@ximian.com>

	* classes/Breakpoint.cs
	(Breakpoint.OnBreakpointBound): New protected internal virtual method.
	(Breakpoint.OnBreakpointError): Likewise.

2008-06-30  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration.OpaqueFileNames): New public property;
	allows us to use Windows file names.

2008-06-18  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadVersion.cs
	(MonoDebuggerInfo): The stable version is 80.

	* configure.in: The stable symbol file version is 50.0.

2008-06-18  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerConfiguration.xsd: Add <DirectoryMaps> section
	containing `<Map from="c:/cygwin/home/ichotolot" to="/work/mordor"/>'
	entries.

	* classes/SourceInfo.cs
	(SourceFile.ctor): Added `DebuggerSession' argument; do directory maps.

2008-06-17  Jb Evain  <jbevain@novell.com>

	* configure.in: detect the internal Cecil library that
	comes with Mono.
	* build/Makefile.am: use Mono's version of Cecil.

2008-06-17  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoMethod.IsCompilerGenerated): Check the `[DebuggerHidden]' and
	`[CompilerGenerated]' custom attributes on the method.

2008-06-15  Martin Baulig  <martin@ximian.com>

	Fix thread-db for SuSE 11 - we need to return the correct PID in
	ps_getpid().	

	* backend/server/thread-db.h (ThreadDbHandle): Added `pid' field;
	we need to store the PID here for ps_getpid().

	* backend/server/thread-db.c
	(mono_debugger_thread_db_init): Added `pid' argument.
	(ps_getpid): Return the stored `pid'.

	* backend/ThreadDB.cs
	(ThreadDB.Create): Take an `Inferior' instead of a
	`TargetMemoryAccess' since we need the target's pid.

2008-06-11  Martin Baulig  <martin@ximian.com>

	* build/Makefile.am: Merge Mono.Debugger.dll and
	Mono.Debugger.Backend.dll into Mono.Debugger.dll.

2008-06-10  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MethodAddress): Check whether prologue_end and epilogue_begin are
	non-zero.

2008-06-07  Martin Baulig  <martin@ximian.com>

	* configure.in: Require the new symbol writer.

2008-06-05  Lluis Sanchez  <lluis@novell.com>

	* mono-debugger.pc.in: Add Mono.Debugger.Backend.dll to Libs
	list. Needed until some types required by the MonoDevelop
	add-in are moved to the public API.

2008-06-05  Martin Baulig  <martin@ximian.com>

	* classes/Method.cs
	(Method.IsCompilerGenerated): New public abstract property.

	* backend/SingleSteppingEngine.cs
	(SSE.MethodHasSource): Also check `method.IsCompilerGenerated'.

2008-06-02  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.OperationStep.IsSourceOperation): Add `StepMode.Finish'.
	(SSE.OperationStep.check_method_operation): New protected method;
	don't stop inside the method's epilogue code.
	(SSE.OperationStep.Step): If we're done stepping, call
	check_method_operation() to check whether we stopped inside a
	method's epilogue code.

2008-05-28  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs: Reflect latest symbol writer
	changes; we now require the latest Mono from SVN HEAD.

2008-05-26  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoMethodLineNumberTable): Compute start and end row here.

2008-05-26  Martin Baulig  <martin@ximian.com>

	* languages/TargetFunctionType.cs
	(TargetFunctionType.GetSourceCode): New public method.
	(TargetFunctionType): Removed `HasSourceCode', `SourceFile',
	`StartRow' and `EndRow'.

	* frontend/Command.cs
	(SourceCommand): Allow resolving to a `MethodSource' instead of a
	`SourceLocation'.
	(ListCommand): If we have a `MethodSource', list the method's
	entire source code.	

2008-05-26  Martin Baulig  <martin@ximian.com>

	* classes/SourceInfo.cs
	(SourceFile): Made this class abstract.
	(SourceFile.IsAutoGenerated): New public property.
	(SourceFile.CheckModified): New public method.

	* frontend/Command.cs
	(ShowSourcesCommand): When used without args: print the sources
	from the current stack frame's module.

	* frontend/ScriptingContext.cs
	(ScriptingContext.ShowSources): Check whether a source file has
	been modified; hide auto-generated files when running in xsp mode.

2008-05-19  Martin Baulig  <martin@ximian.com>

	Kahalo-only.
	
	* classes/DebuggerOptions.cs: -xsp now requires a directory as
	argument which is passed to xsp via `--root'.

2008-05-19  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration): Add `NotifyUser_ThreadCreation'.

2008-05-19  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter.Start): Use WaitAll(), not Wait() - to make things
	work correctly when using `-start' and a thread which is not the
	main thread stops first.
	(Interpreter.Attach): Likewise.
	(Interpreter.LoadSession): Likewise.

2008-05-19  Martin Baulig  <martin@ximian.com>

	Kill the `MONO_INSIDE_MDB' environment variable.

	* backend/MonoThreadManager.cs
	(MonoDebuggerInfo.UsingMonoDebugger): New public field.
	(MonoThreadManager): Set `UsingMonoDebugger' when starting up and
	after exec()'ing.

	* backend/ProcessServant.cs
	(ProcessServant.Initialize): If we exec()'ed a managed process,
	call MonoThreadManager.InitializeAfterExec().

2008-05-19  Martin Baulig  <martin@ximian.com>

	* backend/ThreadManager.cs
	(ThreadManager.HandleChildEvent): Eat SIGCHLD.

	* backend/SingleSteppingEngine.cs
	(SSE.ProcessEvent): if ThreadManager.HandleChildEvent() told us to
	resume the target, try `current_operation.ResumeOperation()' first
	before using `inferior.Continue ()'.

2008-05-19  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter.WaitAll): Rescan the process/thread list when new
	processes/threads have been created while we're waiting.

	* test/{src|testsuite}/TestMultiThread2.cs: Add testcase.

2008-05-19  Martin Baulig  <martin@ximian.com>

	* backend/server/x86_64-arch.c
	(x86_arch_child_stopped): Only send `STOP_ACTION_NOTIFICATION' if
	`stopsig == SIGTRAP' (we may stop a second time at the notification
	address if we received a signal).

	* backend/server/i386-arch.c
	(x86_arch_child_stopped): Likewise.

2008-05-16  Martin Baulig  <martin@ximian.com>

	Kahalo-only: Add support for `#line hidden'.

	* classes/Method.cs
	(LineEntry.IsHidden): New public property.

	* languages/mono/MonoSymbolFile.cs
	(MonoLineNumberTable.Lookup): Support hidden lines.

	* test/{src|testsuite}/TestLineHidden.cs: New testcase.

2008-05-14  Martin Baulig  <martin@ximian.com>

	Allow executing methods while being stopped at a system call.

	* backend/server/x86_64-arch.c
	(server_ptrace_call_method*): Set %orig_rax to -1 to prevent the
	kernel from restarting a system call.
	(server_ptrace_execute_instruction): Likewise.

	* backend/server/i386-arch.c
	(server_ptrace_call_method*): Set %orig_eax to -1 to prevent the
	kernel from restarting a system call.
	(server_ptrace_execute_instruction): Likewise.

	* backend/SingleSteppingEngine.cs
	(SSE.OperationCallMethod): Fix method invocations while being
	stopped at a system call.  This only works when debugging managed
	applications.	

2008-05-08  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.OperationStart.HandleException): Don't stop in exceptions
	after reaching the managed Main().

2008-05-07  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerOptions.cs: Add new `-xsp' option to start xsp
	inside the debugger.

	* configure.in: Conditionally depend on XSP when using the
	development branch.

2008-05-07  Martin Baulig  <martin@ximian.com>

	* classes/Debugger.cs
	(Debugger.ProcessReachedMainEvent): New public event.

	* backend/MonoThreadManager.cs
	(MonoThreadManager.HandleChildEvent): Emit the new
	`ProcessReachedMainEvent' from  `NotificationType.ReachedMain'.

	* backend/ProcessServant.cs
	(ProcessServant.Initialize): Emit the new
	`ProcessReachedMainEvent' if we're a native process.

2008-05-07  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerOptions.cs: Kill `-args'.

2008-05-07  Martin Baulig  <martin@ximian.com>

	* backend/ProcessServant.cs
	(ProcessServant.ChildForked): Unset `MONO_INSIDE_MDB' if we're not
	following forks.

2008-05-06  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs
	(SimpleNameExpression.DoResolve): Also call Process.LookupSymbol()
	and return a NumberExpression containing the address on success.

	* frontend/Command.cs
	(BreakCommand.DoResolve): Also call Process.LookupSymbol() to
	allow breakpoints on native methods.

	* classes/Process.cs
	(Process.LookupSymbol): New public method.

	* backend/ProcessServant.cs
	(ProcessServant.LookupSymbol): New public method; does a native
	symbol lookup via the BfdContainer.

2008-05-06  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(WrapperMethod): Make GetParameters() and GetLocalVariables()
	return an empty array instead of null.

2008-05-06  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(ShowCommand.ShowParametersCommand): Don't crash if the current
	method doesn't have any parameters.
	(ShowCommand.ShowLocalsCommand): Likewise.

2008-05-05  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture_X86_64.cs
	(Architecture_X86_64.unwind_method): Use `memory.ReadLongInteger()'
	to read the registers from the stack.

2008-04-29  Martin Baulig  <martin@ximian.com>

	* classes/Method.cs
	(LineEntry.File): New public field.

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile): Add support for line numbers from other source
	files if we're using the symbol writer from the kahalo branch.

2008-04-29  Martin Baulig  <martin@ximian.com>

	* configure.in: Enable building with a runtime / symbol writer
	from both HEAD and the kahalo branch.

2008-04-24  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs
	(Convert.ExplicitFundamentalConversion): New public method.
	(CastExpression): Implement explicit fundamental conversions.

2008-04-24  Martin Baulig  <martin@ximian.com>

	* test/testsuite/TestManagedTypes.cs: Add some testcases to parse
	all kinds of crazy numbers.

2008-04-23  Martin Baulig  <martin@ximian.com>

	* test/testsuite/NUnit.cs
	(TestSuite.Verbose): Set to false.

2008-04-23  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(ShowCommand.ShowSourcesCommand): Fix #345172.

2008-04-23  Martin Baulig  <martin@ximian.com>

	* build/runtests.in: Use `--debug=mdb-optimizations' so we can
	better attach to the process or examine core files.

2008-04-22  Martin Baulig  <martin@ximian.com>

	Fix an API bug: target output is always per process.

	* classes/Debugger.cs
	(Debugger.TargetOutputEvent): Moved to `Process'.

	* classes/Process.cs
	(Process.TargetOutputEvent): Moved here from `Debugger'.

2008-04-22  Martin Baulig  <martin@ximian.com>

	Fix a race condition causing problems when reading output from a
	child process.

	* backend/server/x86-ptrace.c
	(server_ptrace_io_thread_main): Close the pipes here, not in
	server_ptrace_finalize() since we may still be reading.

2008-04-22  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-ptrace.c
	(server_ptrace_dispatch_event): Map SIGCONT => 0.

2008-04-22  Martin Baulig  <martin@ximian.com>

	* test/misc/libgtop-glue.[ch]: Moved to backend/server/.

	* backend/server/Makefile.am
	(libmonodebuggerserver_la_SOURCES): Added libgtop-glue.[ch].

2008-04-21  Martin Baulig  <martin@ximian.com>

	* configure.in: Require runtime version 69.

2008-04-21  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs
	(MonoThreadManager.InitializeAfterAttach): New internal method.
	(MonoThreadManager.Detach): New internal method.

	* backend/SingleSteppingEngine.cs
	(SSE.OperationStart): We don't need to call any methods in the
	target anymore when attaching.
	(SSE.OperationAttach): Removed.
	(SSE.OperationDetach): Removed.
	(SSE.OperationGetLMFAddr): Removed.

2008-04-21  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-ptrace.c
	(mono_debugger_server_initialize_code_buffer): New public function.

	* backend/MonoThreadManager.cs
	(MonoThreadManager.HasCodeBuffer): New internal property.
	(MonoThreadManager.InitCodeBuffer): New internal method; allows
	delayed initialization of the code buffer.

	* backend/SingleSteppingEngine.cs
	(SSE.step_over_breakpoint): Also use `OperationExecuteInstruction'
	for the nop-case.
	(SSE.OperationExecuteInstruction): Check whether the code buffer
	has already been initialized and trigger an init if necessary.
	(SSE.OperationInitCodeBuffer): New private callback; calls the new
	`init_code_buffer' method.

2008-04-19  Martin Baulig  <martin@ximian.com>

	* backend/arch/Bfd.cs
	(Bfd.OnModuleChanged): Always try to load the CFA if available;
	also when loading of native symtabs is disabled.

	* backend/arch/DwarfFrameReader.cs
	(DwarfFrameReader.UnwindStack): Small fix for `.eh_frame'.

2008-04-16  Martin Baulig  <martin@ximian.com>

	* library.c (mono_debugger_server_get_registers_from_core_file):
	New public function.

	* backend/arch/CoreFile.cs
	(CoreFile.CoreFileThread.read_registers): Read it here to
	correctly read the registers.

2008-04-16  Martin Baulig  <martin@ximian.com>

	* test/misc/libgtop-glue.c: Copy implementation from libgtop so we
	can use this on the build machines.

	* configure.in: Don't require libgtop anymore.

2008-04-15  Martin Baulig  <martin@ximian.com>

	* backend/server/server.h
	(mono_debugger_server_spawn): Removed the two `ChildOutputHandler's;
	return a `IOTheadData *' pointer instead.
	(mono_debugger_server_io_thread_main): New public function; we now
	start the io thread from managed code and then call this function
	with the `IOThreadData *' returned by mono_debugger_server_spawn().

	* backend/Inferior.cs
	(Inferior.TargetOutput): Removed.
	(Inferior.Run): Start the io thread here in managed land and
	directly call `process.OnTargetOutput ()'.

2008-04-14  Martin Baulig  <martin@ximian.com>

	* configure.in: Conditionally check for libgtop; it's only used in
	the test suite to display some memory usage statistics.

	* test/misc/: New directory; contains a simple managed wrapper
	around libgtop to gather some statistics while running the tests.

	* build/runtests: New script to run the tests; correctly sets
	LD_LIBRARY_PATH so we can run the test suite without doing a `make
	install' first.

	* test/testsuite/NUnit.cs
	(TestSuite.PrintMemoryInfo): New public method; uses libgtop to
	print some memory statistics about the current process; only
	available if compiled with libgtop support.

2008-04-14  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-linux-ptrace.c
	(_server_ptrace_finalize_inferior): New static function.

	* backend/server/x86-ptrace.c
	(server_ptrace_finalize): Don't leak file descriptors.

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.Dispose): Use the `symfile_hash', not the
	`symfile_by_index' hash to finalize symbol files.

2008-04-09  Martin Baulig  <martin@ximian.com>

	* test/{testsuite|src}/TestIterator.cs: Reflect latest gmcs changes.

2008-04-08  Martin Baulig  <martin@ximian.com>

	* languages/TargetArrayType.cs
	(TargetArrayBounds): New public class.
	(TargetArrayType.IsByRef): Don't set this here; we need to set
	this to `true' for managed arrays and `false' for native ones.

	* languages/TargetArrayObject.cs
	(TargetArrayObject.GetArrayBounds): New public method returning
	the `TargetArrayBounds'; this was formerly a private method.
	(TargetArrayObject): Removed GetLowerBound() and GetUpperBound().

	* languages/native/NativeArrayType.cs
	(NativeArrayType): Improved support for native arrays; we now
	support multi-dimensional arrays and unbound arrays.

	* test/src/testnativetypes.c: Added tests.
	* test/testsuite/testnativetypes.cs: Added tests.

2008-04-08  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerOptions.cs: Swap behavior of `-start' and `-run'
	to make it consistent with the `start' and `run' commands.

2008-04-07  Martin Baulig  <martin@ximian.com>

	Implemented support for native function pointers.

	* languages/native/NativeFunctionPointer.cs: New file.
	* languages/native/NativeFunctionObject.cs: New file.

	* frontend/Expression.cs
	(PointerDereferenceExpression): Improved this.

	* languages/TargetPointerType.cs
	(TargetPointerType.CanDereference): New public abstract property.

	* test/src/testnativetypes.c: Added tests.
	* test/testsuite/testnativetypes.cs: Added tests.

2008-04-03  Martin Baulig  <martin@ximian.com>

	* backend/ProcessServant.cs
	(ProcessServant.OnManagedThreadExitedEvent): New internal method;
	remove the thread from the hash, but don't emit any events.

	* backend/SingleSteppingEngine.cs
	(SSE.OnManagedThreadExited): Fix a race condition: call
	`process.OnManagedThreadExitedEvent()'.

2008-03-24  Wade Berrier  <wberrier@novell.com>

	* Makefile.am:
	* doc/Makefile.am:
	Fix EXTRA_DIST (missing files) to fix build

2008-03-15  Martin Baulig  <martin@ximian.com>

	Released version 0.80 "Terrania City" of the Mono Debugger :-)

	* NEWS: Updated to 0.80.

2008-03-15  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs: Swap the behavior of `run' and `start':
	`run' now stops in main again.

2008-03-15  Martin Baulig  <martin@ximian.com>

	* build/Makefile.am: Install in $(prefix)/lib/mono/2.0.

2008-03-14  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerConfiguration.cs: Don't use XmlValidatingReader.
	* classes/DebuggerSession.cs: Don't use XmlValidatingReader.

2008-03-14  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile): Make sure it's the correct file format.

2008-03-14  Martin Baulig  <martin@ximian.com>

	* configure.in: Bump version number to 0.80.

2008-03-14  Martin Baulig  <martin@ximian.com>

	**** Merged the `terrania' branch of the Mono Debugger ****

2008-03-13  Martin Baulig  <martin@ximian.com>

	Fix #324557.

	* backend/server/x86_64-arch.h: Don't #include <asm/user.h>; use
	<sys/user.h> instead which defines `struct user_fpregs_struct'.

	* backend/server/i386-arch.h: Likewise.

2008-03-10  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(JitCodeBlockEntry): Removed.
	(MonoSymbolFile.MonoCodeBlock): Read the code blocks directly from
	the symbol file and compute their start and end addresses from the
	line number table.

2008-03-05  Martin Baulig  <martin@ximian.com>

	* languages/TargetMethodSignature.cs: New file.
	(TargetMethodSignature): New public abstract class.

	* languages/TargetType.cs
	(TargetType.ContainsGenericParameters): New public abstract
	property.

	* languages/TargetFunctionType.cs
	(TargetFunctionType.GetSignature): New public abstract method.

	* languages/TargetMember.cs
	(TargetMemberAccessibility): New public enum.
	(TargetMemberInfo.Accessibility): New public readonly field.

	* frontend/Style.cs
	(Style.FormatStruct): Sort the members by their accessibility.

2008-02-28  Martin Baulig  <martin@ximian.com>

	* frontend/ScriptingContext.cs
	(ScriptingContext.MonoObjectToString): Operate on
	`TargetStructObject' so we can also print generic instances.

2008-02-27  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs
	(MonoThreadManager.HandleChildEvent): Store the return stack
	pointer in `NotificationType.ReachedMain'.

2008-02-27  Martin Baulig  <martin@ximian.com>

	* languages/TargetClass.cs
	(TargetClass.GetProperties): New public abstract method.

2008-02-26  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassType.cs
	(IMonoStructType.LookupFunction): New interface method.

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile.LookupFunction): Moved into `IMonoStructType'.
	With generics, we can't just use the `token' as a key, so we need
	a separate hash table per class.

2008-02-19  Martin Baulig  <martin@ximian.com>

	* README.terrania: Updated.

2008-02-19  Martin Baulig  <martin@ximian.com>

	* languages/TargetClassType.cs
	(TargetClassType.IsCompilerGenerated): New public abstract property.

	* frontend/Expression.cs
	(Expression.DoEvaluateObject): Don't use the result of
	TargetStructObject.GetCurrentObject() if it's a compiler generated
	class; this should fix iterators and print the `IEnumerable<T>'
	interface instead.

2008-02-19  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile.GetMethodName): Use a format which is compatible
	with mcs's GetSignatureForError().

2008-02-18  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoMethod.do_read_variables): Support a captured 'this'.

2008-02-18  Martin Baulig  <martin@ximian.com>

	Improved iterator support and added some tests.

	* test/{src|testsuite}/TestIterator.cs: New tests.

2008-02-18  Martin Baulig  <martin@ximian.com>

	* backend/arch/Instruction_I386.cs
	(Instruction_I386.GetMonoTrampoline): Support short 0x6a `push' insns.

2008-02-15  Martin Baulig  <martin@ximian.com>

	* classes/Block.cs: New file.
	(Block): New public abstract class.
	(Method.IsIterator): New internal abstract property.
	(Method.LookupBlock): New internal abstract method.

	* backend/SingleSteppingEngine.cs
	(SSE.frame_changed): Use the new Method.LookupBlock() to check
	which code block we're in and start an `OperationStepIterator' if
	necessary.	
	(SSE.OperationStepIterator): New operation.

2008-02-15  Martin Baulig  <martin@ximian.com>

	* test/{testsuite|src}/TestSSE.cs: New tests.

	* test/{testsuite|src}/TestAnonymous.cs: Added new tests here.

2008-02-15  Martin Baulig  <martin@ximian.com>

	* classes/TargetBinaryReader.cs
	(TargetBinaryReader): Added ReadSByte() and PeekSByte().

	* backend/arch/X86_Instruction.cs: Use ReadSByte(), not ReadByte().

2008-02-08  Martin Baulig  <martin@ximian.com>

	* languages/TargetStructType.cs
	(TargetStructType.BaseName): New public abstract property.  This
	is the full name (including namespace and generic arity) without
	the type arguments.

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.RegisterMethodLoadHandler): Use
	`TargetStructType.BaseName' to insert the breakpoint.

	* test/{testsuite|src}/TestAnonymous.cs: Added new tests here.

2008-02-06  Martin Baulig  <martin@ximian.com>

	* test/testsuite/NUnit.cs: Also scan for `// @MDB BREAKPOINT: name'
	patterns and automatically insert breakpoints.

2008-02-02  Martin Baulig  <martin@ximian.com>

	HEADS UP: We now require Mono 1.9 with some local changes; see
	          README.terrania for details.

	* README.terrania: New file.

2008-02-02  Martin Baulig  <martin@ximian.com>

	* languages/mono/CapturedVariable.cs: New file.

	* languages/mono/MonoSymbolFile.cs
	(MonoMethod.do_read_variables): Support captured variables and
	parameters.	

2008-02-02  Martin Baulig  <martin@ximian.com>

	* test/testuite/NUnit.cs: Read the source files and scan for
	`// @MDB LINE: name' patterns; automatically compute the line
	numbers.

	* test/{testsuite|src}/TestAnonymous.cs: New test.

2008-01-30  Martin Baulig  <martin@ximian.com>

	* classes/Method.cs
	(WrapperType): Updated.
	(Method.IsWrapper): New public abstract property.

	* backend/SingleSteppingEngine.cs
	(SSE.OperationStep.TrampolineHandler): Improved; don't step into
	compiler-generated .ctor's.

2008-01-30  Martin Baulig  <martin@ximian.com>

	* languages/TargetClass.cs
	(TargetClass.GetMethods): New public abstract method.
	(TargetClass.FindMember): New public virtual method.

	* languages/TargetFunctionType.cs
	(TargetFunctionType.DeclaringType): Changed type from
	`TargetClassType' into `TargetStructType'.

	* languages/mono/MonoFunctionType.cs
	(MonoFunctionType.MonoClass): Removed.
	(MonoFunctionType.SymbolFile): New internal property.
	(MonoFunctionType.ResolveClass): New internal method.

	* languages/mono/MonoMember.cs
	(MonoMethodInfo): Operate on `IMonoStructType'.

	* frontend/Expression.cs
	(StructAccessExpression.FindMember): Search both in the
	`TargetClass' and in the `TargetClassType'.

2008-01-25  Martin Baulig  <martin@ximian.com>

	* test/{testsuite|src}/TestRecursiveGenerics.cs: New test.

2008-01-25  Martin Baulig  <martin@ximian.com>

	Fix the parent type madness.

	* languages/TargetClass.cs
	(TargetClass.Type): Changed type into `TargetStructType'.
	(TargetClass.RealType): New public property.

	* languages/Language.cs
	(Language.IsExceptionType): New public method.

	* languages/mono/MonoClassInfo.cs
	(MonoClassInfo.ReadClassInfo): Create `info.type' here.

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.LookupMonoClass): Fix the madness; just call
	ReadClassInfo() here and return its `RealType'.

	* languages/mono/MonoClassType.cs
	(IMonoStructType.ClassInfo): New property.
	(IMonoStructType.ResolveClass): Removed the `MonoClassInfo' argument.
	(MonoClassType.ResolveClass): Maintain a `resolved' flag instead
	of checking whether `class_info' is not null; the `class_info' may
	now be set via `IMonoStructType.ClassInfo' without actually
	resolving the class.  This was necessary to support recursive
	generic types like "class Test : Foo<Test>".

2008-01-25  Martin Baulig  <martin@ximian.com>

	* classes/Thread.cs
	(Thread.RuntimeInvoke): Changed type of `object_argument' from
	`TargetClassObject' -> `TargetStructObject'.

	* backend/ThreadServant.cs
	(ThreadServant.RuntimeInvoke): Changed type of `object_argument'
	from `TargetClassObject' -> `TargetStructObject'.

	* frontend/Interpreter.cs
	(Interpreter.RuntimeInvoke): Changed type of `object_argument' from
	`TargetClassObject' -> `TargetStructObject'.

2008-01-25  Martin Baulig  <martin@ximian.com>

	* frontend/CSharpTokenizer.cs
	(CSharpTokenizer.ReadGenericArity): New public property.
	(CSharpTokenizer.ReadDigit): If `ReadGenericArity' is true, only
	read an integer and stop on the first non-digit.  This is
	necessary to properly tokenize "Foo`1.Data".

2008-01-23  Martin Baulig  <martin@ximian.com>

	Added `$parent (expr)' and `$parent+N (expr)' syntax.

	* frontend/CSharpExpressionParser.jay
	(PARENT): New token.
	(PARENT opt_parent_level OPAREN expression CPAREN): New rule.

	* frontend/CSharpTokenizer.cs: Add `$parent' => `Token.PARENT'.

	* frontend/Expression.cs
	(ParentExpression): New expression.

	* test/testsuite/TestSimpleGenerics.cs: Added tests.

2008-01-23  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile.GetMethodName): Include type parameters.

2008-01-23  Martin Baulig  <martin@ximian.com>

	* languages/TargetStructObject.cs
	(TargetStructObject.GetParentObject): Provide the `Thread'
	implementation here; made the `TargetMemoryAccess' version
	abstract.
	(TargetStructObject.GetCurrentObject): Moved here from
	`TargetClassObject'; changed return type into
	`TargetStructObject'; provide the `Thread' implementation here;
	made the `TargetMemoryAccess' version abstract.

2008-01-23  Martin Baulig  <martin@ximian.com>

	* classes/Method.cs
	(Method.GetDeclaringType): Return a `TargetStructType' instead of
	a `TargetClassType'.

2008-01-23  Martin Baulig  <martin@ximian.com>

	* test/{testsuite|src}/TestSimpleGenerics.cs: New test.

2008-01-19  Martin Baulig  <martin@ximian.com>

	* configure.in: Use gmcs, not mcs.

2008-01-19  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassType.cs
	(IMonoStructType): New internal interface.
	(MonoClassType): Make things work if our parent class is a
	`MonoGenericInstanceType' and not a `MonoClassType'.

2008-01-17  Martin Baulig  <martin@ximian.com>

	* languages/TargetObjectKind.cs
	(TargetObjectKind): Added `GenericParameter' and `GenericInstance'.

	* languages/TargetGenericParameterType.cs: New file.
	(TargetGenericParameterType): New type.

	* languages/TargetGenericInstanceType.cs: New file.
	(TargetGenericInstanceType): New type.

	* languages/TargetGenericInstanceObject.cs: New file.
	(TargetGenericInstanceObject): New file.

	* languages/TargetStructObject.cs
	(TargetStructObject.GetParentObject): Moved here from
	`TargetClassObject' and changed return type into
	`TargetStructType'.

	* languages/TargetClassObject.cs
	(TargetClassObject.GetParentObject): Moved into
	`TargetStructObject' and changed return type into
	`TargetStructType'.

	* languages/mono/MonoGenericInstanceObject.cs: New file.
	* languages/mono/MonoGenericParameterType.cs: New file.

2007-12-18  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassInfo.cs
	(MonoClassInfo): Merge get_fields() and get_field_offsets().

2007-12-18  Martin Baulig  <martin@ximian.com>

	Released version 0.60 "Madrid" of the Mono Debugger :-)

	* configure.in: Require Mono >= 1.2.6.

2007-12-14  Wade Berrier  <wberrier@novell.com>

	* frontend/Makefile.am:
	* test/src/Makefile.am:
	* test/testsuite/Makefile.am:
	* backend/arch/Makefile.am:
	* classes/Makefile.am:
	* interface/Makefile.am:
	* languages/Makefile.am:
	More .cs globbing for EXTRA_DIST

2007-12-10  Martin Baulig  <martin@ximian.com>

	* languages/TargetClass.cs
	(TargetClass.GetField): Take a `TargetStructObject' instead of a
	`TargetClassObject'.
	(TargetClass.SetField): Likewise.

2007-12-10  Martin Baulig  <martin@ximian.com>

	* languages/TargetStructType.cs: New file.
	(TargetStructType): New public abstract type.

	* languages/TargetStructObject.cs: New file.
	(TargetStructObject): New public abstract type.

	* languages/TargetClassType.cs
	(TargetClassType): Derive from `TargetStructType'; removed
	`HasParent', `GetClass', `Module' and `ParentType' which are now
	provided by `TargetStructType'.

	* languages/TargetClassObject.cs
	(TargetClassObject): Derive from `TargetClassObject'.

2007-12-10  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerOptions.cs: Added new `-start' command line
	argument to stop in Main(); made `-run' run the target without
	stopping.  This makes the command line arguments consistent with
	the `start' and `run' commands.

2007-12-10  Martin Baulig  <martin@ximian.com>

	Applied a patch from Harald Krapfenbauer <krapfenbauer@ict.tuwien.ac.at>:

	* backend/server/i386-arch.c
	(x86_arch_get_registers): Store the return value each time to
	`result' to check for errors.

	* backend/server/x86_64-arch.c
	(x86_arch_get_registers): Store the return value each time to
	`result' to check for errors.

	* backend/server/x86-linux-ptrace.c
	(server_ptrace_get_application): Increase size of `buffer' by 1.

2007-12-08  Martin Baulig  <martin@ximian.com>

	* configure.in: Bumped version number to 0.60.

2007-12-08  Martin Baulig  <martin@ximian.com>

	Changed default behavior: don't follow fork() by default.

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration.FollowFork): Changed default to false.

	* test/testsuite/NUnit.cs
	(NUnitInterpreter.ctor): Override configuration: enable `FollowFork'.

2007-12-08  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(ConfigCommand): New command.

2007-12-08  Martin Baulig  <martin@ximian.com>

	* backend/Inferior.cs
	(Inferior): Replaced InitializeAfterFork() by DetachAfterFork().

	* backend/SingleSteppingEngine.cs
	(SSE.InitAfterFork): New method.
	(OperationInitializeAfterFork): New operation.  To avoid a race
	condition, we need to wait until the target stopped the first time
	before we can disable the local breakpoints.

	* backend/server/server.h
	(mono_debugger_server_init_after_fork): Renamed info
	mono_debugger_server_detach_after_fork().

	* backend/server/x86-arch.h
	(x86_arch_enable_breakpoint): Add prototype.
	(x86_arch_disable_breakpoint): Add prototype.

	* backend/server/i386-arch.c
	(do_enable): Renamed into x86_arch_enable_breakpoint().
	(do_disable): Renamed into x86_arch_disable_breakpoint().

	* backend/server/x86_64-arch.c
	(do_enable): Renamed into x86_arch_enable_breakpoint().
	(do_disable): Renamed into x86_arch_disable_breakpoint().

2007-12-08  Martin Baulig  <martin@ximian.com>

	* backend/ProcessServant.cs
	(ProcessServant.ChildForked): Implement detach-after-fork, ie. not
	following fork().  At the moment, this can only be enabled in the
	configuration file
	[FIXME: add user-interface option to enable/disable this].

	* backend/Inferior.cs
	(Inferior.InitializeAfterFork): Added `bool follow_fork' argument.

	* backend/server/server.h
	(mono_debugger_server_init_after_fork): Added
	`gboolean follow_fork' argument; remove all breakpoints if false.

2007-12-08  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration.FollowFork): New property.  Not yet implemented.

2007-12-08  Martin Baulig  <martin@ximian.com>

	* backend/ThreadDB.cs
	(ThreadDB.GetThreadInfo): Added `TargetMemoryAccess' argument;
	operate on that target.  This fixes the XSP issue.

2007-12-07  Martin Baulig  <martin@ximian.com>

	Unify registers on i386 and x86_64.

	* backend/arch/X86_Architecture.cs: New file.
	(X86_Architecture): New internal abstract class.
	(X86_Register): New internal enum.

	* backend/arch/Architecture_X86_64.cs
	(X86_64_Register): Removed; use `X86_Register' instead.

	* backend/arch/Architecture_I386.cs
	(I386Register): Removed; use `X86_Register' instead.

	* backend/server/x86-arch.h
	(DebuggerX86Register): Use an unified register representation on
	i386 and x86_64.

2007-12-05  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture_X86_64.cs
	(X86_64_Register): Actually sync with backend/arch/x86_64-arch.h.

2007-11-30  Martin Baulig  <martin@ximian.com>

	* languages/TargetClassType.cs
	(TargetClassType.StaticFields): Merged with `Fields'.
	(TargetClassType.StaticProperties): Merged with `Properties'.
	(TargetClassType.StaticEvents): Merged with `Events'.
	(TargetClassType.StaticMethods): Merged with `Methods'.
	(TargetClassType.StaticConstructors): Merged with `Constructors'.
	(TargetClassType.FindMember): Provide a virtual implementation here.

2007-11-28  Martin Baulig  <martin@ximian.com>

	* languages/TargetClass.cs
	(TargetClass.GetFields): New public method; this includes both
	instance and static fields.

	* languages/mono/MonoClassInfo.cs
	(MonoClassInfo.GetFields): Get the field types from the runtime
	and not from Cecil.

	* frontend/ObjectFormatter.cs
	(ObjectFormatter.FormatClassObject): Use the new `TargetClass' to
	display fields.

2007-11-28  Martin Baulig  <martin@ximian.com>

	* languages/TargetClass.cs
	(TargetClass): New public abstract class.

	* languages/TargetClassType.cs
	(TargetClassType.GetClass): New public method.
	(TargetClassType): Removed GetStaticField() and SetStaticField(),
	they're now in the `TargetClass'.

	* languages/TargetClassObject.cs
	(TargetClassObject): Removed GetField() and SetField(), they're
	now in the `TargetClass'.

2007-11-28  Martin Baulig  <martin@ximian.com>

	* languages/TargetFunctionType.cs
	(TargetFunctionType.GetMethodAddress): Removed.

	* languages/mono/MonoClassType.cs
	(MonoClassType.HardResolveClass): Removed.

	* backend/SingleSteppingEngine.cs
	(SingleSteppingEngine.OperationRuntimeInvoke): Call
	GetMethodAddress() directly on the `MonoClassInfo'.

2007-11-28  Martin Baulig  <martin@ximian.com>

	* languages/TargetFundamentalObject.cs
	(TargetFundamentalObject.GetObject): Added internal overloaded
	version taking a `TargetMemoryAccess'.

	* backend/SingleSteppingEngine.cs
	(SingleSteppingEngine): Kill some more `sse.Thread' madness.

	* backend/Inferior.cs
	(Inferior.RuntimeInvoke): Removed the `Thread' argument.

2007-11-28  Martin Baulig  <martin@ximian.com>

	Renamed `Mono.Debugger.Backends' => `Mono.Debugger.Backend'.

2007-11-28  Martin Baulig  <martin@ximian.com>

	* backend/arch/X86_Instruction.cs
	(X86_Instruction.GetMonoTrampoline): New protected abstract method.
	(X86_Instruction.CheckTrampoline): Implement this here.

2007-11-28  Martin Baulig  <martin@ximian.com>

	* backend/TargetMemoryAccess.cs
	(TargetMemoryAccess): Moved `TargetIntegerSize',
	`TargetLongIntegerSize', `TargetAddressSize', `IsBigEndian',
	`CanWrite' and `Write*' here from `TargetAccess'.
	(TargetAccess): Removed everything except `InsertBreakpoint' and
	`RemoveBreakpoint'.

	* classes/DebuggerSession.cs
	(IExpressionParser): Operate on `Thread', not `TargetMemoryAccess'.
	(DebuggerSession.ParseLocation): Likewise.

	* classes/Thread.cs
	(Thread): Don't derive from `TargetAccess'.

	* classes/Breakpoint.cs
	(Breakpoint.Resolve): Operate on `Thread', not `TargetMemoryAccess'.

	* backend/ThreadServant.cs
	(ThreadServant): Don't derive from `TargetAccess' or
	`TargetMemoryAccess'.	

	* backend/arch/Architecture.cs
	(Architecture): Operate on `TargetMemoryAccess', not `Thread'.

	* backend/Inferior.cs
	(Inferior): Derive from `TargetAccess', not `TargetMemoryAccess'.

	* backend/MonoThreadManager.cs
	(MonoMetadataInfo): Moved into ../languages/mono/MonoRuntime.cs.

	* languages/Target*Object.cs
	(Target*Object): Operate on `Thread', not `TargetMemoryAccess'.

	* languages/Target*Type.cs
	(Target*Type): Operate on `Thread', not `TargetMemoryAccess'.

2007-11-22  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(OperationDelegateInvoke): New operation; step through a delegate
	invocation trampoline.

	* backend/arch/Instruction.cs
	(Instruction.TrampolineType): Added `DelegateInvoke'.

2007-11-20  Martin Baulig  <martin@ximian.com>

	* test/testsuite/TestDelegate.cs: Temporarily disable this.

	* backend/SingleSteppingEngine.cs
	(OperationExecuteInstruction): Make this a separate operation
	since we need to resume the target after executing the instruction
	if we're not single-stepping.
	(OperationActivateBreakpoints): Use the new breakpoint code.

	* languages/TargetFunctionType.cs
	(TargetFunctionType.InsertBreakpoint): Take a
	`FunctionBreakpointHandle' argument, not `MethodLoadedHandler'.

2007-11-19  Martin Baulig  <martin@ximian.com>

	* frontend/Main.cs
	(Main.RunInferiorMainLoop): New public method.  This can be used
	to run a main loop inside the nunit test suite.

	* test/testsuite/NUnit.cs
	(TestSuite.MainLoop): New public method; run an inferior main loop
	from within the testsuite.

2007-11-06  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture_I386.cs
	(Architecture_I386.GetLMF): Make this work again.

2007-11-05  Martin Baulig  <martin@ximian.com>

	* backend/arch/Instruction.cs
	(Instruction.Type): Added `Interpretable'.

	* backend/arch/Instruction_I386.cs
	(Instruction_I386.InterpretInstruction): Interpret `push %ebp'.

	* backend/arch/Instruction_X86_64.cs
	(Instruction_I386.InterpretInstruction): Interpret `push %rbp'.

2007-11-05  Martin Baulig  <martin@ximian.com>

	* backend/arch/Instruction.cs
	(Instruction.CanInterpretInstruction): New public property.

	* backend/arch/Bfd.cs
	(Bfd.DynlinkBreakpoint): Interpret the instruction rather than
	stepping over the breakpoint.

2007-11-05  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-ptrace.c
	(mono_debugger_server_finalize_mono_runtime): New public method.

	* backend/ProcessServant.cs
	(ProcessServant.CanExecuteCode): New internal property.

2007-11-05  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs
	(MonoDebuggerInfo.MinDynamicVersion): Bump to 64 to require SVN HEAD.

	* backend/server/x86_64-arch.c: Reflect latest JIT changes.
	* backend/server/i386-arch.c: Likewise.

2007-10-31  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture.cs
	(Architecture.Opcodes.GenerateNopInstruction): New public property.

	* backend/SingleSteppingEngine.cs
	(SSE.step_over_breakpoint): Use Opcodes.GenerateNopInstruction()
	instead of encoding it here.

	* backend/server/server.h
	(mono_debugger_server_execute_instruction): Removed the
	`original_size' argument; replaced `push_retaddr' by `up

2007-10-31  Martin Baulig  <martin@ximian.com>

	* backend/arch/Opcodes.cs
	(Opcodes.GenerateJumpInstruction): New abstract method.

	* backend/arch/X86_Opcodes.cs
	(X86_Opcodes): Make this abstract.

	* backend/arch/Opcodes_I386.cs: New file.
	(Opcodes_I386): i386-specific implementation.

	* backend/arch/Opcodes_X86_64.cs: New file.
	(Opcodes_X86_64): x86_64-specific implementation.

2007-10-31  Martin Baulig  <martin@ximian.com>

	Merged the Plophos branch.

	* backend/SingleSteppingEngine.cs
	(SSE.step_over_breakpoint): Take a `bool singlestep' and a
	`TargetAddress until' argument; use the new ExecuteInstruction()
	whenever possible.
	(SSE): The old GetCallTarget() API is gone; we now use
	Architecture.ReadInstruction() which returns an `Instruction'.
	(OperationStepOverBreakpoint): We don't need to deal with
	trampolines here anymore.
	(OperationMonoTrampoline): This is used when stepping into a
	trampoline: we enable the `NotificationType.Trampoline'
	notification and resume execution.
	(OperationCompileMethod): Removed.
	(OperationRuntimeClassInit): Removed.

	* backend/ProcessServant.cs: Reflect latest runtime changes.
	* backend/MonoThreadManager.cs: Reflect latest runtime changes.

	* backend/Inferior.cs
	(Inferior.ChildEvent): Added public readonly `CallbackData' field.
	(Inferior.CallMethod(long,long)): Take a `byte[]' and a `long'
	argument instead of two `long' arguments.
	(Inferior.ExecuteInstruction): New public method.
	(Inferior.ProcessEvent): mono_debugger_server_dispatch_event() may
	now pass us an additional byte[] argument.

	* backend/server/breakpoints.h
	(BreakpointInfo): Added `runtime_table_slot'.

	* server.h
	(MonoRuntimeInfo): New typedef.
	(ServerHandle): Added `MonoRuntimeInfo *mono_runtime'
	(InferiorVTable): Added `set_runtime_info' and
	`execute_instruction'; removed `set_notification'; `call_method_2'
	now takes additional `data_size' and 'data_buffer' arguments.
	(mono_debugger_server_set_runtime_info): New function.
	(mono_debugger_server_execute_instruction): New function.
	(mono_debugger_server_set_notification): Removed.
	(mono_debugger_server_initialize_mono_runtime): New function.

	* x86-ptrace.c
	(InferiorHandle): Removed `notification_address', this is now in
	the new `MonoRuntimeInfo'.

	* x86_64-arch.c
	(runtime_info_enable/disable_breakpoint): New static methods.

	* i386-arch.c
	(runtime_info_enable/disable_breakpoint): New static methods.

	* backend/arch/Architecture.cs
	(CallTargetType): Removed.
	(Architecture.ReadInstruction): New method.
	(Architecture.IsTrampoline): Removed.
	(Architecture.IsCall): Removed.
	(Architecture.GetCallTarget): Removed.
	(Architecture.DoGetMonoTrampoline): Removed.

	* backend/arch/Opcodes.cs: New file.
	(Opcodes): New abstract internal class.

	* backend/arch/X86_Opcodes.cs: New file.
	(X86_Opcodes): Implementation for i386 and x86_64.

	* backend/arch/Instruction.cs: New file.
	(Instruction): New abstract internal class.

	* backend/arch/X86_Instruction.cs: New file.
	(X86_Instruction): Abstract implementation for i386 and x86_64.

	* backend/arch/Instruction_I386.cs: New file.
	(Instruction_I386): i386-specific part.

	* backend/arch/Instruction_X86_64.cs: New file.
	(Instruction_X86_64): x86_64-specific part.

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.IsTrampolineAddress): New public method.
	(MonoLanguageBackend.GetTrampoline): FIXME:  temporarily broken.

2007-10-30  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture.cs
	(Architecture.Disassembler): New public property; only create one
	single disassembler per process.

	* backend/arch/Disassembler.cs
	(Disassembler.GetInstructionSize): Added `TargetMemoryAccess' argument.
	(Disassembler.DisassembleInstruction): Likewise.
	(Disassembler.DisassembleMethod): Likewise.

2007-10-30  Martin Baulig  <martin@ximian.com>

	* backend/ProcessServant.cs
	(ProcessServant.Architecture): New public property; only create
	one single `Architecture' instance per process.	

2007-10-29  Martin Baulig  <martin@ximian.com>

	* classes/TargetInfo.cs: New file.
	(TargetInfo): Moved here from TargetBinaryAccess.cs.
	(TargetMemoryInfo): New public class, derives from `TargetInfo'.
	(TargetInfo.AddressDomain): Moved this into `TargetMemoryInfo'.

2007-10-24  Martin Baulig  <martin@ximian.com>

	* backend/arch/Instruction.cs: New file.
	(Instruction): New internal abstract class.

	* backend/arch/X86_Instruction.cs: New file.
	(X86_Instruction): New internal class; implement `Instruction'
	here, we use this for both i386 and x86_64.

	* backend/arch/Architecture.cs
	(Architecture.DoGetCallTarget): Don't make this abstract;
	implement it here using the new `Instruction' class.

2007-10-16  Martin Baulig  <martin@ximian.com>

	* backend/ILanguageBackend.cs: Removed.
	(ILanguageBackend): Removed.

2007-10-16  Martin Baulig  <martin@ximian.com>

	* backend/ILanguageBackend.cs
	(NotificationType): Moved into MonoThreadManager.cs.

	* backend/MonoThreadManager.cs
	(NotificationType): Moved here from ILanguageBackend.cs.
	
2007-10-16  Martin Baulig  <martin@ximian.com>

	* backend/ILanguageBackend.cs
	(ILanguageBackend.GetTrampoline): Removed.

2007-10-16  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture.cs
	(Architecture.CallTargetType): Add `NativeTrampoline',
	`NativeTrampolineStart' and `MonoTrampoline'.
	(Architecture.GetCallTarget): Also check for trampolines here.
	(Architecture.GetTrampoline): Removed.

	* backend/ILanguageBackend.cs
	(ILanguageBackend.GetTrampolineAddress): Removed.

2007-10-15  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture.cs
	(Architecture.CallTargetType): New internal enum.
	(Architecture.GetCallTarget): Merge GetJumpTarget() and
	GetCallTarget() into a new GetCallTarget(); we now return a
	`CallTargetType'.	

2007-10-10  Martin Baulig  <martin@ximian.com>

	Fix the "field from parent class madness".

	* languages/TargetClassObject.cs
	(TargetClassObject.GetParentObject): Take a `TargetMemoryAccess'
	instead of a `Target' argument.

	* languages/mono/MonoClassObject.cs
	(MonoClassObject.GetParentObject): Disallow any implicit boxings.

	* frontend/Expression.cs
	(StructAccessExpression.FindMember): When searching in the parent
	class, also use the parent instance.

2007-10-09  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassInfo.cs
	(MonoClassInfo): Moved the implementations of GetField(),
	SetField(), GetStaticField() and SetStaticField() here from
	`MonoClassType'.

	* languages/mono/MonoClassType.cs
	(MonoClassType): Moved all the code dealing with fields into
	`MonoClassInfo'.	

2007-10-09  Martin Baulig  <martin@ximian.com>

	* languages/TargetMember.cs
	(TargetEnumInfo): New public abstract class.

	* languages/TargetEnumType.cs
	(TargetEnumType): Changed the type of `Value' and `Members' from
	`TargetFieldInfo' info `TargetEnumInfo'.

	* languages/mono/MonoClassType.cs
	(MonoClassType): No longer include the fields and methods from our
	parent class.  We now create our parent class on-the-fly when it's
	needed.	

2007-10-09  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassInfo.cs
	(MonoClassInfo.ClassType): New public property.
	(MonoClassInfo.GetParent): New public method; compute the parent
	on-the-fly when it's needed.

	* languages/mono/MonoClassObject.cs
	(MonoClassObject): The .ctor now takes a `MonoClassInfo' argument.
	(MonoClassObject.GetParentObject): Implement this here.

2007-10-05  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile.LookupClassInfo): Reload the symbol tables if we
	can't find the requested type and try again.

2007-10-05  Martin Baulig  <martin@ximian.com>

	* languages/TargetType.cs
	(TargetType.SetObject): `Thread' -> `TargetAccess'.

	* languages/TargetFundamentalObject.cs
	(TargetFundamentalObject.SetObject): `Thread' -> `TargetAccess'.

	* languages/TargetClassObject.cs
	(TargetClassObject.SetField): `Thread' -> `TargetAccess'.

	* languages/TargetArrayObject.cs
	(TargetArrayObject.SetElement): `Thread' -> `TargetAccess'.

2007-10-05  Martin Baulig  <martin@ximian.com>

	* classes/StackFrame.cs
	(Register.WriteRegister): `Thread' -> `TargetAccess'.

	* languages/TargetLocation.cs
	(TargetLocation.WriteBuffer): `Thread' -> `TargetAccess'.
	(TargetLocation.WriteAddress): Likewise.

	* backends/TargetAccess.cs
	(TargetAccess): Move `Mono.Debugger.Backends' -> `Mono.Debugger'.

2007-10-05  Martin Baulig  <martin@ximian.com>

	* languages/TargetObject.cs
	(TargetObject.GetAddress): `Thread' -> `TargetMemoryAccess'.

	* languages/TargetFundamentalObject.cs
	(TargetFundamentalObject.GetObject): `Thread' -> `TargetMemoryAccess'.

	* languages/TargetClassObject.cs
	(TargetClassObject.GetField): `Thread' -> `TargetMemoryAccess'.
	(TargetClassObject.GetCurrentObject): Likewise.

2007-10-05  Martin Baulig  <martin@ximian.com>

	* languages/TargetPointerObject.cs
	(TargetPointerObject.GetCurrentType): `Thread' -> `TargetMemoryAccess'.
	(TargetPointerObject.GetDereferencedObject): Likewise.
	(TargetPointerObject.GetArrayElement): Likewise.

	* languages/TargetObjectObject.cs
	(TargetObjectObject.GetClassObject): `Thread' -> `TargetMemoryAccess'.

2007-10-05  Martin Baulig  <martin@ximian.com>

	* languages/TargetObject.cs
	(TargetObject.GetDynamicSize): `Thread' -> `TargetMemoryAccess'.

	* languages/TargetLocation.cs
	(TargetLocation.ReadMemory): `Thread' -> `TargetMemoryAccess'.
	(TargetLocation.ReadBuffer): Likewise.

2007-10-05  Martin Baulig  <martin@ximian.com>

	* languages/TargetEnumType.cs
	(TargetEnumType.Value): Replaced by a GetValue() method.

	* languages/TargetType.cs
	(TargetType.GetObject): Added `TargetMemoryAccess' argument.
	(TargetType.DoGetObject): Likewise.

2007-10-02  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-linux-ptrace.c
	(_server_ptrace_check_errno): New static method; when `errno' is
	`ESRCH', check whether the target still exists to distinguish
	between `COMMAND_ERROR_NOT_STOPPED' and `COMMAND_ERROR_NO_TARGET'.

2007-10-02  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SingleSteppingEngine.ProcessEvent): Added new `dead' flag which
	is set when we receive `CHILD_EXITED' or `CHILD_SIGNALED'.
	(SingleSteppingEngine.IsAlive): Also check for `dead' and `killed'.

2007-10-02  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SingleSteppingEngine.Return): Create our own, local backtrace
	instead of using `current_backtrace'; limit the maximum number of
	frames to 2 since that's all we need here.

	* classes/Backtrace.cs
	(Backtrace.TryUnwind): Add sanity check to avoid 'loops'.

2007-09-28  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs
	(MonoDebuggerInfo.MinDynamicVersion): Require 61.

	* languages/mono/MonoRuntime.cs
	(MonoRuntime.ReadMonoMethod): New public static method.

2007-09-28  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoType.cs: Renamed into MonoRuntime.cs
	(MonoType): Renamed into `MonoRuntime'.

2007-09-28  Martin Baulig  <martin@ximian.com>

	* backend/arch/DwarfReader.cs
	(DwarfReader): Kill the `source_hash'; each source file may be
	used multiple times in different compilation units.

2007-09-28  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture_I386.cs
	(Architecture_I386.GetLMF): Make this work again.

2007-09-28  Martin Baulig  <martin@ximian.com>

	* backend/ProcessServant.cs
	(ProcessServant.read_thread_table): Truncate the `TID' to 32-bits
	on 32-bit machines.

2007-09-27  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.ReadMonoClass): Use
	MonoClassInfo.ReadMonoClass() to create the `MonoClassInfo', then
	create a `MonoClassType'.
	(MonoLanguageBackend.CreateClassInfo): Renamed into
	CreateCoreType(); create the MonoClassType here and not inside
	MonoClassInfo's .ctor.

	* languages/mono/MonoClassType.cs
	(MonoClassType.ReadClassType): Removed.

	* languages/mono/MonoClassInfo.cs
	(MonoClassInfo.ClassType): Removed.

2007-09-27  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoObjectType.cs
	(MonoObjectType): Replace the public .ctor with a static
	Create() method.

	* languages/mono/MonoOpaqueType.cs: Renamed into MonoVoidType.cs
	(MonoOpaqueType): Renamed into `MonoVoidType'.

2007-09-27  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoType.cs
	(MonoType.Read): Renamed into ReadType().
	(MonoType.ReadMonoClass): New public static method.

	* languages/mono/MonoObjectObject.cs
	(MonoObjectObject.GetCurrentType): Use MonoType.ReadMonoClass().

2007-09-27  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoFundamentalType.cs
	(MonoFundamentalType): Replace the public .ctor with a static
	Create() method.	

	* languages/mono/MonoStringType.cs
	(MonoStringType): Replace the public .ctor with a static
	Create() method.

2007-09-26  Wade Berrier  <wberrier@novell.com>

	* languages/native/Makefile.am:
	* languages/mono/Makefile.am:
	Glob .cs for EXTRA_DIST so these don't need updating anymore.

2007-09-26  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoFundamentalType.cs
	(MonoFundamentalType): The .ctor now takes a `MonoClassInfo'.

	* languages/mono/MonoClassType.cs
	(MonoClassType): Add a .ctor taking a `MonoClassInfo'; remove the
	one taking a `TargetAddress'.

2007-09-26  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassInfo.cs
	(MonoClassInfo): Read field offsets and methods on-the-fly when
	they're needed; this allows us to create a `MonoClassInfo' for
	classes which aren't initialized yet.
	(MonoClassInfo.FieldOffsets): Replaced by GetFieldOffsets().
	(MonoClassInfo.GetMethodAddress): Added `TargetMemoryAccess' arg.

2007-09-26  Martin Baulig  <martin@ximian.com>

	* languages/TargetFundamentalType.cs
	(TargetFundamentalType): Made this class abstract.
	(TargetFundamentalType.HasClassType): Don't implement this here.
	(TargetFundamentalType.ClassType): Likewise.

	* languages/native/NativeFundamentalType.cs: New file.
	(NativeFundamentalType): Derive from `TargetFundamentalType'.

	* languages/mono/MonoFundamentalType.cs
	(MonoFundamentalType): Implement `HasClassType' and `ClassType' here.

2007-09-25  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoTypeTable.ReadDataItem): Create a `token' -> `klass_address'
	hash table; don't actually read the class.
	(MonoSymbolFile.LookupClassInfo): New internal method; we now
	create the `MonoClassInfo' on-the-fly when it's needed.

2007-09-25  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassType.cs
	(MonoClassType.ResolveClass): Added `TargetMemoryAccess target'
	and `bool fail' arguments.

2007-09-25  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoDebuggerSupport.cs
	(MonoDebuggerSupport.GetLocalTypeFromSignature): Removed.

2007-09-25  Martin Baulig  <martin@ximian.com>

	* classes/Method.cs
	(Method.DeclaringType): Repaced by GetDeclaringType().

2007-09-25  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoMethod): Use the new MonoType.Read() to construct the
	variable's types from the `MonoType *'s provided by the runtime.

2007-09-25  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoType.cs: New file.
	(MonoTypeEnum): New static enum.
	(MonoType): New internal static class.

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.GetClass): Renamed into ReadMonoClass().

2007-09-25  Martin Baulig  <martin@ximian.com>

	* classes/TargetException.cs
	(TargetError): Add `MethodNotLoaded'.

2007-09-25  Martin Baulig  <martin@ximian.com>

	* classes/Method.cs
	(Method): Replace the `This', `Locals' and `Parameters' by methods
	which take a `TargetMemoryAccess' argument.  This is neccessary
	for generics.
	(Method.This): Replaced by GetThis().
	(Method.Parameters): Replaced by GetParameters().
	(Method.Locals): Replaced by GetLocalVariables().
	(Method.GetVariableByName): Removed.

	* classes/StackFrame.cs
	(StackFrame.Locals): Removed.

2007-09-24  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoLanguageBackend.cs
	(MonoDataTable): Made this abstract; create `DomainDataTable' and
	`MonoTypeTable' implementations.

2007-09-24  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoLanguageBackend.cs
	(MonoDataTable): Formerly known as `MonoLanguageBackend.DataTable'.
	(MonoLanguageBackend): Reflect latest runtime changes; we now have
	one type table per symbol file.

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile.TypeTable): New public property.

2007-09-21  Martin Baulig  <martin@ximian.com>

	* languages/TargetType.cs
	(TargetType.HasClassType): New public abstract property.
	(TargetType.ClassType): Likewise.

2007-09-17  Martin Baulig  <martin@ximian.com>

	* languages/TargetType.cs
	(TargetType): Renamed the abstract GetObject() into DoGetObject()
	and made it protected; added a new non-abstract GetObject() which
	just calls DoGetObject().

	* languages/TargetLocation.cs
	(TargetLocation): Made this class public; but removed all public
	API entry points from it.
	(TargetLocation.HasAddress): Made this internal.
	(TargetLocation.GetAddress): Likewise.

2007-09-11  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs
	(MonoMetadataInfo): Add `MonoMethodFlagsOffset' and
	`MonoMethodInflatedOffset'.	

2007-09-04  Martin Baulig  <martin@ximian.com>

	* frontend/CSharpExpressionParser.jay
	(member_name): New rule; support member names with generic arity.
	(variable_or_type_name_0): Use `member_name' instead of
	`IDENTIFIER' to allow names with generic arity.

	* languages/mono/MonoMember.cs
	(MonoMethodInfo): Include the generic arity in the method name.

	* languages/mono/MonoFunctionType.cs
	(MonoFunctionType): Include the generic arity in the method name.

2007-09-04  Martin Baulig  <martin@ximian.com>

	* backend/BreakpointManager.cs: Kill the `entry_hash'; only use
	the `index_hash'.

2007-09-03  Martin Baulig  <martin@ximian.com>

	*** Milestone: Appdomains are now fully functional ***

2007-09-03  Martin Baulig  <martin@ximian.com>

	Fix a race condition in the thread-lock code.

	* backend/SingleSteppingEngine.cs
	(SingleSteppingEngine.ReleaseThreadLock): If we have a `stop_event',
	don't process it here while we're called from the ProcessServant;
	added a new overloaded version of this function which is now
	called from the ThreadManager's event loop.

	* backend/ThreadManager.cs
	(ThreadManager.AddPendingEvent): New internal method; we're called
	from SingleSteppingEngine.ReleaseThreadLock(); just queue the
	event and process it next time we run the event loop.
	(ThreadManager.engine_thread_main): Check for pending events.

2007-09-03  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter.WaitAll): Don't stop if another than the current
	thread exited.

2007-09-03  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(SteppingCommand.DoExecute): Only switch threads if the new thread
	is alive.

2007-09-03  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(BreakCommand): Add new `lazy' argument to disable error checking.

	* test/testsuite/TestAppDomain-Module.cs:
	Insert a breakpoint on Hello.World(), which is dynamically loaded.

2007-09-03  Martin Baulig  <martin@ximian.com>

	User-visible change:
	- `run' no longer stops in main
	- there's a new `start' command which starts the target and stops
	  in main.

	* frontend/Command.cs
	(StartCommand): New command; start the target and stop in main.
	(RunCommand): Don't stop in main anymore.

2007-09-03  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SingleSteppingEngine.OnModuleLoaded): New internal method; check
	whether we need to activate any breakpoints and start an
	`OperationActivateBreakpoints' if neccessary.
	(OperationActivateBreakpoints): New operation.
	(OperationStart): Don't activate any breakpoints here; just call
	sse.OnModuleLoaded() and let the new `OperationActivateBreakpoints'
	do the job.

	* backend/ProcessStart.cs
	(ProcessStart.StopInMain): New public property.
	(ProcessStart.SetupApplication): We're called on exec() -> set
	`StopInMain' to false.	

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.Notification): Added `SingleSteppingEngine'
	argument; return a `bool' denoting whether or not to resume the
	target.

2007-08-24  Wade Berrier  <wberrier@novell.com>

	* backend/Makefile.am: Glob .cs for EXTRA_DIST so these don't
	need updating anymore.

2007-08-23  Martin Baulig  <martin@ximian.com>

	* test/src/IHelloInterface.cs: New file.
	* test/src/TestAppDomain-Hello.cs: New file.
	* test/src/TestAppDomain-Module.cs: New file.

	* test/testsuite/TestAppDomain-Module.cs: New test.

2007-08-22  Martin Baulig  <martin@ximian.com>

	* backend/arch/Bfd.cs
	(Bfd): Several bug fixes; mostly for core files.
	(Bfd.LookupLocalSymbol): New public method.
	(bfd.FindSection): New internal method.

	* backend/arch/BfdContainer.cs
	(BfdContainer.LookupLibrary): New public method.
	(BfdContainer.FindLibrary): New public method.

	* backend/arch/CoreFile.cs: Make this work again.

	* backend/arch/bfdglue.c
	(bfd_glue_get_errormsg): New public function.
	(bfd_glue_get_section_size): Removed the `raw_section' argument.

2007-08-22  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoLanguageBackend.cs: Reflect latest runtime
	changes; the method range entries are now stored on a per-domain
	basis and are free'ed when the domain gets unloaded.  Add support
	for unloading symbol files.

2007-08-22  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SSE.OnManagedThreadCreated): Remove the `tid' argument; this is
	now computed by the ThreadDB.
	(SSE.SetTID): New internal method; called by ThreadDB.
	(SSE.SetLMFAddress): Likewise.
	(SSE.OperationGetCurrentThread): Removed; we now use ThreadDB for this.

2007-08-22  Martin Baulig  <martin@ximian.com>

	* backend/ProcessServant.cs: Use the new `ThreadDB' interface if
	possible.  When attaching to a managed application, read the new
	thread table from the runtime.	

	* backend/ThreadDB.cs: New file. We now use glibc's `thread_db'
	library to get information about threads.

	* backend/server/thread-db.[ch]: New files.

	* backend/server/linux-proc-service.h: New file; copied from glibc.

2007-08-06  Wade Berrier  <wberrier@novell.com>

	* classes/Makefile.am:
	* languages/mono/Makefile.am:
	* languages/Makefile.am:
	Update filelists for new source files to fix 'make dist'
	Beautify listing

	* test/src/Makefile.am:
	Clean up list duplication, only build .cs files during 'make check'

2007-08-07  Martin Baulig  <martin@ximian.com>

	* backend/ILanguageBackend.cs (NotificationType): Add `DomainUnload'.

	* backend/BreakpointManager.cs
	(BreakpointManager.DomainUnload): New public method; remove all
	breakpoints from an appdomain.

	* backend/MonoThreadManager.cs
	(MonoThreadManager.HandleChildEvent): Added a new `DomainUnload'
	notification; we're called from the JIT before unloading an
	appdomain, call BreakpointManager.DomainUnload() to remove all its
	breakpoints.	

2007-08-06  Martin Baulig  <martin@ximian.com>

	* backend/TargetMemoryAccess.cs
	(TargetMemoryAccess.InsertBreakpoint): Return `void'.
	(TargetMemoryAccess.RemoveBreakpoint): Take a `BreakpointHandle',
	not an integer index.

	* backend/BreakpointManager.cs
	(BreakpointManager): Added a second hash table which maps
	breakpoint handles and appdomains into indices.
	(BreakpointManager.InsertBreakpoint): Added `int domain' argument.
	(BreakpointManager.RemoveBreakpoint): Take a `BreakpointHandle'
	instead of an integer index; remove all breakpoints in all
	appdomains.

	* classes/SourceLocation.cs
	(SourceLocation.ResolveBreakpoint): Remove the `domain' argument.

	* test/testsuite/TestAppDomain.cs: Remove the breakpoint instead
	of disabling it; this must remove it from all appdomains.

2007-08-06  Martin Baulig  <martin@ximian.com>

	* classes/Method.cs
	(Method.Domain): New public property.

2007-08-06  Martin Baulig  <martin@ximian.com>

	* backend/BreakpointManager.cs
	(BreakpointManager): Operate on `BreakpointHandle', not `Breakpoint'.

2007-08-06  Martin Baulig  <martin@ximian.com>

	* backend/TargetMemoryAccess.cs
	(TargetMemoryAccess.InsertBreakpoint): Make this internal.
	(TargetMemoryAccess.RemoveBreakpoint): Likewise.

	* classes/AddressBreakpoint.cs
	(AddressBreakpoint): Use `AddressBreakpointHandle'.

2007-08-01  Martin Baulig  <martin@ximian.com>

	* configure.in: Make sure the runtime is recent enough.

2007-08-01  Martin Baulig  <martin@ximian.com>

	* configure.in: Bump version number to 0.55.

2007-08-01  Martin Baulig  <martin@ximian.com>

	Merged the `debugger-dublin' branch.

2007-06-21  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-linux-ptrace.c
	(server_ptrace_read_memory): Moved the actual reading into
	_server_ptrace_read_memory(), just remove the breakpoints here.
	(_server_ptrace_read_memory): Like server_ptrace_read_memory(),
	but don't remove any breakpoints.

	* backend/server/x86-ptrace.c
	(server_ptrace_write_memory): Use _server_ptrace_read_memory().

2007-06-21  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs
	(MonoDebuggerInfo.MaxDynamicVersion): Allow 59 here; keep
	`MinDynamicVersion' at 58.  The new `debugger-dublin' branch uses
	59, but it's backwards-compatible.

2007-07-31  Martin Baulig  <martin@ximian.com>

	* test/src/TestAppDomain.cs: New test.
	* test/testsuite/TestAppDomain.cs: New test.

2007-07-31  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture_X86_64.cs
	(Architecture_X86_64.GetJumpOrCallTarget): New private method; fix
	and improve GetCallTarget() and also add support for jump
	instructions.

	* backend/SingleSteppingEngine.cs
	(SingleSteppingEngine.OperationNativeTrampoline): New operation;
	keep stepping while we're in the trampoline like `finish -native'.

2007-07-30  Martin Baulig  <martin@ximian.com>

	* languages/TargetLocation.cs
	(TargetLocation.Address): Replaced by GetAddress().
	(TargetLocation.GetAddress): New public function; replaces the
	`Address' property.
	(TargetLocation.GetDereferencedTargetLocation): Removed the
	`Thread' argument; returns a `DereferencedTargetLocation'.

	* languages/TargetObject.cs
	(TargetObject.Address): Replaced by GetAddress().
	(TargetObject.GetAddress): New public function; replaces the
	`Address' property.
	(TargetObject.IsNull): Removed.

2007-07-30  Martin Baulig  <martin@ximian.com>

	* test/testsuite/testnativetypes.cs: New test.
	* test/src/testnativetypes.c: New test.

2007-07-30  Martin Baulig  <martin@ximian.com>

	* languages/DeferencedTargetLocation.cs: New file.

2007-07-28  Martin Baulig  <martin@ximian.com>

	* backend/arch/DwarfReader.cs: Almost completely redesign the line
	number table; it's no longer based on methods and now also works
	with newer versions of gcc and g++.

2007-07-28  Martin Baulig  <martin@ximian.com>

	* classes/SourceLocation.cs
	(SourceLocation): Add a .ctor which takes a `SourceFile' in
	addition to a `MethodSource'.

2007-07-27  Martin Baulig  <martin@ximian.com>

	* classes/LineNumberTable.cs
	(LineNumberTable): Made Lookup() and DumpLineNumbers() abstract;
	move the actual implementation into MonoSymbolFile.cs and
	DwarfReader.cs.	

2007-07-27  Martin Baulig  <martin@ximian.com>

	* classes/LineNumberTable.cs
	(LineNumberTable.Name): Removed.
	(LineNumberTable.Module): Removed.

2007-07-27  Martin Baulig  <martin@ximian.com>

	* classes/SourceAddress.cs
	(SourceAddress.Null): Removed.
	(SourceAddress.LineNumberTable): Removed.
	(SourceAddress.SourceBuffer): New public property.

	* classes/LineNumberTable.cs
	(LineNumberTable.IsDynamic): Removed.
	(LineNumberTable.SourceBuffer): Removed.

2007-07-27  Martin Baulig  <martin@ximian.com>

	* classes/MethodSource.cs
	(MethodSource.IsDynamic): New public property.
	(MethodSource.HasSourceCode): Renamed into `HasSourceFile'.
	(MethodSource.HasSourceBuffer): New public property.
	(MethodSource.SourceBuffer): New public property.

	* classes/AssemblerMethod.cs
	(AssemblerMethod): Derive from `MethodSource', not
	`LineNumberTable'.

	* classes/Method.cs
	(Method.HasSourceFile): Removed.
	(Method.SourceFile): Removed.

	* languages/mono/MonoSymbolFile.cs
	(WrapperMethod): Also create a MethodSource for wrappers.

2007-07-26  Martin Baulig  <martin@ximian.com>

	* classes/SourceAddress.cs
	(SourceAddress.Location): Removed.
	(SourceAddress.SourceFile): New public property.

	* classes/LineNumberTable.cs
	(LineNumberTable): Removed `MethodSource', `Addresses',
	`StartRow', `EndRow' and `GetNamespaces()'.

	* classes/Method.cs
	(Method.HasSource): New public property.
	(Method.MethodSource): New public property.
	(Method.GetNamespaces): New public method.
	(Method): Removed `StartRow' and `EndRow'; get them from the
	`MethodSource' instead.

2007-07-20  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoFundamentalType.cs: New file.
	(MonoFundamentalType): New type.

	* languages/mono/MonoStringType.cs
	(MonoStringType): Derive from `MonoFundamentalType'.

	* languages/mono/MonoObjectType.cs
	(MonoObjectType): Create the MonoClassType in the .ctor.

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile.LookupMonoClass): New public method; calls
	LookupMonoType() and then returns a `MonoClassType', this also
	works for fundamental types.

	* languages/mono/MonoLanguageBackend.cs
	(MonoBuiltinTypeInfo): Use the new `MonoFundamentalType'.

2007-06-28  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs
	(MonoDebuggerInfo): Reflect latest runtime changes; add the new
	`DebuggerVersion' field.

2007-06-04  Martin Baulig  <martin@ximian.com>

	* classes/Thread.cs
	(Thread.CallMethod (long,string)): Added second `long' argument
	so we can now pass a long value in addition to the string to the
	target.

	* backends/Inferior.cs
	(Inferior.CallMethod (long,string)): Added second `long' argument
	so we can now pass a long value in addition to the string to the
	target.

	* backends/server/server.h
	(mono_debugger_server_call_method_1): Added `guint64 data_arg'
	argument.

2007-06-04  Martin Baulig  <martin@ximian.com>

	Replace `SourceMethod' with a new abstract `MethodSource'.

	* classes/MethodSource.cs: New file.
	(MethodSource): New public abstract class.

	* classes/SourceInfo.cs
	(SourceMethod): Removed; we now use the new `MethodSource'.

	* classes/Module.cs
	(Module.LookupMethod): Removed; use FindMethod() instead.
	(Module.RegisterLoadHandler): Removed.

2007-05-29  Wade Berrier  <wberrier@novell.com>

	* classes/Makefile.am: fix make dist (remove MethodSource.cs)

2007-05-29  Martin Baulig  <martin@ximian.com>

	* classes/Method.cs
	(Method.StartRow, Method.EndRow): New public properties.  Only
	valid when `HasSourceFile' is true.

2007-05-29  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter.SourceFileFactory): New public property; moved the
	`SourceFileFactory' from the backend to the frontend.

	* frontend/Interpreter.cs
	(Interpreter.ReadFile): New public method.

	* classes/Method.cs
	(Method.HasSourceFile): New public property.
	(Method.SourceFile): New public property.

	* classes/Process.cs
	(Process.SourceFileFactory): Removed.

	* backend/ProcessServant.cs
	(ProcessServant.SourceFileFactory): Removed.

2007-05-29  Martin Baulig  <martin@ximian.com>

	* classes/MethodSource.cs: Renamed into LineNumberTable.cs
	(MethodSource): Renamed into `LineNumberTable'.

	* classes/Method.cs
	(Method.HasSource): Renamed into `HasLineNumbers'.
	(Method.Source): Renamed into `LineNumberTable'.

2007-05-23  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(SourceCommand.FindFile): Don't do a method lookup here.
	(ListCommand.DoExecute): We can now list source locations outside
	methods.	

2007-05-16  Martin Baulig  <martin@ximian.com>

	* classes/SourceLocation.cs
	(SourceLocation.FunctionBreakpointHandle): Moved into
	BreakpointHandle.cs and made internal.

	* backend/BreakpointHandle.cs
	(FunctionBreakpointHandle): New internal class.

2007-05-16  Martin Baulig  <martin@ximian.com>

	* classes/Breakpoint.cs
	(Breakpoint.Resolve): New abstract internal method.

	* classes/SourceLocation.cs
	(SourceLocation.InsertBreakpoint): Renamed into
	ResolveBreakpoint(); don't take a `Thread' argument.  You need to
	call Insert() on the returned `BreakpointHandle' to actually
	insert the breakpoint.

	* backend/BreakpointHandle.cs
	(BreakpointHandle.Insert): New public abstract method; we need to
	call this to actually insert the breakpoint.
	(AddressBreakpointHandle): New internal class.

2007-05-09  Martin Baulig  <martin@ximian.com>

	Released version 0.50 "Dublin" of the Mono Debugger :-)

	* configure.in: Require Mono >= 1.2.4.

2007-05-14  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.symbol_files): Make this a Hashtable instead
	of an ArrayList; don't store any null's in the list.

2007-05-14  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture_I386.cs
	(Architecture_I386.GetLMF): Correctly set ebp.

	* backend/arch/Architecture_X86_64.cs
	(Architecture_X86_64.GetLMF): Correctly set rbp.

2007-05-09  Martin Baulig  <martin@ximian.com>

	* frontend/ObjectFormatter.cs
	(ObjectFormatter.FormatEnum): Sort the keys alphabetically.

2007-05-09  Martin Baulig  <martin@ximian.com>

	* test/testsuite/NUnit.cs (TestSuite.Compile): Don't take a
	filename argument; use the `FileName' and `ExeFileName' and pass
	the output filename to mcs to make things work with
	srcdir != builddir.

2007-05-09  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassInfo.cs
	(MonoClassInfo.GenericClass): New public field.
	(MonoClassInfo.GenericContainer): Likewise.

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.GetClassInfo): Don't add generic classes to
	the type hash.

2007-05-09  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerOptions.cs
	(DebuggerOptions.ParseCommandLine): Warn about unknown arguments.

2007-05-08  Martin Baulig  <martin@ximian.com>

	The new ObjectFormatter :-)

	This has two major user-visible changes:
	- When printing a class, we now include fields from the parent type.
	- When printing a variable, we use the actual type of the object
	rather than just using the variable type.

	* classes/Style.cs (StructFormatter): Removed; this has been
	replaced by the new ObjectFormatter.

	* frontend/Expression.cs
	(Expression.DoEvaluateObject): Get the "real" type of a class
	object instead of just using the variable type.
	(BaseExpression.DoEvaluateObject): We need to override this and
	use the variable type.

	* frontend/ObjectFormatter.cs: New file.
	(ObjectFormatter): New public class.

	* frontend/Style.cs: Use the new ObjectFormatter.

2007-05-08  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassType.cs
	(MonoClassType.GetCurrentObject): Unbox the object if necessary.

	* languages/mono/MonoClassObject.cs
	(MonoClassObject.GetParentObject): Ensure that `type.IsByRef'.

2007-05-02  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassInfo.cs
	(MonoClassInfo): Completely redesigned this; we now construct the
	`MonoClassInfo' when reading the symbol tables and it replaces the
	`ClassEntry' in the symbol table.  This means that we don't have
	to do any target access when actually using the class.

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.read_class_entry): Read all the data from the
	target and construct the `MonoClassInfo' here, so we don't have to
	make any target access when actually using the class.

	* languages/mono/MonoClassObject.cs
	(MonoClassObject): We now keep a reference to our `MonoClassType',
	not our `MonoClassInfo'.

2007-04-18  Martin Baulig  <martin@ximian.com>

	Reimplement displays; integrate them with the session code and use
	the new expression parser.

	* classes/Display.cs: New file.
	(Display): New public class.

	* classes/DebuggerSession.cs
	(DebuggerSession): Add displays to the session.

	* frontend/Displays.cs: Removed.

	* frontend/Command.cs
	(DisplayCommand): Derive from `DebuggerCommand'.
	(UndisplayCommand): Likewise.

	* frontend/Expression.cs
	(ExpressionParser.EvaluateExpression): New public method.

	* frontend/Interpreter.cs
	(Interpreter): Displays are now in the `DebuggerSession'.

2007-04-17  Martin Baulig  <martin@ximian.com>

	* classes/ExpressionBreakpoint.cs
	(ILocationParser): Moved to DebuggerSession.cs and renamed into
	`IExpressionParser'.	

	* classes/DebuggerSession.cs
	(LocationType): Moved here from ExpressionBreakpoint.cs.
	(IExpressionParser): Formerly known as `ILocationParser'.

	* frontend/Expression.cs: Merge `ExpressionParser' and
	`LocationParser'.	

2007-04-17  Martin Baulig  <martin@ximian.com>

	* frontend/IExpressionParser.cs: Removed.

	* frontend/CSharpExpressionParser.jay: We don't need a
	`ScriptingContext' here; allow reusing the parser to parse
	multiple expressions.

	* frontend/Expression.cs
	(ExpressionParser): New public class.

	* frontend/Interpreter.cs
	(Interpreter.ExpressionParser): New public property.

2007-04-17  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter): Remove support for multiple parser languages; this
	was never used and we only supported "c#" anyways.

2007-04-04  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(BacktraceCommand.DoExecute): If we already have a backtrace and
	no arguments were given, reuse it.

2007-03-28  Jb Evain  <jb@nurv.fr>

	* frontend/Command.cs: Rename PrintFrameCommand to SelectFrameCommand.
	and make it able to select the current frame.

2007-03-14  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile.MonoMethod.GetTypeSignature): Add support for
	byref types and arrays.

2007-03-13  Miguel de Icaza  <miguel@novell.com>

	* languages/mono/MonoLanguageBackend.cs: The main assembly might
	not have symbols, we should not crash in that case. 

2007-03-08  Wade Berrier  <wberrier@novell.com>

	* classes/Makefile.am: added new files to fix make dist, 
	beautified listing

2007-03-08  Martin Baulig  <martin@ximian.com>

	* api/: Removed unused directory.

2007-03-08  Massimiliano Mantione  <massi@ximian.com>

	* frontend/Command.cs: Added "[un]display" and enhanced "examine".
	* frontend/Style.cs: In StyleCLI.TargetStopped, added code to
	show displays to the user.
	* frontend/Displays.cs: Implemented displays.
	* frontend/Interpreter.cs: Added the collection of displays to
	the interpreter instance.
	* build/Makefile.am, frontend/Makefile.am: added Displays.cs

2007-03-06  Martin Baulig  <martin@ximian.com>

	* test/testsuite/TestSession.cs: Add a new testcase.

2007-03-06  Martin Baulig  <martin@ximian.com>

	* classes/Debugger.cs
	(Debugger.MainProcessCreatedEvent): New public event.

	* backend/ProcessServant.cs
	(ProcessServant.Initialize): Fire a `MainProcessCreatedEvent' when
	creating the main process.

	* test/testsuite/NUnit.cs
	(TestSuite.Start): New public method; use this instead of
	`Interpreter.Start()'.
	(TestSuite.LoadSession): Likewise.
	(TestSuite.Attach): Likewise.

	* test/testsuite/*.cs: Use our parent class'es Start(),
	LoadSession() and Attach() methods instead directly calling them
	on the `Interpreter'.

	* test/testsuite/TestSession.cs: Add a new testcase.

2007-03-05  Martin Baulig  <martin@ximian.com>

	* classes/ExpressionBreakpoint.cs: New file.
	(ExpressionBreakpoint.LocationType): Moved here from
	frontend/Expression.cs.	

	* classes/DebuggerSession.cs
	(DebuggerSession.ctor): Added `ILocationParser parser' argument.
	(DebuggerSession.ParseLocation): New internal method.
	(DebuggerSession.InsertBreakpoint): Added overloaded version
	taking a `LocationType' and a `string'.

	* frontend/Expression.cs
	(LocationParser): New public class.

	* frontend/Command.cs
	(BreakCommand): Completely rewrote this; we can now insert
	breakpoints before the target is started.

2007-02-28  Martin Baulig  <martin@ximian.com>

	* test/testsuite/TestBreakpoint.cs: Add a test for inserting
	breakpoints by filename.

2007-02-28  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerSession.InsertBreakpoint): Don't take a `Thread' argument
	when inserting a breakpoint on a `SourceLocation' and don't
	activate it.  This allows us to insert such breakpoints before the
	target is started.

	* frontend/Interpreter.cs
	(Interpreter.InsertBreakpoint): Removed; call
	DebuggerSession.InsertBreakpoint() directly.

	* frontend/Command.cs
	(TestCommand): Temporary hack.

2007-02-28  Martin Baulig  <martin@ximian.com>

	* backend/ProcessStart.cs
	(ProcessStart..ctor): Set `options.WorkingDirectory' if null.

	* classes/Process.cs
	(Process.FindFile): Correctly implement this.
	(Process.FindLocation): Removed; use FileFile() instead.

2007-02-28  Martin Baulig  <martin@ximian.com>

	* classes/Process.cs
	(Process.GetFullPath): Removed; use FindFile() instead.

2007-02-28  Martin Baulig  <martin@ximian.com>

	* classes/SourceInfo.cs
	(SourceFile.FindMethod): New public method.

	* classes/Process.cs
	(Process.FindFile): New public method.

	* classes/Module.cs
	(Module.FindFile): New public method.

	* classes/SourceLocation.cs
	(SourceLocation): Allow file-line locations.

2007-02-27  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(BreakpointEnableCommand, BreakpointDisableCommand): Also activate
	and deactivate the breakpoint if we have a target.

2007-02-27  Martin Baulig  <martin@ximian.com>

	* classes/Process.cs
	(Process.GetFullPath): New public method; moved here from the
	`ScriptingContext'.

	* frontend/ScriptingContext.cs
	(ScriptingContext.GetFullPath): Moved into `Process'.
	(ScriptingContext.GetFullPathByFilename): Removed.

2007-02-27  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(ShowCommand): Make `show events' and alias for `show breakpoints'.

2007-02-27  Martin Baulig  <martin@ximian.com>

	* classes/Event.cs
	(Event.Enable): Renamed to `Activate' and made public.
	(Event.Disable): Renamed to `Deactivate' and made public.
	(Event.IsEnabled): New public abstract property.

2007-02-23  Martin Baulig  <martin@ximian.com>

	* classes/ExceptionCatchPoint.cs
	(ExceptionCatchPoint): Make this persistent.

2007-02-22  Martin Baulig  <martin@ximian.com>

	* classes/Event.cs
	(Event.IsPersistent): New public property.

	* classes/Breakpoint.cs
	(Breakpoint): Make this class abstract and split the functionality
	into `SourceBreakpoint' and `AddressBreakpoint'.

	* classes/SourceBreakpoint.cs: New file.
	(SourceBreakpoint): New public class.

	* classes/AddressBreakpoint.cs: New file.
	(AddressBreakpoint): New public class.

2007-02-22  Martin Baulig  <martin@ximian.com>

	* classes/Event.cs
	(EventType): Added `Breakpoint', `WatchRead' and `WatchWrite'.
	(Event.Type): New public property.

	* classes/Breakpoint.cs
	(HardwareWatchType): New public enum.
	(BreakpointType): Removed; use `EventType' instead.

	* classes/Thread.cs
	(Thread.AddEventHandler): Removed the `EventType' argument.

	* backends/ThreadServer.cs
	(ThreadServant.AddEventHandler): Likewise.

2007-02-22  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoLanguageBackend.cs: Don't crash if we can't
	find a symbol file.

2007-02-20  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerSession): Store the main process internally and use it's
	main thread when removing events.
	(DebuggerSession.DeleteEvent): Removed the `Thread' argument.

	* frontend/Command.cs
	(EventHandleCommand): Derive from `DebuggerCommand', not
	`ThreadCommand'; the "enable", "disable" and "delete" commands now
	longer require a thread to operate on - it's now also possible to
	enable/disable or delete events after the target exited.

2007-02-20  Martin Baulig  <martin@ximian.com>

	* classes/Event.cs
	(Event.Breaks): Check `IsEnabled' as well.
	(Event.Enable, Event.Disable): Make these methods internal; modify
	the `IsEnabled' property instead.

	* classes/DebuggerSession.cs
	(DebuggerSession.InsertBreakpoint): Also enable the breakpoint by
	calling the now internal `Event.Enable ()'.
	(DebuggerSession.InsertHardwareWatchPoint): Likewise.
	(DebuggerSession.InsertExceptionCatchPoint): Likewise.

	* backend/SingleSteppingEngine.cs
	(SingleSteppingEngine): Check whether a breakpoint is actually enabled.

2007-02-16  Martin Baulig  <martin@ximian.com>

	Session changes: keep the `DebuggerSession' in memory between
	different invocations of the same target; this allows us to modify
	breakpoints before starting the target.

	* classes/DebuggerSession.cs
	(DebuggerSession.SessionData): Removed the nested class.

	* classes/Event.cs
	(Event.IsEnabled): Added a setter for this property.

	* classes/SourceLocation.cs
	(SourceLocation): Splitted into `SourceLocation' and
	`DynamicSourceLocation'; the `SourceLocation' can now persist
	across different invocations of the same target.

2007-02-13  Martin Baulig  <martin@ximian.com>

	* test/testsuite/NUnit.cs: Run the tests in the invariant culture;
	fixes #80360.

2007-02-12  Martin Baulig  <martin@ximian.com>

	* configure.in: Require Mono >= 1.2.3.

2007-02-08  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs (Interpreter.WaitAll): Fix another bug.

2007-02-08  Martin Baulig  <martin@ximian.com>

	Distinguish between normal stopping and receiving a SIGSTOP in the
	backend.

	* backend/server/x86-arch.h
	(ChildStoppedAction): Added `STOP_ACTION_INTERRUPTED'; renamed
	`STOP_ACTION_SEND_STOPPED' to `STOP_ACTION_STOPPED'.

	* backend/server/server.h
	(ServerStatusMessageType): Added `MESSAGE_CHILD_INTERRUPTED'.

	* backend/Inferior.cs
	(Inferior.ChildEventType): Added `CHILD_INTERRUPTED'.

	* backend/SingleSteppingEngine.cs: Handle `CHILD_INTERRUPTED'
	separately; we now distinguish between stopped normally (hitting a
	breakpoint, receiving a notification etc.) or being stopped by a
	SIGSTOP.

	* classes/TargetEvent.cs
	(TargetEventType): Added `TargetInterrupted'.	

2007-02-01  Miguel de Icaza  <miguel@novell.com>

	* frontend/Command.cs: Make it so "list -" works.

2007-02-01  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs: Fix a race condition: if we hit
	a breakpoint and a stop has been requested at the same time, check
	the breakpoint handler first and report `TargetStopped' instead of
	`TargetHitBreakpoint' if the handler told us to resume.

2007-02-01  Martin Baulig  <martin@ximian.com>

	* interface/Report.cs
	(ReportWriter.PrintToConsole): New public property.
	(ReportWriter.Print): Also print to the console if we have a
	logfile and `PrintToConsole' is true.  We use this for the test
	suite to suppress output to the console.

2007-01-30  Martin Baulig  <martin@ximian.com>

	* languages/Language.cs
	(Language.ArrayType): New public property.

	* languages/TargetArrayObject.cs
	(TargetArrayObject.HasClassObject): New public abstract property.
	(TargetArrayObject.GetClassObject): New public abstract method.

	* frontend/Expression.cs
	(Convert.ToClassObject): Handle `TargetArrayObject' -> `TargetClassObject'.
	(Convert.ToClassType): Handle `TargetArrayType' -> `TargetClassType'.

	* test/testsuite/TestManagedTypes.cs: Add tests for that.

2007-01-30  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs
	(StructAccessExpression.GetField): Add support for consts.

	* frontend/Style.cs
	(StyleCLI.FormatMember): Add support for consts.

2007-01-29  Martin Baulig  <martin@ximian.com>

	* test/testsuite/NUnit.cs
	(TestSuite.Compile): New public method to trigger a mcs compilation.
	(TestSuite.OnTargetOutput): Don't call our base method; ie. we
	don't want to print the text to the console.

	* test/testsuite/TestSession.cs: New test.
	* test/src/TestSession.cs: Source file for it.

2007-01-29  Martin Baulig  <martin@ximian.com>

	* build/AssemblyInfo.cs.in (BuildInfo.mcs): New public property.

2007-01-29  Martin Baulig  <martin@ximian.com>

	* interface/Report.cs (Report.Print): Only print to the `writer'.
	(Report.Errort): Likewise.

2007-01-29  Martin Baulig  <martin@ximian.com>

	* backend/server/x86-ptrace.c
	(server_ptrace_spawn): Use mono_domain_get() instead of
	mono_get_root_domain() to execute the callback in the correct domain.

2007-01-29  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile.ctor): Do the GUID check here rather than passing
	an assembly to C.MonoSymbolFile's .ctor.

2007-01-25  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SingleSteppingEngine.Stop): Check whether a stop has already been
	requested.	

2007-01-25  Martin Baulig  <martin@ximian.com>

	* build/Makefile.am
	(check-local): Set LD_LIBRARY_PATH to build/server/.libs.

2007-01-24  Wade Berrier  <wberrier@novell.com>

	* backend/server/Makefile.am: remove deleted files to fix make dist

2007-01-24  Martin Baulig  <martin@ximian.com>

	* test/testsuite/TestMultiThread.cs: Improved the test.

2007-01-24  Martin Baulig  <martin@ximian.com>

	* backend/server/i386-win32.[ch]: Removed old code.
	* backend/server/powerpc-arch.[ch]: Likewise.
	* backend/server/powerpc-darwin.[ch]: Likewise.
	* backend/server/x86-freebsd-ptrace.[ch]: Likewise.

2007-01-24  Martin Baulig  <martin@ximian.com>

	* test/testsuite/NUnit.cs (TestSuite..cctor): Call
	Report.Initialize() in the .cctor rather than in the .ctor to
	avoid a sharing violation on the logfile.

2007-01-23  Martin Baulig  <martin@ximian.com>

	* test/testsuite/TestMultiThread.cs: New test.
	* test/src/TestMultiThread.cs: New test.

2007-01-23  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter.WaitAll): Store the threads in a Hashtable instead of
	an ArrayList and only start each thread once.

2007-01-23  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SingleSteppingEngine.ProcessOperation): Queue the operation and
	start it later if we're currently thread-locked.
	(SingleSteppingEngine.ReleaseThreadLockDone): New internal method.

	* backend/ProcessServant.cs
	(ProcessServant.ReleaseGlobalThreadLock): Call
	ReleaseThreadLockDone() on each SSE after releasing the mutex to
	start queued operations.

2007-01-19  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(SingleSteppingEngine.IsStopped): Check whether the engine is
	stopped rather than using the Inferior's TargetState.

	* classes/Thread.cs
	(Thread.IsStopped): Use `servant.IsStopped' rather than relying on
	the `TargetState'.

2007-01-19  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration.BrokenThreading): New public property;
	enabled by default.

	* frontend/Interpreter.cs
	(Interpreter.RuntimeInvoke): New public method; use WaitAll() is
	`DebuggerConfiguration.BrokenThreading' is set.

2007-01-19  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoLanguageBackend.cs: Don't crash if we don't
	have a symbol table.  This might happen if we for instance attach
	to a mono process which is running without --debug.

2007-01-19  Martin Baulig  <martin@ximian.com>

	* classes/Backtrace.cs
	(Backtrace.Mode): New public enum.
	(Backtrace.GetBacktrace): Added `Mode mode' argument.

	* classes/Thread.cs
	(Thread.GetBacktrace): Added `Backtrace.Mode mode' argument.

	* frontend/Command.cs
	(BacktraceCommand): Added `-managed' and `-native' arguments.

2007-01-17  Martin Baulig  <martin@ximian.com>

	* classes/Backtrace.cs
	(Backtrace.GetBacktrace): Make this internal and take a
	`ThreadServant'.
	(Backtrace.TryUnwind): Likewise.
	(Backtrace.TryUnwind): If we're in unmanaged code and don't have
	any source info, use the LMF to get back to managed land.

2007-01-17  Martin Baulig  <martin@ximian.com>

	* backend/arch/Architecture.cs
	(Architecture.GetLMF): New internal method.

2007-01-17  Martin Baulig  <martin@ximian.com>

	* classes/Thread.cs
	(Thread.LMFAddress): New internal property.

	* backend/ThreadServant.cs
	(ThreadServant.Process): New internal property.

	* classes/TargetBinaryReader.cs
	(TargetBinaryReader.ReadTargetAddress): New public method.

2007-01-17  Martin Baulig  <martin@ximian.com>

	* languages/Language.cs
	(Language.IsManaged): New public property.

2007-01-17  Martin Baulig  <martin@ximian.com>

	* backend/ThreadServant.cs
	(ThreadServant.LMFAddress): New public property.

	* backend/SingleSteppingEngine.cs
	(SingleSteppingEngine.OperationGetLMFAddress): New operation.
	(SingleSteppingEngine.OperationStart): Push
	OperationGetLMFAddress() to get the LMF on startup.
	(SingleSteppingEngine.OperationInitialize): Likewise.

2007-01-16  Martin Baulig  <martin@ximian.com>

	* test/testsuite/: Updated the testsuite to reflect the latest
	threading changes.	

2007-01-16  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter.CheckLastEvent): New method.
	(Interpreter.WaitAll): Correctly implement this.

2007-01-16  Martin Baulig  <martin@ximian.com>

	* classes/Thread.cs (Thread.Flags): Added `AutoRun'.
	(Thread.AutoStop): New public method.

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration.StayInThread): New public property.

	* backend/SingleSteppingEngine.cs: Correctly handle stop requests.

2007-01-03  Martin Baulig  <martin@ximian.com>

	* classes/Thread.cs (Thread.Flags): New public enum.
	(Thread.ThreadFlags): New public property.
	(Thread.IsAlive): New public property.
	(Thread.IsDaemon): Removed.
	(Thread.Continue): Removed the `is_background' argument.
	(Thread.Background): New public method.

2006-12-29  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter.IsSynchronous): Removed.
	(Interpreter.WaitAll): New public method.

	* frontend/Command.cs
	(SteppingCommand): More work on the threading stuff.

2006-12-29  Martin Baulig  <martin@ximian.com>

	* classes/Thread.cs
	(Thread): Make all the stepping operations return a
	`ThreadCommandResult' instead of a `CommandResult'.
	(Thread.GetLastTargetEvent): Renamed from `LastTargetEvent' and
	made it a function.
	(Thread.IsRunning): New public property.

2006-12-28  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs
	(MonoDebuggerInfo): Added `GetLMFAddress'.

2006-12-28  Martin Baulig  <martin@ximian.com>

	* classes/Process.cs
	(Process): Replaced the `Threads' property with a GetThreads()
	method.

2006-12-28  Martin Baulig  <martin@ximian.com>

	* classes/Thread.cs
	(Thread.LastTargetEvent): New public property.
	(CommandResult.Abort): New public method.

	* backend/ThreadServant.cs
	(ThreadServant.LastTargetEvent): New public property.

2006-12-28  Martin Baulig  <martin@ximian.com>

	* backend/SingleSteppingEngine.cs
	(Operation): Store the `SingleSteppingEngine' inside the
	`Operation', so we don't need to pass it around as a parameter.

2006-12-22  Martin Baulig  <martin@ximian.com>

	* backend/MonoThreadManager.cs: The `mono' binary now contains a
	pointer to the `MONO_DEBUGGER__debugger_info' in a special
	`.mdb_debug_info' section - this also works when the binary is
	stripped.	

2006-12-21  Martin Baulig  <martin@ximian.com>

	Change Ctrl-C semantics: abort the current operation on Ctrl-C.

	* frontend/Main.cs
	(CommandLineInterpreter.command_thread_main): Don't abort the main
	thread on Ctrl-C; we still do it the second time the user hits
	Ctrl-C as a fallback.

	* frontend/Interpreter.cs
	(Interpreter.Wait): Check whether the operation was interrupted by
	Ctrl-C and stop the thread if neccessary.

	* frontend/Command.cs: Use the new RuntimeInvoke API.

2006-12-21  Martin Baulig  <martin@ximian.com>

	* classes/Thread.cs
	(Thread.StepCommandResult): Renamed to `ThreadCommandResult' and
	made public.
	(RuntimeInvokeResult): New public class; derives from `CommandResult'.
	(Thread.RuntimeInvoke): Make this non-blocking and return a
	`RuntimeCommandResult'; removed the other overloaded version.

2006-12-21  Martin Baulig  <martin@ximian.com>

	* configure.in: Bump version number to 0.35 for the SVN version;
	the next release will be 0.40 "Bonn".

2006-11-15  Martin Baulig  <martin@ximian.com>

	Released version 0.31 "Ehrenbreitstein" of the Mono Debugger :-)

2006-11-14  Wade Berrier  <wberrier@novell.com>

	* ChangeLog: bump version for 0.31 tag

2006-11-10  Martin Baulig  <martin@ximian.com>

	* build/Makefile.am: Don't remove Mono.Debugger.Cecil.dll.

	* build/Mono.Debugger.Cecil.dll: Upgrade to Cecil 0.4.3.

2006-11-10  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoLanguageBackend.cs: Don't crash if a symbol
	file occurs twice in the list.

2006-11-10  Martin Baulig  <martin@ximian.com>

	* classes/Debugger.cs: Don't use another appdomain for the server.

2006-11-09  Wade Berrier  <wberrier@novell.com>

	* build/Makefile.am:
	* classes/Makefile.am:
	* frontend/libedit/Makefile.am:
	* interface/Makefile.am:
	 Add/remove source files to filelistings to fix make dist

2006-10-25  Martin Baulig  <martin@ximian.com>

	* build/: Rename the current `Mono.Debugger.dll' into
	`Mono.Debugger.Backend.dll' and create a new `Mono.Debugger.dll'.

	* classes/TargetAddress.cs: Moved to ../interface.

	* classes/AddressDomain.cs: Moved to ../interface.

	* classes/Report.cs: Moved to ../interface.

2006-10-25  Martin Baulig  <martin@ximian.com>

	* classes/AddressDomain.cs
	(AddressDomain): Don't make this byref; add [Serializable]
	attribute and make the .ctor take the id as argument.

2006-10-25  Martin Baulig  <martin@ximian.com>

	* interfaces: Renamed to interface.

2006-10-25  Martin Baulig  <martin@ximian.com>

	* interfaces/ISymbolTable.cs: Moved to ../classes/.

	* interfaces/ITargetNotification.cs: Moved to ../classes/.

2006-10-25  Martin Baulig  <martin@ximian.com>

	* jay/: Moved to frontend/jay/.

2006-10-25  Martin Baulig  <martin@ximian.com>

	* arch/: Moved to backend/arch.

2006-10-25  Martin Baulig  <martin@ximian.com>

	* backends/: Rename to backend.

2006-10-24  Wade Berrier  <wberrier@novell.com>

	* doc/Makefile.am: Update filelist for removed files to fix make dist

2006-10-09  Jb Evain  <jbevain@gmail.com>

	* languages/mono/MonoFunctionType.cs
	languages/mono/MonoLanguageBackend.cs
	languages/mono/MonoOpaqueType.cs
	languages/mono/MonoSymbolFile.cs
	languages/mono/MonoEnumType.cs
	languages/mono/MonoMember.cs
	languages/mono/MonoClassType.cs
	languages/mono/MonoObjectType.cs
	languages/mono/MonoDebuggerSupport.cs:
		Don't use Cecil's interfaces which are deprecated
		in the next version.

2006-07-18  Wade Berrier <wberrier@novell.com>

	* backends/Makefile.am: Remove ModuleManager.cs from EXTRA_DIST

2006-07-18  Martin Baulig  <martin@ximian.com>

	Released version 0.30 "Koblenz" of the Mono Debugger :-)

2006-07-18  Martin Baulig  <martin@ximian.com>

	* configure.in: Require Mono >= 1.1.16.

2006-07-17  Martin Baulig  <martin@ximian.com>

	Kill the System.Data dependency.

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration): Rewrite using System.Xml.

	* classes/DebuggerSession.cs
	(DebuggerSession): Rewrite using System.Xml; use an `XmlDocument'
	instead of a `DataSet'.

	* classes/DebuggerConfiguration.xsd: Update the schema to reflect
	the new XML file format (we're still using the schema with an
	`XmlValidatingReader').	

2006-07-13  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(ModuleCommand): New command.

2006-07-13  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerOptions.cs
	(DebuggerOptions): Make this a DebuggerMarshalByRefObject.
	(DebuggerOptions.Clone): New internal method.

	* classes/DebuggerSession.cs
	(DebuggerSession.Clone): Added `DebugggerOptions new_options' and
	`string new_name' arguments.

	* classes/Process.cs
	(Process.Session): Get the session from the servant.

	* backends/ProcessStart.cs
	(ProcessStart.SetupApplication): Clone the options and update them
	to the new values.

	* frontend/Command.cs
	(ShowCommand.ShowArgumentsCommand): Added `show args' command to
	show the command line arguments.

2006-07-13  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration): Rewrite to use System.Data with the
	DebuggerConfiguration.xsd schema.

2006-07-12  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.xsd: Renamed into
	DebuggerConfiguration.xsd.	

2006-07-12  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerOptions.cs: New file; split out
	`DebuggerOptions' from DebuggerSession.cs.

2006-07-12  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerOptions.ParseCommandLine): New public static method;
	moved here from frontend/Main.cs.

2006-07-12  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.MethodHasSource): Don't check
	`Module.StepInto' if the method we're stepping into is in the same
	module.	

2006-07-12  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerOptions.cs
	(DebuggerOptions.Prompt): Removed.
	(DebuggerOptions.LoadNativeSymbolTable): Removed.
	(DebuggerOptions.JitOptimizations): Default to null.
	(DebuggerOptions.WorkingDirectory): Default to null.
	(DebuggerSession): Also save/load the `DebuggerOptions'.

2006-07-08  Martin Baulig  <martin@ximian.com>

	* arch/DwarfReader.cs
	(DwarfLocation): New protected class; moved the location reading here.
	(DwarfLocation.GetLocation): Correctly handle `DW_OP_fbreg'.
	(DieSubprogram): Support the `DW_AT_frame_base' attribute.
	(DwarfTargetVariable): Moved the location code into `DwarfLocation'.

2006-07-06  Martin Baulig  <martin@ximian.com>

	* arch/Architecture_I386.cs
	(Architecture_I386.IsSyscallInstruction): Correctly implement
	this; also protect with try/catch.

	* arch/Architecture_X86_64.cs
	(Architecture_X86_64.IsSyscallInstruction): Protect with try/catch.

2006-07-06  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(OperationFinish.IsSourceOperation): Set to `!Native'.

2006-07-06  Martin Baulig  <martin@ximian.com>

	* backends/server/i386-arch.c (ArchInfo): Use `guint64' for
	`dr_control' and `dr_status' since _server_ptrace_get_dr()
	operates on guint64.

2006-07-06  Martin Baulig  <martin@ximian.com>

	* backends/server/x86_64-arch.c
	(server_ptrace_insert_hw_breakpoint): Don't deadlock here.

	* backends/server/i386-arch.c
	(server_ptrace_insert_hw_breakpoint): Don't deadlock here.

2006-07-06  Martin Baulig  <martin@ximian.com>

	* classes/SourceInfo.cs
	(SourceMethod.ClassName): New public property.

	* classes/DebuggerSession.cs
	(DebuggerSession.Clone): New internal method.

	* backends/ProcessServant.cs
	(ProcessServant.ChildExecd): Clone the session.

	* classes/SourceLocation.cs
	(SourceLocation): Make this actually work again.

2006-07-05  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerSession.SessionData): New protected class; moved all the
	session data here, we save this to XML when the target exists
	while the `DebuggerSession' persists across multiple invocations.

2006-07-05  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerSession.MainProcessReachedMain): Make this public again
	and call it from the `Interpreter'; read the FIXME in the source
	code.

	* frontend/Interpreter.cs
	(Interpreter.Start): Call `session.MainProcessReachedMain ()'.
	(Interpreter.LoadSession): Likewise.

2006-07-03  Martin Baulig  <martin@ximian.com>

	* classes/Event.cs
	(Event.OnTargetExited): New abstract internal method; an `Event'
	may persist across multiple invocations of the target, so we use
	this to disable the event when we exit.

	* backends/ProcessServant.cs
	(ProcessServant.OnProcessExitedEvent): New internal method; save
	the session here.

	* classes/DebuggerSession.cs
	(DebuggerSession.OnProcessExited): Disable all events here.

2006-06-29  Martin Baulig  <martin@ximian.com>

	The big session-handling cleanup - we now load/save the session to
	XML using a DataSet.

	* classes/DebuggerConfiguration.cs
	(DebuggerConfiguration.ModuleGroups): New internal property.

	* classes/DebuggerSession.cs
	(DebuggerSession): Moved thread groups and events here; load and
	save the session from XML using a DataSet.
	(DebuggerSession.CreateThreadGroup): Moved here.
	(DebuggerSession.DeleteThreadGroup): Moved here.
	(DebuggerSession.ThreadGroupExists): Moved here.
	(DebuggerSession.ThreadGroups): Moved here.
	(DebuggerSession.ThreadGroupByName): Moved here.
	(DebuggerSession.MainThreadGroup): Moved here.
	(DebuggerSession.Events): Moved here.
	(DebuggerSession.GetEvent): Moved here.
	(DebuggerSession.AddEvent): Moved here.
	(DebuggerSession.DeleteEvent): Moved here.
	(DebuggerSession.InsertBreakpoint): Moved here.
	(DebuggerSession.SaveSession): New public method to save the
	session as XML into a Stream.
	(DebuggerSession.ctor): Added a ctor taking a `Stream' to load the
	session from XML.
	(DebuggerSession.SurrogateSelector): Removed.

	* classes/DebuggerSession.xsd: New file.

	* classes/Process.cs (Process.Session): New public property.

	* classes/Event.cs
	(Event.GetSessionData): New internal virtual method taking a
	`DataRow' argument.
	(Event.GetSessionData, SetSessionData): Removed the old
	serialization-based implementation.
	(Event.SessionSurrogate): Removed.

	* classes/ThreadGroup.cs
	(ThreadGroup.SessionSurrogate): Removed.

	* classes/Module.cs
	(SymbolFile.LookupMethod): New public abstract method.
	(ModuleGroup.GetSessionData, SetSessionData): New internal
	methods; operate on a `DataRow'.
	(Module.LookupMethod): New public abstract method.
	(Module.GetSessionData, SetSessionData): New internal methods;
	operate on a `DataRow'.
	(Module.SessionSurrogate): Removed.

	* classes/SourceLocation.cs
	(SourceLocation): Don't implement IDeserializationCallback.
	(SourceLocation.method): New private field; when loading the
	location from XML, we just have a method name and need to do a
	method lookup.

	* languages/TargetFunctionType.cs
	(TargetFunctionType.Name): Don't include the class name here.
	(TargetFunctionType.FullName): New public abstract property; this
	is class name plus method name.

2006-06-26  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerSession.ModulesChanged): Removed.

	* classes/Module.cs
	(SymbolFile): Implement IDisposable.
	(SymbolFile.Module): New public abstract property.
	(SymbolFile.DoDispose): New protected virtual method; call
	`Module.UnLoadModule()'.	
	(Module.UnLoadModule): New internal method.

2006-06-26  Martin Baulig  <martin@ximian.com>

	* backends/SymbolTableManager.cs
	(SymbolTableManager): Completely rewrite and simplify this;
	instead of maintaining a `SymbolTableCollection' in a separate
	thread, directly implement `ISymbolTable' and iterate over an
	array of `SymbolFile's.

	* classes/SourceInfo.cs
	(SourceFile): Override GetHashCode() and Equals().

	* classes/Module.cs
	(Module.RegisterLoadHandler): Removed; call it on the `SymbolFile'
	instead.	

2006-06-26  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerSession.ctor): Added `DebuggerConfiguration' argument.
	(DebuggerSession.Config): New public readonly field.
	(DebuggerSession): Moved the module management code here from
	`ModuleManager'.

	* backends/ModuleManager.cs: Removed.
	(ModuleManager): Moved all the functionality into
	`DebuggerSession'.	

2006-06-26  Martin Baulig  <martin@ximian.com>

	* backends/SymbolTableManager.cs
	(SymbolTableManager): Removed all the module code.
	(SymbolTableManager.SetModules): Removed.
	(SymbolTableManager.Modules): Removed.

2006-06-26  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerSession): Make this a `DebuggerMarshalByRefObject'.

	* classes/Debugger.cs
	(Debugger.Run): Take a `DebuggerSession' argument instead of a
	`DebuggerOptions' one.
	(Debugger.Attach, Debugger.OpenCoreFile): Likewise.

	* backends/DebuggerServant.cs
	(DebuggerServabt.Run): Take a `DebuggerSession' argument instead
	of a `DebuggerOptions' one.
	(DebuggerServant.Attach, Debugger.OpenCoreFile): Likewise.

	* backends/ProcessServant.cs
	(ProcessServant.Session): New public property.

2006-06-26  Martin Baulig  <martin@ximian.com>

	* classes/Module.cs
	(Module.BreakpointsChangedEvent): Removed.

	* backends/ModuleManager.cs
	(BreakpointChangedHandler): Removed.
	(ModuleManager.BreakpointsChanged): Removed.

	* backends/ProcessServant.cs
	(ProcessServant.BreakpointsChangedEvent): Removed.

2006-06-26  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerConfiguration.cs: New file.
	(DebuggerConfiguration): New public class.

	* classes/Debugger.cs
	(Debugger.ctor): Added `DebuggerConfiguration' argument.

	* classes/Module.cs
	(SymbolFile.IsNative): New public property.
	(ModuleBase): New public abstract base class.
	(Module): Derive from `ModuleBase'.
	(Module.ModuleGroup): New public property.
	(Module.HideFromUser): New public property.
	(ModuleGroup): New public class.

2006-06-12  Martin Baulig  <martin@ximian.com>

	* classes/TargetVariable.cs
	(TargetVariable.IsInScope): New public abstract method.

	* classes/Method.cs
	(Method.GetVariableByName): Added `TargetAddress address' argument
	and check whether the variable is actually in scope.

	* classes/StackFrame.cs
	(StackFrame.Locals): Use `local.IsInScope()' rather than
	`local.IsAlive()'.	

2006-06-12  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(OperationRuntimeInvoke.DoProcessEvent): Also push the rti frame
	if we hit a breakpoint at the invoke method.

	* test/testsuite/TestInvocation.cs: Added testcase for that.

2006-06-01  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine): Correctly handle the THROW_EXCEPTION /
	HANDLE_EXCEPTION notification.

2006-06-01  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(BreakCommand): Added `-local' argument; change default behaviour
	to `-global'.

2006-06-01  Martin Baulig  <martin@ximian.com>

	* backends/server/x86_64-arch.c
	(server_ptrace_push_registers): Properly align the stack.
	(server_ptrace_call_method_*): Likewise.

2006-06-01  Martin Baulig  <martin@ximian.com>

	* backends/server/server.h
	(ServerCommandError): Add `COMMAND_ERROR_INTERNAL_ERROR'.

	* classes/TargetException.cs
	(TargetError): Added `InternalError'.

2006-05-31  Martin Baulig  <martin@ximian.com>

	* classes/Debugger.cs: Added error checking.

2006-05-31  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetNotification.cs
	(TargetState): Don't use all-capital letters.

2006-05-31  Martin Baulig  <martin@ximian.com>

	* classes/Thread.cs
	(Thread): Merge `Finish' and `FinishNative'.

	* backends/ThreadServant.cs
	(ThreadServant): Merge `Finish' and `FinishNative'.

2006-05-31  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(SteppingCommand.DoStep): Return a `CommandResult'.

	* frontend/Interpreter.cs
	(Interpreter.Wait): Added overloaded version which takes a
	`CommandResult'; check for exceptions.

	* backends/SingleSteppingEngine.cs
	(CommandResult): Moved to classes/Thread.cs and made public.

	* classes/Thread.cs (CommandResult): Moved here from
	SingleSteppingEngine.cs and made public.	
	(Thread.StepInstruction): Return a `CommandResult'.
	(Thread.StepNativeInstruction): Likewise.
	(Thread.NextInstruction): Likewise.
	(Thread.StepLine): Likewise.
	(Thread.NextLine): Likewise.
	(Thread.Finish): Likewise.
	(Thread.FinishNative): Likewise.
	(Thread.Continue): Likewise.
	(Thread.FinishNative): Likewise.

2006-05-30  Martin Baulig  <martin@ximian.com>

	* backends/server/x86_64-arch.c
	(server_ptrace_push_registers): Don't corrup the red zone.
	(server_ptrace_call_method_*): Likewise.

2006-05-24  Martin Baulig  <martin@ximian.com>

	* doc/GC-issues.txt: Added document describing the interface
	between the debugger and the GC.

2006-05-24  Martin Baulig  <martin@ximian.com>

	Released version 0.20 "Bruxelles" of the Mono Debugger :-)

2006-05-24  Martin Baulig  <martin@ximian.com>

	* backends/server/library.c
	(mono_debugger_server_set_notification): This is no longer a
	"static" method - different processes may have different
	notification addresses, so we need to make this per-target.

	* backends/server/x86-ptrace.c
	(InferiorHandle): Added `guint64 nofification_address'; replaces
	the static variable in x86_64-arch.c/i386-arch.c.
	(server_ptrace_set_notification): Moved here from x86_64-arch.c.

	* backends/Inferior.cs
	(Inferior.SetNotificationAddress): New internal method; call
	mono_debugger_server_set_notification().

	* backends/MonoThreadManager.cs
	(MonoThreadManager.ThreadCreated): Call SetNotificationAddress()
	on each newly created inferior.	

2006-05-24  Martin Baulig  <martin@ximian.com>

	* arch/bfdglue.c
	(bfd_glue_get_section_size): Added `raw_size' argument.
	(bfd_glue_get_section_contents): Take a pre-alloced buffer as
	argument rather than allocating it here.

2006-05-24  Martin Baulig  <martin@ximian.com>

	* backends/ProcessServant.cs
	(ProcessServant.Kill): Don't call Dispose().

	* backends/server/x86-linux-ptrace.c
	(server_ptrace_initialize_process): Don't use PTRACE_O_TRACEEXIT;
	we don't need this.

2006-05-24  Martin Baulig  <martin@ximian.com>

	* backends/MonoThreadManager.cs
	(MonoThreadManager.HandleChildEvent): Clear the `csharp_language' on
	`NofitifactionType.FinalizeManagedCode'.

2006-05-24  Martin Baulig  <martin@ximian.com>

	* configure.in: Check whether the Mono we're using is recent enough.

2006-05-24  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(BreakCommand.DoResolve): If our base class'es DoResolve() failed,
	try resolving the expression as an address.

	* frontend/Interpreter.cs
	(Interpreter.InsertBreakpoint): Added overloaded version which
	takes a `TargetAddress'.

	* classes/Process.cs
	(Process.InsertBreakpoint): Added overloaded version which takes a
	`TargetAddress'.	

2006-05-24  Martin Baulig  <martin@ximian.com>

	* backends/server/server.h
	(ServerStatusMessageType): Added `MESSAGE_CHILD_CALLED_EXIT'.

	* backends/server/x86-ptrace.c
	(server_ptrace_dispatch_event): Use `MESSAGE_CHILD_CALLED_EXIT'
	for `PTRACE_EVENT_EXIT'.

2006-05-23  Martin Baulig  <martin@ximian.com>

	* backends/Inferior.cs
	(Inferior.PushRegisters): New public method.
	(Inferior.PopRegisters): New public method.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.AcquireThreadLock): Call
	inferior.PushRegisters() to push all registers onto the stack so
	the GC will see them.
	(SingleSteppingEngine.ReleaseThreadLock): Call
	inferior.PopRegisters() to remove them from the stack again.

	* backends/server/x86-linux-ptrace.c
	(server_ptrace_initialize_process): Add `PTRACE_O_TRACEEXIT'.

	* backends/server/x86_64-arch.c
	(server_ptrace_push_registers): New method.
	(server_ptrace_pop_registers): New method.

	* backends/server/i386-arch.c
	(server_ptrace_push_registers): New method.
	(server_ptrace_pop_registers): New method.

	* backends/server/library.c
	(mono_debugger_server_push_registers): New public method.
	(mono_debugger_server_pop_registers): New public method.

2006-05-20  Martin Baulig  <martin@ximian.com>

	* arch/DwarfReader.cs
	(DwarfReader.DwarfTargetVariable.GetLocation): Add support for
	location lists.	

2006-05-20  Martin Baulig  <martin@ximian.com>

	* arch/DwarfFrameReader.cs: More 64-bit updates.

2006-05-20  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(SourceCommand.DoResolve): Also lookup native methods.
	(BreakCommand): Add `-global' argument as a shortcut for
	`-group global'.

2006-05-17  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter.InsertHardwareWatchPoint): New public method.

	* frontend/Command.cs
	(WatchCommand): New command.

	* classes/Breakpoint.cs
	(BreakpointType): New public enum.
	(Breakpoint.Type): New public property.

	* classes/Process.cs
	(Process.InsertHardwareWatchPoint): New public method.

	* backends/ProcessServant.cs
	(ProcessServant.InsertHardwareWatchPoint): New public method.

2006-05-17  Martin Baulig  <martin@ximian.com>

	* backends/Inferior.cs
	(Inferior.HardwareBreakpointType): New internal enum.
	(Inferior.InsertHardwareWatchPoint): New public method.

	* backends/server/x86-linux-ptrace.c
	(_server_ptrace_set_dr): Use `guint64' for the `value' arg.
	(_server_ptrace_get_dr): Likewise.
	(server_ptrace_get_application): Fix compiler warnings.

	* backends/server/x86-arch.h
	(x86_arch_remove_hardware_breakpoints): New public function.

	* backends/server/x86_64-arch.c
	(ArchInfo): Use `guint64' for `dr_control' and `dr_status'.

	* backends/server/x86-ptrace.cs
	(server_ptrace_dispatch_event): Remove all hardware breakpoints if
	we stopped the first time.

	* backends/server/server.h
	(mono_debugger_server_insert_hw_breakpoint): Added `guint32 type'
	argument which is a `HardwareBreakpointType'.

	* backends/server/breakpoints.h
	(HardwareBreakpointType): New enum typedef.
	(BreakpointInfo): Added `HardwareBreakpointType type' field to
	support hardware watchpoints.

2006-05-15  Martin Baulig  <martin@ximian.com>

	* classes/SourceLocation.cs
	(SourceLocation.HasLine): New public property.

	* frontend/Command.cs
	(ListCommand.DoExecute): Only display the whole method if we
	didn't specify a line.

2006-05-15  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(SetCommand.SetEnvironmentCommand): Added "set env" command to set
	environment variables.

	* classes/DebuggerSession.cs
	(DebuggerOptions.UserEnvironment): New public property.
	(DebuggerOptions.SetEnvironment): New public method.

	* backends/ProcessStart.cs
	(ProcessStart.UserEnvironment): Removed; retrieve it from the
	`DebuggerOptions'.

2006-05-12  Martin Baulig  <martin@ximian.com>

	* backends/server/x86-linux-ptrace.c
	(server_ptrace_global_wait): Restart the waiting on `stop_requested'.
	(server_ptrace_stop_and_wait): Fix a race condition;
	server_ptrace_global_wait() is now automatically restarted; also
	return the SIGSTOP which we expect.

	* backends/ThreadManager.cs
	(ThreadManager.RequestWait): Make this private and protect against
	being called multiple times; use RequestWait() everywhere instead
	of setting the `wait_event' directly to avoid race conditions.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.child_breakpoint): Call `bpt.CheckBreakpointHit()'
	directly rather than using an async handler.
	(SingleSteppingEngine.AcquireThreadLock): Don't call
	`manager.RequestWait()'.

2006-05-12  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(OperationFinish.DoExecte): Use `do_next_native()', not
	`do_step_native().	

2006-05-12  Martin Baulig  <martin@ximian.com>

	* NEWS: Update: we need the latest Mono from SVN; just realized
	that 1.1.15 is too old and does not work.

2006-05-12  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs (FileCommand): Added error checking.
	(SetCommand.SetArgsCommand): Added `set args' command.
	(SetCommand.DoResolve): Properly handle the subcommands.

	* backends/ProcessStart.cs
	(ProcessStart.cs): `Options.InferiorArgs' no longer contains the
	target application; use `Options.File' for that.

2006-05-12  Martin Baulig  <martin@ximian.com>

	* configure.in: Bump version number to 0.20.

	* NEWS: Updated NEWS.

2006-05-11  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs
	(PointerDereferenceExpression): Allow dereferencing arbitrary
	pointer expressions.

2006-05-11  Martin Baulig  <martin@ximian.com>

	* backends/ThreadManager.cs
	(ThreadManager.WaitTimeout): Increase to 5 seconds.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.OnThreadExited): Use `TargetExited' and not
	`TargetSignaled' if we were previously Kill()ed.

	* backends/MonoThreadManager.cs
	(MonoThreadManager.HandleChildEvent): Kill the target on
	`NotificationType.MainExited'.	

2006-05-11  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter.Start): Properly handle errors.
	(Interpreter.Attach): Likewise.
	(Interpreter.OpenCoreFile): Likewise.

	* frontend/Main.cs
	(CommandLineInterpreter.RunMainLoop): Properly handle errors.

2006-05-11  Martin Baulig  <martin@ximian.com>

	* backends/server/remoting.[ch]: Removed.

2006-05-11  Martin Baulig  <martin@ximian.com>

	* arch/Architecture.cs
	(Architecture.AdjustReturnAddress): New protected method; adjust
	the return address, so we report the line of the call and not the
	return address in stack traces.
	(Architecture.CreateFrame): Call AdjustReturnAddress().

	* test/testsuite/TestException.cs: Added test case for it.

2006-05-10  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerMarshalByRefObject.cs
	(DebuggerMarshalByRefObject): New public class; we now use this
	everywhere instead of `MarshalByRefObject'.
	(DebuggerMarshalByRefObject.InitializeLifeTimeService): Override
	this and return null.

2006-05-10  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs (BinaryOperator): Make this work again.

	* frontend/CSharpExpressionParser.jay: Add support for binary
	operators.

2006-05-10  Martin Baulig  <martin@ximian.com>

	* classes/DebuggerSession.cs
	(DebuggerOptions.JitArguments): New public field.

	* frontend/Main.cs: Add `-jit-arg' command line argument to pass
	additional arguments to the inferior `mono'.

2006-05-10  Martin Baulig  <martin@ximian.com>

	* backends/server/x86_64-arch.c: Use proper alignment when calling
	methods.

2006-05-09  Martin Baulig  <martin@ximian.com>

	The big method lookup cleanup :-)

	* frontend/Expression.cs (LocationType): Added `Constructor'.
	(Expression.EvaluateSource): Removed.
	(Expression.DoEvaluateSource): Removed.
	(Expression.ResolveMethod): Added a `LocationType' argument and
	return a `MethodExpression'.
	(Expression.DoResolveMethod): Likewise; return null by default.
	(SimpleNameExpression.DoResolveMethod): Handle all the different
	kinds of method lookups here.
	(MethodExpression): New public abstract class.
	(MethodExpression.EvaluateSource): New public abstract method; use
	this instead of `Expression.EvaluateSource()'.
	(MethodGroupExpression): Derive from `MethodExpression'.
	(MethodGroupExpression.DoResolveMethod): Add support for the
	different LocationType's here.
	(InvocationExpression): Derive from `MethodExpression'.

	* frontend/Command.cs
	(SourceCommand.Ctor): Added `-ctor' argument to lookup ctors.
	(SourceCommand.DoResolve): We now use `Expression.ResolveMethod()'
	to get a `MethodExpression' and then call EvaluateSource() on it.

	* test/src/testsuite/TestMethodLookup.cs: New test.  This test is
	really huge and should cover all the cases.

2006-05-05  Martin Baulig  <martin@ximian.com>

	* languages/TargetFunctionType.cs
	(TargetFunctionType.IsConstructor): New public property.

	* frontend/Expression.cs
	(InvocationExpression.DoInvoke): Make invoking ctors work.

2006-05-05  Martin Baulig  <martin@ximian.com>

	* languages/TargetFunctionType.cs
	(TargetFunctionType.IsStatic): New public property.

	* frontend/Expression.cs
	(InvocationExpression.DoResolve): Use `method_expr.ResolveMethod()'
	since we may be called from SourceLocation.DoResolve()'.
	(InvocationExpression.DoInvoke): Don't allow invoking instance
	methods with a type reference.

2006-05-05  Martin Baulig  <martin@ximian.com>

	* classes/SourceLocation.cs
	(SourceLocation.HasMethod): New public property.
	(SourceLocation.Function): New public property.
	(SourceLocation.ctor): Add a ctor taking a `SourceFile' and a
	line number.

	* classes/SourceInfo.cs
	(SourceInfo.FindLine): Allow line numbers outside methods; return
	a `SourceLocation' without a method in this case.

	* frontend/Command.cs
	(SourceCommand.DoResolve): If the argument is now a valid number,
	try parsing it as an expression and create a function location.
	(SourceCommand.EvaluateMethod): Removed.
	(BreakCommand.DoExecute): If we're a function breakpoint,
	`Location.HasFunction' is true.

2006-05-05  Martin Baulig  <martin@ximian.com>

	* frontend/ScriptingContext.cs
	(ScriptingContext.ListSourceCode): Removed; moved the
	functionality into `ListCommand'.

	* frontend/Command.cs
	(SourceCommand.Location): New public property.
	(SourceCommand.DoResolve): Make sure we have a valid `Location'.
	(ListCommand.DoExecute): Moved the functionality here.

2006-05-03  Martin Baulig  <martin@ximian.com>

	* classes/Debugger.cs
	(Debugger.Kill): Wait for the target to exit before returning.

2006-05-03  Martin Baulig  <martin@ximian.com>

	* backends/MonoThreadManager.cs
	(MonoThreadManager.HandleChildEvent): Fix a race condition: call
	`inferior.InitializeModules ()' before resuming the target.

2006-05-03  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs (DebuggerCommand.Execute): Always resolve
	the command before executing it; also when repeating it.

2006-05-03  Martin Baulig  <martin@ximian.com>

	* backends/Inferior.cs (Inferior.Kill): Check errors.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.OnThreadExited): New internal method; we're
	called from the ThreadManager when the target exited.
	(SingleSteppingEngine.Kill): Correctly implement this.
	(SingleSteppingEngine.Dispose): Correctly implement this.
	(SingleSteppingEngine.DoDispose): Don't call `inferior.Kill ()'.

	* backends/ProcessServant.cs
	(ProcessServant.OnThreadExitedEvent): Call OnProcessExited() if
	the last thread exited.
	(ProcessServant.KillThread): Removed.

	* backends/DebuggerServant.cs
	(DebuggerServant.OnProcessExitedEvent): Call OnTargetExitedEvent()
	if the last process exited.

	* backends/server/x86-ptrace.c
	(server_ptrace_kill): Don't send a SIGKILL to the target; just use
	`ptrace (PTRACE_KILL)'.

2006-05-02  Martin Baulig  <martin@ximian.com>

	* test/testsuite/NUnit.cs
	(DebuggerEvent): New public class.
	(DebuggerEventType): New public enum.
	(NUnitInterpreter): New public class; derive from `Interpreter'.
	(TestSuite): Rewrite the testsuite: instead of parsing the
	debugger output we're now listening directly for the events.

2006-05-02  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(Command.Execute): Changed return type from `void' to `object'.
	(Command.DoExecute): Likewise.

	* frontend/ScriptingContext.cs
	(ScriptingContext.Error): Removed; throw a `ScriptingException'
	instead.

2006-05-02  Martin Baulig  <martin@ximian.com>

	* backends/DebuggerServant.cs
	(DebuggerServant.OnThreadCreatedEvent): Don't send the event for
	daemon threads.
	(DebuggerServant.OnThreadExitedEvent): Likewise.
	(DebuggerServant.OnTargetEvent): Don't send a `TargetExited' or
	`TargetSignaled' event for daemon threads.

2006-04-26  Martin Baulig  <martin@ximian.com>

	* classes/Report.cs (Report.ReportWriter): Make this field public
	and don't initialize it.

	* backends/DebuggerServant.cs
	(DebuggerServant.ctor): Added `ReportWriter' argument and assign
	it to `Report.ReportWriter'.

2006-04-26  Martin Baulig  <martin@ximian.com>

	* arch/bfdglue.h (BfdGlueSection): Removed.

	* arch/bfdglue.c (bfd_glue_get_sections): Removed.
	(bfd_glue_get_first_section): New function.
	(bfd_glue_get_next_section): New function.
	(bfd_glue_get_section_name): New function.
	(bfd_glue_get_section_vma): New function.
	(bfd_glue_get_section_size): New function.
	(bfd_glue_get_section_flags): New function.

	* arch/Bfd.cs (Bfd.InternalSection): Removed.
	(Bfd.Section): Operate directly on the `asection *' pointer.

2006-04-25  Martin Baulig  <martin@ximian.com>

	* classes/Process.cs
	(Process.SaveSession, Process.LoadSession): Moved the session
	handling into the `ProcessServant'.

	* classes/Debugger.cs
	(Debugger.ctor): Create the `DebuggerServant' in another appdomain.

2006-04-25  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.StartThread): Added `do_attach' argument.
	(SingleSteppingEngine.GetThreadID): Removed.
	(SingleSteppingEngine.Attached): Removed.
	(SingleSteppingEngine.Attach): Removed.
	(SingleSteppingEngine.Detach): When detaching from a managed
	application, start an `OperationDetach'.
	(OperationDetach): New operation.
	(OperationGetThreadId): Renamed into `OperationGetCurrentThread'.

	* backends/ThreadServant.cs
	(ThreadServant.DetachThread): New internal abstract method.

2006-04-25  Martin Baulig  <martin@ximian.com>

	* backends/BreakpointManager.cs
	(BreakpointManager.RemoveAllBreakpoints): New public method.

2006-04-25  Martin Baulig  <martin@ximian.com>

	* backends/MonoThreadManager.cs
	(MonoMetadataInfo): New internal struct; splitted out from
	`MonoBuiltinTypeInfo' in MonoLanguageBackend.cs.

2006-04-25  Martin Baulig  <martin@ximian.com>

	* arch/Architecture.cs
	(Architecture.IsSyscallInstruction): New public abstract method.

2006-04-20  Martin Baulig  <martin@ximian.com>

	* backends/Inferior.cs
	(Inferior.Attach): Removed the `is_main' argument.

	* backends/server/server.h
	(mono_debugger_server_attach): Removed the `is_main' argument.

2006-04-20  Martin Baulig  <martin@ximian.com>

	* backends/ProcessServant.cs
	(ProcessServant.MainThread): Changed type into `ThreadServant'.
	(ProcessServant.Initialize): Major code cleanup in here; call
	Inferior.InitializeProcess() if we're called the first time.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.ctor): A SingleSteppingEngine is now created
	with an operation - it's either executing `OperationStart' or
	`OperationRun'; moved the `reached main' magic into `OperationStart'.
	(SingleSteppingEngine.OperationStart): New operation.

	* backends/MonoThreadManager.cs
	(MonoThreadManager.HandleChildEvent): No longer read the TID from
	the notification on `ThreadCreated' and `ThreadExited'; always use
	the SingleSteppingEngine which received the notification.

	* backends/server/Inferior.cs
	(Inferior.InitializeProcess): New method; this needs to be called
	the first time the target is stopped.
	(Inferior.Initialize): Renamed into InitializeThread().
	(Inferior.GlobalStop): Removed.
	(Inferior.TID): Removed.

2006-04-20  Martin Baulig  <martin@ximian.com>

	* backends/server/x86-linux-ptrace.c
	(_server_ptrace_setup_inferior): Don't attempt to read the
	registers and also don't call do_wait().  We may now be called
	before the target is stopped.
	(_server_ptrace_setup_thread_manager): Renamed into
	server_ptrace_initialize_process(); we're now called from
	ProcessServant.Initialize() after the managed `ThreadManager'
	received the first event.
	(server_ptrace_global_wait): `first_status' and `first_ret' is
	gone; don't do anything special if we're called the first time.

	* x86-ptrace.c (InferiorHandle): Removed `tid'; no longer attempt
	to compute the TID here.

	* x86-arch.h (x86_arch_get_tid): Removed.

	* backends/server/server.h
	(mono_debugger_server_initialize): Renamed into
	mono_debugger_server_initialize_process() and removed the `tid'
	argument.	
	(mono_debugger_server_initialize_process): New function.
	(mono_debugger_server_attach): Removed the `tid' argument.
	(mono_debugger_server_global_stop): Removed.

	* backends/server/x86-ptrace.h: New file; replaces i386-ptrace.h
	and x86_64-ptrace.h.

2006-04-19  Martin Baulig  <martin@ximian.com>

	* backends/ThreadServant.cs: New file.
	(ThreadServant): New internal abstract class.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine): Derive from `ThreadServant'.

	* arch/CoreFile.cs
	(CoreFile.CoreFileThread): Derive from `ThreadServant'.

2006-04-19  Martin Baulig  <martin@ximian.com>

	Split `Process' into `Process' and `ProcessServant'.

	* backends/ProcessServant.cs: New file.
	(ProcessServant): New internal class.

2006-04-19  Martin Baulig  <martin@ximian.com>

	Split `Debugger' into `Debugger' and `DebuggerServant'.

	* backends/DebuggerServant.cs: New file.
	(DebuggerServant): New internal class.

2006-04-19  Martin Baulig  <martin@ximian.com>

	* test/testsuite/testnativeattach.cs: New test.

2006-04-19  Martin Baulig  <martin@ximian.com>

	* backends/ThreadManager.cs
	(ThreadManager.start_wait_thread): Catch `ThreadAbortException'
	and reset the abort.  See the comment in the source code.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs (ProcessCommand): New public abstract class.
	(DetachCommand): New command.  Note that we can only detach from a
	process if we previously attached to it.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.Kill): Send a SIGKILL to the target.
	(SingleSteppingEngine.Dispose): Call `inferior.Kill()' if we still
	have an inferior.

	* classes/TargetException.cs
	(TargetError.CannotDetach): New error.

	* classes/Debugger.cs
	(Debugger.Detach): New public method.

	* classes/Process.cs
	(Process.Detach): New public method.

	* classes/Thread.cs
	(Thread.Detach): New public method.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* backends/server/x86-ptrace.cs
	(x86_ptrace_kill): Send a SIGKILL to the process before using
	`ptrace (PTRACE_KILL)' so we actually kill it.

	* backends/ThreadManager.cs
	(ThreadManager.Dispose): Call `wait_thread.Abort()' prior to
	`wait_thread.Join()'.	

2006-04-18  Martin Baulig  <martin@ximian.com>

	* backends/Debugger.cs: Moved to ../classes/
	* backends/Process.cs: Moved to ../classes/
	* backends/Thread.cs: Moved to ../classes/

2006-04-18  Martin Baulig  <martin@ximian.com>

	* classes/SymbolTableManager.cs: Moved to ../backends/
	* classes/ModuleManager.cs: Moved to ../backends/

	* backends/Process.cs
	(Process.ModuleManager): Make this internal.
	(Process.SymbolTableManager): Make this internal.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* backends/classes/*TargetLocation.cs: Moved to languages/
	* backends/classes/MonoVariableLocation: Moved to languages/mono/.

	* backends/classes/: Removed.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* backends/TargetReader.cs: Moved here from backends/classes/.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* backends/Inferior.cs
	(Inferior.GetFileContents): New public static method; obsoletes
	the `Utils' class form backends/classes/Utils.cs.

	* backends/classes/Utils.cs: Removed.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* backends/EventQueue.cs: New file; merged classes/Threading.cs
	and backends/classes/EventQueue.cs here.

	* classes/ObjectContainer.cs: Removed.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* classes/BreakpointHandle.cs: Moved into ../backends/.
	* backends/BreakpointHandle.cs: Moved here from ../classes/.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* arch/Architecture.cs (Architecture): Make this internal.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* backends/TargetMemoryAccess.cs
	(TargetMemoryAccess.Architecture): Make this internal.

	* backends/Thread.cs
	(Thread.PrintRegisters): New public method.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* interfaces/ISourceBuffer.cs: Removed.
	(ISourceBuffer): Removed this interface; `SourceBuffer' is the
	only class implementing it.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetMemoryAccess.cs: Removed.
	(ITargetMemoryAccess): Removed.

	* backends/TargetMemoryAccess.cs: New file.
	(TargetMemoryAccess): New public abstract class.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetMemoryAccess.cs
	(ITargetInfo): Removed.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetMemoryAccess.cs
	(ITargetMemoryAccess): Removed all the writing methods.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* classes/TargetBinaryAccess.cs
	(TargetInfo): Moved here from ../backends/classes/TargetReader.cs
	and made it public.

	* backends/TargetAccess.cs
	(TargetAccess.TargetInfo): Return a `TargetInfo'.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetMemoryAccess.cs
	(ITargetMemoryInfo): Removed.

	* backends/classes/TargetReader.cs
	(TargetMemoryInfo): Removed.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* backends/Thread.cs
	(Thread.TargetMemoryAccess): Removed; just use `Thread' directly.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetMemoryAccess.cs
	(ITargetMemoryAccess): Only implement `ITargetInfo'.
	(ITargetMemoryAccess.TargetMemoryInfo): Removed.
	(ITargetMemoryAccess.Architecture): New property.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetMemoryAccess.cs
	(ITargetMemoryInfo.AddressDomain): Moved into `ITargetInfo'.
	(ITargetInfo.AddressDomain): Moved here from `ITargetMemoryInfo'.

	* backends/classes/TargetReader.cs
	(TargetReader): Don't implement `ITargetMemoryInfo'.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* backends/Inferior.cs
	(Inferior.GetTargetInfo): New public static method.

	* arch/CoreFile.cs: Don't create an Inferior here and make core
	files work again.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* backends/ThreadBase.cs: Renamed into TargetAccess.cs.
	(ThreadBase): Renamed into `TargetAccess'.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetMemoryAccess.cs
	(ITargetMemoryInfo): Make this interface internal.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetMemoryAccess.cs
	(ITargetMemoryAccess): Make this interface internal.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* classes/AddressDomain.cs
	(AddressDomain): Make the .ctor internal.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetMemoryAccess.cs
	(ITargetMemoryReader): Removed this interface; `TargetReader' is
	the only class implementing it.

2006-04-18  Martin Baulig  <martin@ximian.com>

	* classes/ExceptionCatchPoint.cs
	(ExceptionCatchPoint): Make this class sealed and rename
	`CheckBreakpointHit' into `CheckException'.

	* classes/Event.cs
	(Event.CheckBreakpointHit): Moved into the `Breakpoint' class.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.child_breakpoint): Run
	`breakpoint.CheckBreakpointHit()' asynchronously.

2006-04-17  Martin Baulig  <martin@ximian.com>

	Bump version number to 0.14 and require Mono >= 1.1.15.

2006-04-17  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs: Cosmetic cleanups in the
	process-related messages.

2006-04-17  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.AcquireGlobalThreadLock): Check the
	`stop_event' and don't do anything if we just died.
	(SingleSteppingEngine.Start): Set `main_method_stackptr' to the
	current stack pointer.

	* backends/server/x86_64-arch.c
	(server_ptrace_get_frame): Call x86_arch_get_registers() first.

	* backends/server/i386-arch.c
	(server_ptrace_get_frame): Call x86_arch_get_registers() first.

2006-04-13  Martin Baulig  <martin@ximian.com>

	* backends/ProcessStart.cs
	(ProcessStart.SetupEnvironment): Add a `MONO_INSIDE_MDB' 
	environment variable; this is required if the target fork()s
	another mono process.

2006-04-13  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoLanguageBackend.cs: Use the new
	`MonoDefaults' offsets.

2006-04-13  Martin Baulig  <martin@ximian.com>

	* backends/Process.cs
	(Process.ChildExecd): Don't create a new process here.

2006-04-12  Martin Baulig  <martin@ximian.com>

	* test/testsuite/testnativeexec.cs: New test.

2006-04-11  Martin Baulig  <martin@ximian.com>

	* test/testsuite/TestRestart.cs: New test.

2006-04-11  Martin Baulig  <martin@ximian.com>

	* backends/Debugger.cs
	(Debugger.ProcessReachedMainEvent): Removed.

	* classes/DebuggerSession.cs
	(DebuggerSession): We're not a static class anymore.

	* frontend/Interpreter.cs: Save the session on exit and load it
	when we restart.

2006-04-11  Martin Baulig  <martin@ximian.com>

	* classes/SimpleBreakpoint.cs: Removed.

	* classes/Breakpoint.cs (Breakpoint): Don't make this abstract.

	* backends/Process.cs
	(Process.InsertBreakpoint): Create and return a new `Breakpoint'.
	(Process.InsertExceptionCheckPoint): Likewise.

2006-04-11  Martin Baulig  <martin@ximian.com>

	* classes/Event.cs (Event): New public abstract class.  This
	replaces the old `EventHandle' class.

	* classes/Breakpoint.cs (Breakpoint): Derive from `Event'.

	* classes/ExceptionCatchPoint.cs
	(ExceptionCatchPoint): New public class; derives from `Event'.

	* classes/EventHandle.cs: Removed.
	* classes/CatchpointHandle.cs: Removed.

	* classes/SourceLocation.cs
	(SourceLocation): We can now also operate on a
	`TargetFunctionType'.
	(SourceLocation.HasFunction): New public property.
	(SourceLocation.InsertBreakpoint): New internal method.

	* classes/BreakpointHandle.cs
	(BreakpointHandle): This is now private.

2006-04-11  Martin Baulig  <martin@ximian.com>

	* classes/BreakpointHandle.cs
	(BreakpointHandle): Make this internal.

	* backends/Process.cs
	(Process.InsertBreakpoint): Don't take a `Thread' argument and
	don't enable the breakpoint.

	* frontend/Interpreter.cs
	(Interpreter.InsertBreakpoint): Process.InsertBreakpoint() no
	longer enables the breakpoint; do this here.

2006-04-11  Martin Baulig  <martin@ximian.com>

	* classes/Module.cs (ILoadHandler): New internal interface.
	(SymbolFile.RegisterLoadHandler, Module.RegisterLoadHandler):
	Return an `ILoadHandler', not an `IDisposable'.	

2006-04-11  Martin Baulig  <martin@ximian.com>

	* classes/SourceLocation.cs
	(SourceLocation.SourceBuffer): Removed.

2006-04-11  Martin Baulig  <martin@ximian.com>

	* backends/Process.cs
	(Process.SaveSession, LoadSession): New public methods; moved the
	session handling code here from `DebuggerSession'.
	(Process.Session): Removed.

	* classes/DebuggerSession.cs
	(DebuggerSession): Make this a static class for the moment; all
	the session handling code is now in `Process'.

2006-04-11  Martin Baulig  <martin@ximian.com>

	* classes/ThreadGroup.cs
	(ThreadGroup.Global, ThreadGroup.System): New public static
	properties; the "global" and "system" groups are now static and
	immutable.

	* backends/BreakpointManager.cs
	(BreakpointManager.RemoveBreakpointsAfterFork): Renamed into
	InitializeAfterFork().	

2006-04-11  Martin Baulig  <martin@ximian.com>

	* classes/Breakpoint.cs (Breakpoint.Clone): Removed.

	* backends/BreakpointManager.cs
	(BreakpointManager.RemoveBreakpointsAfterFork): Create a new
	`BreakpointHandle' for all global user-defined breakpoints.

2006-04-11  Martin Baulig  <martin@ximian.com>

	* backends/Process.cs (Process): Moved the breakpoint/event code
	here from `DebuggerSession'.

	* backends/DebuggerSession.cs (DebuggerSession): Moved the
	breakpoint/event code into `Process'.

2006-04-10  Martin Baulig  <martin@ximian.com>

	* backends/BreakpointManager.cs
	(BreakpointManager.RemoveBreakpointsAfterFork): Remove all
	non-global breakpoints after a fork().

	* backends/Inferior.cs
	(Inferior.InitializeAfterFork): Call it here.

	* frontend/Interpreter.cs
	(Interpreter.GetThreadGroup): Default to `main', not `global'.

2006-04-10  Martin Baulig  <martin@ximian.com>

	* backends/ILanguageBackend.cs
	(NotificationType): Added `ThreadExited'.

	* backends/MonoThreadManager.cs
	(MonoThreadManager.HandleChildEvent): If we receive a
	`ThreadExited' notification, clear `engine.EndStackAddress'.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.ReleaseThreadLock): Resume the target if we
	stopped it.

2006-04-10  Martin Baulig  <martin@ximian.com>

	* backends/server/x86-ptrace.c
	(server_ptrace_dispatch_event): Clear `inferior->last_signal' if
	we don't send a `MESSAGE_CHILD_STOPPED'.

2006-04-10  Martin Baulig  <martin@ximian.com>

	Released version 0.13 "Luxemburg" of the Mono Debugger :-)

2006-04-10  Martin Baulig  <martin@ximian.com>

	* backends/Debugger.cs
	(Debugger.DebuggerSession): Moved into `Process'.

	* backends/Process.cs
	(Process.DebuggerSession): Moved here from `Debugger'.

	* classes/DebuggerSession.cs
	(DebuggerSession): Make this per-process, not per-debugger.

2006-04-09  Martin Baulig  <martin@ximian.com>

	* test/testsuite/testnativefork.cs: New test.
	* test/src/testnativefork.c: Test case for the test.

2006-04-09  Martin Baulig  <martin@ximian.com>

	* backends/Threadmanager.cs
	(ThreadManager.HandleChildEvent): Pass SIGCHLD to the target
	without stopping it.

	* backends/server/x86-ptrace.c
	(server_ptrace_dispatch_event): Return a normal
	MESSAGE_CHILD_STOPPED on SIGCHLD.

2006-04-07  Martin Baulig  <martin@ximian.com>

	* backends/server/x86-ptrace.c (server_ptrace_spawn): Set the
	child's core-file limit to zero after forking.

2006-04-07  Martin Baulig  <martin@ximian.com>

	* backends/server/x86-ptrace.c
	(io_thread): Fix a very old race condition: keep our data in a
	separate `IOThreadData' structure since the inferior could have
	been disposed.

2006-04-07  Martin Baulig  <martin@ximian.com>

	* test/: Clean up this directory a bit.

	* test/mono-debugger.tests/: Removed.
	* test/mdb.exp: Removed.

2006-04-06  Martin Baulig  <martin@ximian.com>

	* frontend/CL.cs (Engine.ctor): Take an `Interpreter' argument.
	(Engine.Run): Moved the exception handling here.

	* frontend/Command.cs
	(Command.Execute): Changed return type to `void'; don't catch any
	exceptions here.
	(Command.Repeat): Changed return type to `void'.
	(Command.Resolve): Don't catch any exceptions here.

2006-04-06  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter): Implement `IDisposable'.

2006-04-05  Martin Baulig  <martin@ximian.com>

	* wrapper/: Renamed to `build'.

2006-04-05  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs (DebuggerEngine.ctor): Register all the
	commands here.

	* frontend/Interpreter.cs (Interpreter): Make this a sealed class
	and add a public .ctor.

	* frontend/Main.cs (CommandLineInterpreter): Don't derive from
	`Interpreter' anymore.

	* frontend/ScriptingContext.cs
	(ScriptingContext.PrintObject): Renamed into FormatObject().
	(ScriptingContext.PrintType): Renamed into FormatType().

2006-04-05  Martin Baulig  <martin@ximian.com>

	* test/testsuite/: New directory.  Started to migrate the
	testsuite to NUnit.

	* test/src/: New directory.  The test sources will be moved here.	

2006-04-04  Martin Baulig  <martin@ximian.com>

	* backends/server/x86-linux-ptrace.c
	(_server_ptrace_setup_inferior): Check whether we're already
	stopped before blocking on do_wait().

2006-04-04  Martin Baulig  <martin@ximian.com>

	* NEWS: Updated NEWS.

2006-04-04  Martin Baulig  <martin@ximian.com>

	* backends/Process.cs
	(Process.AcquireGlobalThreadLock): Moved here from ThreadManager.
	(Process.ReleaseGlobalThreadLock): Likewise.

2006-04-03  Martin Baulig  <martin@ximian.com>

	HEADS UP: The debugger no longer works with the stable Mono from
	the 1.1.13 branch, sorry.

	* configure.in: Require Mono >= 1.1.14.

2006-04-03  Martin Baulig  <martin@ximian.com>

	* backends/Debugger.cs
	(Debugger.TargetOutputEvent): Moved here from `Thread'.

2006-04-03  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs: Inform the user about newly created and
	exited processes.

2006-04-03  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter.MainProcess): Removed.
	(Interpreter.CurrentProcess): New public property.

	* backends/Debugger.cs
	(Debugger.TargetExitedEvent): New public event.
	(Debugger.OnProcessExitedEvent): Kill all other processes if the
	main process exited.
	(Debugger.Kill): New public method.

2006-04-03  Martin Baulig  <martin@ximian.com>

	* backends/Process.cs
	(Process.Initialize): Set `main_thread' and `main_engine' here.

	* backends/Debugger.cs
	(Debugger.Run): It's now safe to use `process.MainThread' on the
	returned Process immediately.

2006-04-03  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter.start_event): Removed.

2006-04-03  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs
	(Interpreter.Threads): Removed; we don't keep a separate hash
	table here anymore, but use `Process.Threads' instead.
	(Interpreter.Processes): New public property.

	* frontend/Command.cs
	(Show.ShowProcessesCommand): Added `show processes' command.

2006-04-03  Martin Baulig  <martin@ximian.com>

	* backends/Process.cs
	(Process.ID): New public property.
	(Process.Threads): New public property.
	(Process.TargetApplication): New public property.
	(Process.CommandLineArguments): New public property.

2006-04-03  Martin Baulig  <martin@ximian.com>

	* classes/Breakpoint.cs (Breakpoint): Implement ICloneable.
	(Breakpoint.Clone): New public method.

2006-04-03  Martin Baulig  <martin@ximian.com>

	* backends/server/breakpoints.c
	(mono_debugger_breakpoint_manager_clone): New public function.

2006-04-02  Martin Baulig  <martin@ximian.com>

	* backends/server/breakpoints.h
	(BreakpointInfo): Merge this with `X86BreakpointInfo'.

	* backends/server/x86-arch.h
	(X86BreakpointInfo): Merged into `BreakpointInfo'.

2006-04-02  Martin Baulig  <martin@ximian.com>

	* frontend/Interpreter.cs: Correctly dispose the `Debugger', so we
	don't hang on exit.

2006-04-01  Martin Baulig  <martin@ximian.com>

	* backends/Process.cs: Implement follow-fork and follow-exec.

	* backends/Debugger.cs
	(Debugger.ProcessReachedMainEvent): New public event.

2006-04-01  Martin Baulig  <martin@ximian.com>

	* backends/server/x86-linux-ptrace.c
	(_server_ptrace_setup_thread_manager): Add `PTRACE_O_TRACEFORK',
	`PTRACE_O_TRACEVFORK' and `PTRACE_O_TRACEEXEC'.

	* backends/server/server.h (ServerStatusMessageType): Added
	`MESSAGE_CHILD_FORKED' and `MESSAGE_CHILD_EXECD'.

	* backends/server/library.c
	(mono_debugger_server_init_after_fork): New public function.

	* backends/server/i386-arch.c
	(do_disable, do_enable): Don't modify `breakpoint->info.enabled';
	this is now done by our caller.

	* backends/server/x86_64-arch.c
	(do_disable, do_enable): Don't modify `breakpoint->info.enabled';
	this is now done by our caller.

2006-04-01  Martin Baulig  <martin@ximian.com>

	* languages/native/NativeLanguage.cs
	(NativeLanguage.StringType): Implemented.

	* languages/native/NativePointerObject.cs
	(NativePointerObject.Print): Check whether we're a string.

2006-04-01  Martin Baulig  <martin@ximian.com>

	* backends/ProcessStart.cs
	(ProcessStart.SetupEnvironment): Set `MONO_SHARED_HOSTNAME=mdb'.

2006-03-29  Martin Baulig  <martin@ximian.com>

	* backends/Debugger.cs
	(Debugger.InitializedEvent): Renamed to `ProcessCreatedEvent'.
	(Debugger.TargetExitedEvent): Renamed to `ProcessExitedEvent'.

2006-03-29  Martin Baulig  <martin@ximian.com>

	* backends/remoting/: Removed.

2006-03-29  Martin Baulig  <martin@ximian.com>

	* backends/Debugger.cs (Debugger): Don't make this abstract and
	added a public .ctor.

	* backends/DebuggerSession.cs: Take a `Debugger' argument, not a
	`DebuggerClient' one.

	* backends/remoting/DebuggerClient.cs: Removed.
	* backends/remoting/DebuggerServer.cs: Removed.

2006-03-29  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(DebuggerCommand.Execute): Don't create a new `ScriptingContext'
	if we're repeating.

2006-03-28  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(DebuggerCommand.Execute): Create a new `ScriptingContext'.
	(DebuggerCommand.Resolve): Call DoResolveBase() before
	DoResolve().
	(ThreadCommand.DoResolveBase): Set `context.CurrentThread' here.
	(ThreadCommand.ResolveThread): Removed; use `CurrentThread' instead.
	(ThreadCommand.CurrentThread): New public property.
	(FrameCommand.DoResolveBase): Set `context.CurrentFrame' here.
	(FrameCommand.ResolveFrame): Removed; use `CurrentFrame' instead.
	(FrameCommand.CurrentFrame): New public property.
	(UpCommand, DownCommand): We now use `backtrace.CurrentFrameIndex'.

2006-03-28  Martin Baulig  <martin@ximian.com>

	* classes/Backtrace.cs
	(Backtrace.CurrentFrame): New public property.
	(Backtrace.CurrentFrameIndex): Likewise.

	* languages/Language.cs
	(Language.Process): New public porperty.

2006-03-14  Martin Baulig  <martin@ximian.com>

	Released version 0.12 "Portland" of the Mono Debugger :-)

2006-03-14  Martin Baulig  <martin@ximian.com>

	* configure.in: Require Mono >= 1.1.13.

2006-03-13  Wade Berrier <wberrier@novell.com>

	* arch/Makefile.am backends/remoting/Makefile.am backends/Makefile.am:
	Update EXTRA_DIST to fix make dist and make distcheck

2006-03-04  Martin Baulig  <martin@ximian.com>

	* backends/MonoThreadManager.cs
	(MonoThreadManager.Initialize): The notification function is not
	dynamically allocated at runtime; we need to insert a breakpoint
	on the `initialize' function in the `MONO_DEBUGGER_debugger_info'
	vtable and read the notification address once we hit that bpt.

2006-02-28  Martin Baulig  <martin@ximian.com>

	* backends/TargetAccess.cs: Removed.

2006-02-28  Martin Baulig  <martin@ximian.com>

	* languages/*.cs: Use `Thread' everywhere instead of `TargetAccess'.

2006-02-28  Martin Baulig  <martin@ximian.com>

	* languages/Language.cs
	(Language.CreateObject): Take a `Thread' argument, not a `TargetAccess'.
	(Language.CreateInstance): Likewise.
	(Language.CreateNullObject): Likewise.

	* classes/Breakpoint.cs
	(Breakpoint.CheckBreakpointHit): Take a `Thread' argument, not a
	`TargetAccess'.

	* classes/SimpleBreakpoint.cs
	(BreakpointCheckHandler): Take a `Thread' argument, not a `TargetAccess'.

2006-02-28  Martin Baulig  <martin@ximian.com>

	* backends/TargetAccess.cs
	(TargetAccess.DisassembleInstruction): Removed.
	(TargetAccess.DisassembleMethod): Removed.

2006-02-28  Martin Baulig  <martin@ximian.com>

	* backends/TargetAccess.cs
	(TargetAccess.InsertBreakpoint): Removed.
	(TargetAccess.RemoveBreakpoint): Removed.
	(TargetAccess.AddEventHandler): Removed.
	(TargetAccess.RemoveEventHandler): Removed.

	* backends/Debugger.cs
	(Debugger.InsertBreakpoint): Removed.
	(Debugger.InsertExceptionCatchpoint): Removed.

	* backends/BreakpointHandle.cs
	(BreakpointHandle): We now operate directly on the `Thread'
	instead of the `TargetAccess'.

	* classes/DebuggerSession.cs
	(DebuggerSession.InsertBreakpoint): Take a `Thread' argument
	instead of a `TargetAccess'.
	(DebuggerSession.InsertExceptionCatchPoint): Likewise.

2006-02-28  Martin Baulig  <martin@ximian.com>

	* classes/Breakpoint.cs
	(Breakpoint.GetNextBreakpointIndex): New internal static method.

	* classes/EventHandle.cs (EventHandle..ctor): We now take an
	`index' argument; we use `Breakpoint.Index' for breakpoints and
	generate a new unique index for catchpoints.

2006-02-28  Martin Baulig  <martin@ximian.com>

	* backends/remoting/DebuggerContext.cs: Removed.

	* backends/remoting/DebuggerManager.cs: Removed.

2006-02-28  Martin Baulig  <martin@ximian.com>

	* backends/TargetAccess.cs (ClientTargetAccess): Removed.
	(TargetAccessHelper): Removed; we now share the same
	`TargetAccess' between client and server.

	* backends/remoting/DebuggerContext.cs
	(DebuggerContext.GetTargetAccess): Removed.

2006-02-28  Martin Baulig  <martin@ximian.com>

	* backends/Process.cs
	(Process): Manage thread groups here and not in `DebuggerManager'.

	* backends/remoting/DebuggerManager.cs
	(DebuggerManager): Moved all the thread groups related code into
	the new `Process' class.

2006-02-28  Martin Baulig  <martin@ximian.com>

	* backends/Process.cs: New file.
	(Process): New internal class.  This class holds all the
	information about one instance of a target application; ie. the
	target application's threads, breakpoints, modules and symbol
	tables.

	* backends/ThreadManager.cs
	(ThreadManager): The `ThreadManager' can now persist across
	multiple invocations of a target application; all the state is in
	the new `Process' class.

2006-02-24  Martin Baulig  <martin@ximian.com>

	The big `Process' -> `Thread' rename.

	* backends/Process.cs: Renamed to Thread.cs
	(Process): Renamed to Thread.

	* frontend/Command.cs
	(ProcessCommand): Renamed to `ThreadCommand'.
	(ThreadCommand.ResolveProcess): Renamed to `ResolveThread'.
	(FrameCommand.Process): Renamed the property to `Thread'.
	(SelectProcessCommand): Renamed to `SelectThreadCommand'.
	(BackgroundProcessCommand): Renamed to `SelectThreadCommand'.
	(StopProcessCommand): Renamed to `StopThreadCommand'.

	* frontend/Main.cs
	(CommandLineInterpreter.SetupEngine): Renamed the "process"
	command to "thread".

2006-02-24  Martin Baulig  <martin@ximian.com>

	* backends/Thread.cs: Renamed to ThreadBase.cs.
	(Thread): Renamed to `ThreadBase'.

2006-02-23  Martin Baulig  <martin@ximian.com>

	* backends/Process.cs (Process): Derive from `Thread'.

2006-02-23  Martin Baulig  <martin@ximian.com>

	* backends/server/library.c
	(mono_debugger_server_get_application): Return the currently
	running application, its current working directory and command
	line arguments; we use this after attaching to a process.

	* backends/Inferior.cs (Inferior.GetApplication): New public
	method to get the currently running application.
	(Inferior.Attach): Call GetApplication() after attaching and setup
	the `ProcessStart' accordingly.

	* backends/ProcessStart.cs
	(ProcessStart.SetupApplication): New public method; we use this
	after attaching, so the user doesn't need to specify the application.

2006-02-23  Martin Baulig  <martin@ximian.com>

	Support multiple appdomains; this is only used when attaching to a
	process which is running without `-O=shared'; the API to insert a
	breakpoint in another appdomain is intentionally undocumented and
	will change in near future.

	* classes/SourceInfo.cs (SourceMethod.IsLoaded): Removed.
	(SourceMethod.Method): Replaced the property with a new
	GetMethod() method which takes a `domain' argument.
	(SourceMethod.GetMethod): New public method.
	(SourceMethod.Lookup): Removed.

	* classes/DebuggerSession.cs
	(DebuggerSession.InsertBreakpoint): Added `int domain' argument.

	* classes/Module.cs
	(SymbolFile.GetMethod): Added `int domain' argument.

	* classes/SourceLocation.cs
	(SourceLocation.GetAddress): Added `int domain' argument to
	support multiple application domains.

	* classes/BreakpointHandle.cs: Support multiple appdomains.

	* languages/mono/MonoSymbolFile.cs: Support multiple appdomains.

2006-02-08  Martin Baulig  <martin@ximian.com>

	* backends/server/i386-arch.c: Use `guint32' instead of `long'
	everywhere to correctly handle "negative" values.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(AttachCommand): New command.
	(OpenCoreFileCommand): New command.

	* frontend/Interpreter.cs
	(Interpreter.Attach): New public method.
	(Interpreter.OpenCoreFile): New public method.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* backends/ProcessStart.cs
	(ProcessStart.CoreFile): New public readonly field.
	(ProcessStart.PID): New public readonly field

	* backends/Debugger.cs
	(Debugger.Attach): New public method.
	(Debugger.OpenCoreFile): New public method.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* backends/Thread.cs: New file.
	(Mono.Debugger.Backends.Thread): New public abstract class.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine): Derive from `Thread'.

	* arch/CoreFile.cs (CoreFile): Derive from `Thread'.

	* backends/Process.cs (Process): Use a new `Thread thread' field
	to perform non-stepping operations so we can talk both to a
	`SingleSteppingEngine' and a `CoreFile'.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* backends/MonoThreadManager.cs: The big API cleanup.
	(MonoDebuggerInfo): Moved this here from MonoLanguageBackend.

	* languages/mono/MonoLanguageBackend.cs
	(MonoDebuggerInfo): Moved into MonoThreadManager.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* arch/bfdglue.h (BfdGlueSection): Added `name'.

	* arch/bfdglue.c (bfd_glue_core_file_failing_command): New
	function.

	* arch/Bfd.cs: Added core file support.

	* arch/CoreFile.cs: New file.
	(Mono.Debugger.Backends.CoreFile): New internal class.

	* arch/Architecture.cs (Architecture.CreateFrame): Added
	overloaded version taking a `Registers' argument.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* backends/server/x86-linux-ptrace.c
	(server_ptrace_get_threads): New function.

	* backends/server/x86-ptrace.c
	(server_ptrace_initialize): Renamed into `server_ptrace_create_inferior'.
	(server_ptrace_attach): Renamed into `server_ptrace_initialize'
	and created a new `server_ptrace_attach' to actually attach to a process.
	Note that If we "attach" to a thread after receiving a PTRACE_EVENT_CLONE,
	we are in fact already attached to that thread and don't need another
	PT_ATTACH call.

	* backends/server/library.c
	(mono_debugger_server_initialize): Use this to "attach" to a new
	thread of the application we're already debugging; this is used
	after receiving a PTRACE_EVENT_CLONE.
	(mono_debugger_server_attach): Use this to actually attach to a
	new process.
	(mono_debugger_server_get_threads): Get all threads of the process.

2006-01-25  Martin Baulig  <martin@ximian.com>

	* backends/MonoThreadManager.cs: Started to clean this up; removed
	the `thread_hash'.

	* backends/Inferior.cs (Inferior.TID): Make this a `long', not `int'.
	* backends/Process.cs (Process.TID): Likewise.

	* backends/server/library.c
	(mono_debugger_server_attach): `tid' is now a `guint64 *'.
	(mono_debugger_server_peek_word): `word' is now a `guint64 *'.

	* backends/server/x86-arch.h (x86_arch_get_tid): Return a `guint64'.

2006-01-21  Martin Baulig  <martin@ximian.com>

	The debugger is now using the normal `mono' instead of its own
	`mono-debugger-mini-wrapper' to execute managed code.  You need to
	use the latest SVN version of Mono from either HEAD or the
	mono-1-1-13 branch for this.

	* frontend/Main.cs: Added `-mono' command line argument to
	specify the `mono' which should be used to execute managed code.

	* wrapper/Makefile.am: The `mono-debugger-mini-wrapper' is gone.

	* wrapper/wrapper.c: Removed.
	* wrapper/mono-debugger-jit-wrapper.h: Removed.

2006-01-21  Martin Baulig  <martin@ximian.com>

	* wrapper/wrapper.c, thread-manager.c: Merge wrapper.c and
	thread-manager.c into wrapper.c.

	* wrapper/thread-manager.c: Removed.
	* wrapper/icall.c: Removed.

2006-01-19  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.do_continue): Only insert the temporary
	breakpoint if we're not stepping over a breakpoint; otherwise
	OperationStepOverBreakpoint takes care of that.

	* tests/mono-debugger.tests/TestBreakpoint.exp: Added some more
	test cases; this also addresses the underlying problem of #77056.

2006-01-19  Martin Baulig  <martin@ximian.com>

	Fix #77056.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.ProcessChildEvent): Don't remove the
	temporary breakpoint here unless we actually hit it.
	(SingleSteppingEngine.step_over_breakpoint): The `trampoline'
	argument is either null or the same than `until'; so change its
	type into a `bool'.
	(Operation.ResumeOperation): New protected virtual method; we're
	called if the operation got interrupted by a non-breaking
	breakpoint and we need to resume it.

	* backends/server/x86_64-arch.cx
	(86_arch_get_registers): Also read `DR_STATUS' here to make
	hardware breakpoints actually work.

2006-01-05  Hans Kratz <kratz@omnicore.com>

	* backends/ProcessStart.cs: Search for the for the wrapper in 
	the directory where mscorlib.dll is located instead.   This is
	used so other clients can work (X-Develop for example).

2005-12-21  Wade Berrier <wberrier@novell.com>

	* wrapper/mdb.in: Modify wrapper to match more closly the wrappers in mono

2005-12-15  Martin Baulig  <martin@ximian.com>

	Released version 0.11 "Guam" of the Mono Debugger :-)

2005-12-14  Martin Baulig  <martin@ximian.com>

	* wrapper/Mono.Debugger.Cecil.dll: Added this to SVN.

	* wrapper/Makefile.am: Don't build Mono.Debugger.Cecil.dll.

2005-12-14  Martin Baulig  <martin@ximian.com>

	* configure.in: Require Mono 1.1.11.

2005-12-14  Martin Baulig  <martin@ximian.com>

	* backends/remoting/DebuggerClient.cs
	(DebuggerClient.IsRemote): Use another appdomain instead of
	another process.

2005-12-11  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs
	(TypeExpr): New public abstract base class for `TypeExpression'.
	(PointerExpression): New public class.
	(CastExpression.DoEvaluateObject): Allow casting from a pointer
	expression of from a non-typesafe pointer to a native pointer.

	* frontend/CSharpExpressionParser.jay
	(variable_or_type_name): Add `NativeTypeName *' syntax for native
	pointers.	

2005-12-11  Martin Baulig  <martin@ximian.com>

	* backends/Debugger.cs
	(Debugger.NativeLanguage): New public property.

2005-12-11  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoGenericInstanceType.cs: New file.
	(MonoGenericInstanceType): New public class; derives from
	`MonoClass'.  We still don't have full generics support, we treat
	the generic instance just like a normal class.

2005-12-11  Martin Baulig  <martin@ximian.com>

	* languages/TargetPointerType.cs
	(TargetPointerType.GetObject): New public method to create a
	pointer from an address.

2005-12-11  Martin Baulig  <martin@ximian.com>

	* languages/Language.cs
	(Language.CreatePointerType): New public method.

2005-12-11  Martin Baulig  <martin@ximian.com>

	* arch/DwarfReader.cs: Improved the type support.

	* arch/BfdContainer.cs
	(BfdContainer.LookupType): We now use a type hashtable in the
	`BfdContainer' and keep track of incomplete structs: if there's a
	typedef entry for the same struct in more than one source file,
	return the actual definition.

2005-12-11  Martin Baulig  <martin@ximian.com>

	* backends/remoting/DebuggerClient.cs
	(DebuggerClient.ClientShutdown): New public event.

	* frontend/Interpreter.cs
	(Interpreter.Exit): Call Environment.Exit() in a `finally'
	handler; print, but ignore all exceptions.
	(Interpreter.InterpreterEventSink): Connect to the
	`DebuggerClient.ClientShutdown' event.

2005-12-07  Martin Baulig  <martin@ximian.com>

	Reworked the breakpoint code and added session management.

	* classes/DebuggerSession.cs
	(DebuggerSession): The new session management code.

	* classes/SourceFile.cs (SourceFile): Make this [Serializable].
	(SourceMethod): Likewise.

	* classes/SourceLocation.cs
	(SourceLocation): Make this [Serializable].

	* classes/EventHandle.cs
	(EventHandle): Don't implement `IEventHandle'; killed that
	interface.

	* arch/Bfd.cs (Bfd): Inherit from `SymbolFile', not `Module'.

	* languages/mono/MonoSymbolFile.cs
	(MonoSymbolFile): Inherit from `SymbolFile', not `Module'.

	* classes/CatchpointHandle.cs
	(CatchPointHandle): Don't use an `ExceptionCatchPoint' anymore; do
	everything in here instead.

	* classes/ThreadGroup.cs (ThreadGroup): Moved all the static
	methods into DebuggerManager.

	* classes/Module.cs
	(SymbolFile): New internal abstract class; replaces `ISymbolFile'.
	(Module): Don't make this abstract; split out all the
	functionality into `SymbolFile'.

	* classes/ExceptionCatchPoint.cs: Removed.

	* interfaces/IEventHandle.cs: Removed.

	* interfaces/ISymbolFile.cs: Removed.

2005-12-03  Martin Baulig  <martin@ximian.com>

	* classes/ProcessStart.cs: Moved to ../backends/ProcessStart.cs;
	moved the `ProcessStart' class into the `Mono.Debugger.Backends'
	namespace; moved the `DebuggerOptions' class into the new
	DebuggerSession.cs.

	* classes/DebuggerSession.cs: New file.
	(DebuggerOptions): Moved here from ProcessStart.cs.

2005-12-03  Martin Baulig  <martin@ximian.com>

	* classes/ProcessStart.cs
	(ProcessStart): Make this class internal.
	(DebuggerOptions): We're now [Serializable] and not a
	MarshalByRefObject anymore.	

2005-12-01  Martin Baulig  <martin@ximian.com>

	* frontend/ScriptingContext.cs (ProcessHandle): Removed.

2005-12-01  Martin Baulig  <martin@ximian.com>

	* frontend/ScriptingContext.cs
	(ProcessHandle): Removed some more stuff here and get ready to
	kill it.

2005-12-01  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(Command.SteppingCommand): New public abstract class; use this for
	all stepping commands.

	* frontend/ScriptingContext.cs (ProcessHandle.Step): Removed.

2005-12-01  Martin Baulig  <martin@ximian.com>

	* frontend/ScriptingContext.cs (FrameHandle): Removed.
	(BacktraceHandle): Removed.

2005-12-01  Martin Baulig  <martin@ximian.com>

	* classes/StackFrame.cs
	(StackFrame.ExceptionObject): New public property.

	* frontend/Style.cs
	(StyleBase.UnhandledException): Don't take a `TargetObject exc'
	argument; it's now part of the `StackFrame'.
	(StyleBase.TargetEvent): New public abstract method.

	* frontend/ScriptingContext.cs
	(FrameHandle.TargetEvent): Removed; we now use `Style.TargetEvent'.

2005-12-01  Martin Baulig  <martin@ximian.com>

	* frontend/ScriptingContext.cs
	(FrameHandle): Removed all the register stuff.

2005-12-01  Martin Baulig  <martin@ximian.com>

	* frontend/ScriptingContext.cs
	(FrameHandle.Disassemble): Removed.
	(FrameHandle.DisassembleMethod): Removed.
	(FrameHandle.Language): Removed.
	(ScriptingContext.CurrentLanguage): New public property.

2005-11-30  Martin Baulig  <martin@ximian.com>

	* frontend/Style.cs (StyleMartin): Removed.
	(StyleBase.PrintFrame): Take a `StackFrame' instead of a
	`FrameHandle'.
	(StyleBase.TargetStopped): Likewise.
	(StyleBase.UnhandledException): Likewise.

2005-11-30  Martin Baulig  <martin@ximian.com>

	* backends/server/i386-arch.h: Move the hardware breakpoint stuff
	to x86-ptrace.h and rename the `I386_DR_*' macros to `X86_DR_*'.

	* backends/server/x86_64-arch.c: Implement hardware breakpoints.

2005-11-30  Martin Baulig  <martin@ximian.com>

	* frontend/Style.cs: Merge `StyleMono' and `StyleNative' into a
	new `StyleCLI'.

2005-11-30  Martin Baulig  <martin@ximian.com>

	* backends/Process.cs (Process.DebuggerOutput): Removed.
	* backends/Process.cs (Process.DebuggerError): Removed.

2005-11-30  Martin Baulig  <martin@ximian.com>

	* backends/server/i386-arch.c
	(server_ptrace_call_method_invoke): Make this work again.

2005-11-29  Martin Baulig  <martin@ximian.com>

	* backends/server/i386-arch.c
	(server_ptrace_insert_breakpoint): You cannot have a hardware
	breakpoint and a normal breakpoint on the same address.
	(server_ptrace_insert_hw_breakpoint): Check whether we already
	have a breakpoint on the requested instruction.

2005-11-28  Martin Baulig  <martin@ximian.com>

	* classes/Report.cs (Report.Print): New public method.
	(Report.Error): New public method.

	* frontend/Interpreter.cs: Use Report.Print() and Report.Error()
	to print things.

2005-11-28  Martin Baulig  <martin@ximian.com>

	* backends/server/i386-arch.c: Make i386 support work again.

2005-11-11  Martin Baulig  <martin@ximian.com>

	* languages/native/NativeEnumObject.cs: Removed.
	* languages/mono/MonoEnumObject.cs: Removed.

	* languages/TargetEnumObject.cs
	(TargetEnumObject): Don't make this class abstract.
	(TargetEnumObject.Value): Implement this here.

	* languages/TargetEnumType.cs
	(TargetEnumType.GetValue): New internal method.

2005-11-11  Martin Baulig  <martin@ximian.com>

	* arch/DwarfReader.cs
	(DwarfTargetVariable.GetLocation): Implemented a few more opcodes.

	* languages/TargetVariable.cs
	(TargetVariable.PrintLocation): New public abstract method.

	* frontend/Command.cs
	(ShowLocationCommand): Added `show location' command.

2005-11-11  Martin Baulig  <martin@ximian.com>

	* backends/server/library.c
	(mono_debugger_server_initialize): Print a warning that running
	mdb as root may be a security risk; see
	http://primates.ximian.com/~martin/blog/entry_150.html for details.

2005-11-11  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs
	(Expression.EvaluateVariable): Renamed to `EvaluateObject'.
	(Expression.DoEvaluateVariable): Renamed to `DoEvaluateObject'.

2005-11-11  Martin Baulig  <martin@ximian.com>

	* arch/Architecture.cs
	(Architecture.CopyRegisters): New internal abstract method.

	* arch/DwarfFrameReader.cs: Use `arch.CopyRegisters()' to copy the
	registers; preserve callee saved registers.

	* classes/StackFrame.cs (Register.Name): New public field.

2005-11-11  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs
	(Expression.EvaluateLocation): Renamed to `EvaluateSource'.
	(Expression.DoEvaluateLocation): Renamed to `DoEvaluateSource'.

2005-11-10  Martin Baulig  <martin@ximian.com>

	* arch/Architecture.cs
	(Architecture.Hack_ReturnNull): You don't wanna use this function.

	* arch/BfdContainer.cs: Some minor API cleanups; make sure to set
	the newly created Bfd's `MainBfd'.

	* classes/Breakpoint.cs
	(Breakpoint.BreakpointHandler): New internal function.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.child_breakpoint): Call the new
	`bpt.BreakpointHandler()' method before CheckBreakpointHit().

	* arch/Bfd.cs
	(Bfd.DynlinkBreakpoint): New private class; we use this for the
	dynlink breakpoints.
	(Bfd.module_loaded): Added big big hack for gnome-vfs: intercept
	any calls to `__nptl_setxid()' via the new `SetXidBreakpoint' and
	make it return 0.

2005-11-10  Martin Baulig  <martin@ximian.com>

	* backends/server/library.c
	(mono_debugger_server_initialize): Refuse to run as root.

2005-11-09  Martin Baulig  <martin@ximian.com>

	* languages/TargetClassType.cs
	(TargetClassType.Module): New public abstract property.

	* languages/TargetFunctionType.cs
	(TargetFunctionType.IsLoaded): New public abstract property.

	* classes/BreakpointHandle.cs
	(BreakpointHandle.EnableBreakpoint): When inserting a breakpoint
	on a function, first check whether that function is loaded and use
	a load handler if not.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.ExecuteOperation): New private method; use
	this in ProcessOperation() and PushOperation() rather than calling
	`operation.Execute (this)' directly; catch exceptions here.

2005-11-08  Martin Baulig  <martin@ximian.com>

	* languages/Language.cs
	(Language.LookupType): Removed the `StackFrame' argument.

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.LookupMonoType): Use `LookupType' to lookup a
	`Cecil.ITypeReference'.	

2005-11-08  Martin Baulig  <martin@ximian.com>

	* backends/Inferior.cs
	(Inferior.CreateThread): Copy all the data to the new Inferior, so
	we don't need to call SetupInferior() on it.
	(Inferior.Attach): Don't call SetupInferior().
	(Inferior.Dispose): Don't dispose the `Bfd' as it's owned by the
	BfdContainer and will be disposed by the `Debugger' backend.

2005-11-02  Martin Baulig  <martin@ximian.com>

	* classes/Report.cs
	(Report): Make this a static class and remove everything except
	the `Debug' method.
	(ReportWriter): New public `MarshalByRefObject' class.

	* backends/remoting/DebuggerContext.cs
	(DebuggerContext.ReportWriter): New public property; share one
	`ReportWriter' instance between client and server so we can
	redirect debugging output to a file.

	* frontend/Main.cs (Main.ParseOption): The `-debug-flags' command
	line argument now takes an optional filename.

2005-11-02  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(CommandAttribute): Removed.
	(SingleSteppingEngine.SendCommand): New private method; call
	`manager.SendCommand' unless we're in the engine thread.
	(SingleSteppingEngine): Use `SendCommand' with an anonymous method
	everywhere instead of the [Command] attribute.

2005-10-29  Martin Baulig  <martin@ximian.com>

	Avoid using the `Process' in the server; instead use the
	`TargetAccess' to avoid unneccessary remoting round-trips.

	* backends/Process.cs (Process.CallMethod): Removed.

	* backends/TargetAccess.cs
	(ServerTargetAccess.CallMethod): Implemented.
	(TargetAccess.InsertBreakpoint): New internal method.
	(TargetAccess.RemoveBreakpoint): New internal method.
	(TargetAccess.AddEventHandler): New internal method.
	(TargetAccess.RemoveEventHandler): New internal method.

	* classes/BreakpointHandle.cs
	(BreakpointHandle): Operate on `TargetAccess' and not on
	`Process'.	

2005-10-29  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(CommandResult): Make this abstract.
	(SimpleCommandResult): New internal class.
	(Operation.Result): New public readonly field.
	(SingleSteppingEngine.operation_completed): Don't call
	`process.SendTargetEvent()' anymore; our `current_operation' now
	contains a `CommandResult' which has the completed event.

	* backends/Process.cs (Process.State): Return the SSE's state.
	(Process.SendTargetEvent): Removed.
	(Process): When calling methods on the SSE, don't wait on the
	`operation_completed_event' directly; use the `CommandResult'.

2005-10-26  Martin Baulig  <martin@ximian.com>

	* languages/TargetClassType.cs
	(TargetClassType.ResolveClass): Removed.

	* languages/TargetFunctionType.cs
	(TargetFunctionType.GetVirtualMethod): Removed.

	* backends/Process.cs
	(Process.RuntimeInvoke): Take a `TargetFunctionType' instead of a
	`TargetAddress' and added `bool is_virtual' argument.

	* backends/SingleSteppingEngine.cs
	(OperationRuntimeInvoke): Cleaned this up; box the instance and
	compute the (virtual) method address here.

2005-10-20  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs
	(Convert.ImplicitConversion(Exists)): Add support for implicit
	reference conversions from a type to its parent.

	* test/mono-debugger.tests/TestInheritance.exp: Added testcase.

2005-10-20  Martin Baulig  <martin@ximian.com>

	* frontend/Style.cs
	(StyleNative.DoFormatObject): Added support for enums.

	* languages/TargetEnumType.cs
	(TargetEnumType.IsFlagsEnum): New public property.

	* languages/TargetMember.cs
	(TargetMemberInfo): Make this a MarshalByRefObject.
	(TargetFieldInfo.ConstValue): New public property; replaces
	GetConstValue().
	(TargetFieldInfo.GetConstValue): Removed.

	* test/mono-debugger.tests/TestEnum.exp: Added enum test.

2005-10-19  Martin Baulig  <martin@ximian.com>

	* languages/TargetFunctionType.cs
	(TargetFunctionType.GetMethodAddress): New public method.
	(TargetFunctionType.GetVirtualMethod): New public method.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.RuntimeInvoke): Take a `TargetAddress'
	instead of a `TargetFunctionType'.
	(OperationRuntimeInvoke): Don't compute the virtual method and
	also don't box the instance here; our caller is now responsible
	for doing that.

	* backends/Process.cs (Process.RuntimeInvoke): Take a
	`TargetAddress' instead of a `TargetFunctionType'.

	* frontend/ScriptingContext.cs
	(ScriptingContext.RuntimeInvoke): Compute the virtual method and
	box/unbox the instance object here.

2005-10-18  Martin Baulig  <martin@ximian.com>

	* languages/TargetObjectType.cs
	(TargetObjectType): New public abstract class.

	* languages/TargetObjectObject.cs
	(TargetObjectObject): New public abstract class.

	* languages/TargetObjectKind.cs
	(TargetObjectKind): Added `TargetObjectKind.Object'.

	* languages/mono/MonoObjectType.cs
	(MonoObjectType): Derive from `TargetObjectType'.

	* languages/mono/MonoObjectObject.cs
	(MonoObjectObject): Derive from `TargetObjectObject'.

	* frontend/Expression.cs
	(Convert.ToClassType): New public static method.
	(Convert.ToClassObject): Likewise.

2005-10-18  Martin Baulig  <martin@ximian.com>

	* languages/TargetClassObject.cs
	(TargetClassObject.GetCurrentObject): New public abstract method.

	* frontend/Expression.cs
	(Cast.TryCurrentCast): Make this actually work.

2005-10-18  Martin Baulig  <martin@ximian.com>

	* backends/server/x86_64-arch.c, i386-arch.c: Save and restore
	`inferior->last_signal' across invocations.

2005-10-17  Martin Baulig  <martin@ximian.com>

	* backends/classes/MonoVariableLocation.cs
	(MonoVariableLocation.WriteAddress): Correctly handle `is_byref'.

2005-10-17  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs (VariableAccessExpression.DoAssign): Call
	`Convert.ImplicitConversionRequired' on the object to convert it
	to the correct type.

2005-10-17  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs
	(MethodGroupExpression.ctor): Take a `TargetFunctionType[]' array
	instead of an `ArrayList'.
	(PropertyGroupExpression): Removed.
	(InvocationExpression.DoResolve): Do overload resolution here.
	(InvocationExpression.DoResolveType): Override this.
	(InvocationExpression.Invoke): Return `void'.
	(ArrayAccessExpression.DoResolveVariable, DoAssign): Use an
	`InvocationExpression' to invoke indexers.

2005-10-17  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs (Convert): New public static class.
	(Convert.ImplicitConversion): New public method.
	(Convert.ImplicitConversionExists): Likewise.
	(Convert.ImplicitConversionRequired): Likewise.
	(MethodGroupExpression.IsApplicable): New method to check whether
	a method is actually applicable.
	(MethodGroupExpression.OverloadResolve): Also check whether the
	method is applicable if there is just one single method; take a
	`TargetType[]' array instead of an `Expression[]' array as
	argument.
	(MethodGroupExpression.OverloadResolve): Make the overloaded
	version taking an `ArrayList candidates' private.
	(InvocationExpression.Invoke): Implicitly convert the arguments to
	the actual parameter types.
	(NewExpression.Invoke): Create an InvocationExpression to avoid
	some code duplication.

2005-10-16  Martin Baulig  <martin@ximian.com>

	* backends/classes/ClientSuppliedTargetLocation.cs
	(ClientSuppliedTargetLocation): New internal class.

	* languages/TargetFundamentalType.cs
	(TargetFundamentalType.CreateInstance): Use the new
	`ClientSuppliedTargetLocation' as the object's location rather
	than using the heap.

	* languages/Language.cs (Language.AllocateMemory): Removed.

	* languages/mono/Heap.cs: Removed.

2005-10-16  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(OperationAbortInvocation): New operation to abort a runtime
	invoke; this unwinds the stack and calls all `finally' handlers.
	(SingleSteppingEngine.AbortInvocation): New function.

2005-10-16  Martin Baulig  <martin@ximian.com>

	* classes/StackFrame.cs (StackFrame.ctor): Don't take a `level'
	argument; we compute this automatically when adding the frame to
	the Backtrace.

2005-10-16  Martin Baulig  <martin@ximian.com>

	* test/TestAbort.cs, test/mono-debugger.test/TestAbort.exp: New
	test for the stack unwinding and `return'.

2005-10-16  Martin Baulig  <martin@ximian.com>

	* backends/server/server.c
	(mono_debugger_server_abort_invoke): New public method.

	* backends/SingleSteppingEngine.cs
	(SingleSteppingEngine.Return): Check whether we're crossing a
	runtime invoke boundary and abort the invocation if neccessary.
	(SingleSteppingEngine.ProcessChildEvent): We now receive a
	`CHILD_CALLBACK_COMPLETED' event when completing a debugging
	runtime invoke.

	* backends/Inferior.cs
	(Inferior.ChildEventType): Added `CHILD_CALLBACK_COMPLETED'.

	* backends/server/x86_64-arch.c
	(x86_arch_child_stopped): Send `STOP_ACTION_CALLBACK_COMPLETED' if
	we completed a debugging runtime invoke.

2005-10-16  Martin Baulig  <martin@ximian.com>

	* classes/StackFrame.cs (StackFrame): Don't implement IDisposable.
	(StackFrame.FrameInvalidEvent): Removed.
	(ObjectInvalidHandler): Removed.

	* classes/Backtrace.cs (Backtrace): Don't implement IDisposable.
	(Backtrace.BacktraceInvalidEvent): Removed.

2005-10-16  Martin Baulig  <martin@ximian.com>

	Added the `return' command to make the current stack frame return.

	* wrapper/mono-debugger-jit-wrapper.h
	(MonoDebuggerInfo): Added `run_finally'.

	* backends/server/server.c
	(mono_debugger_server_call_method_2): New public method; invoke a
	function which takes a `MonoContext *' (private mini data structure)
	argument; we use this to call mono_debugger_run_finally().

	* backends/SingleSteppingEngine.cs
	(OperationReturn): New operation; run the current frame's
	`finally' handlers.
	(SingleSteppingEngine.Return): New public method; make the current
	stack frame return.

	* frontend/Command.cs (ReturnCommand): Added a `return' command to
	make the current stack frame return.

2005-10-14  Martin Baulig  <martin@ximian.com>

	Only use a single AddressDomain per process.

	* interfaces/ITargetMemoryAccess.cs
	(ITargetMemoryInfo.GlobalAddressDomain): Removed; use
	`AddressDomain' instead.
	(ITargetMemoryAccess.ReadGlobalAddress): Removed; use
	`ReadAddress' instead.

2005-10-11  Martin Baulig  <martin@ximian.com>

	* classes/StackFrame.cs (SimpleStackFrame): Removed.

2005-10-11  Martin Baulig  <martin@ximian.com>

	* arch/Architecture.cs: The stack unwinding methods now operate on
	`StackFrame's instead of `SimpleStackFrame's.

2005-10-11  Martin Baulig  <martin@ximian.com>

	* classes/StackFrame.cs
	(StackFrame.SourceAddress): Create this lazily.

2005-10-11  Martin Baulig  <martin@ximian.com>

	* classes/SymbolTableManager.cs
	(SymbolTableManager.SymbolTable): Removed.
	(SymbolTableManager): Make some API entry points `internal'.

2005-10-11  Martin Baulig  <martin@ximian.com>

	* interfaces/ISymbolTable.cs (ISimpleSymbolTable): Removed.

	* arch/Disassembler.cs (Disassembler.SymbolTable): Removed.

	* classes/SimpleSymbolTableCollection.cs: Removed.

	* classes/Module.cs (Module.SimpleSymbolTable): Removed.
	(Module.SimpleLookup): New public abstract method.

	* classes/SymbolTableManager.cs
	(SymbolTableManager.Lookup): New public method.
	(SymbolTableManager.SimpleLookup): New public method.
	(SymbolTableManager.SimpleSymbolTable): Removed.

	* backends/Process.cs
	(Process.SimpleLookup): Made this public.
	(Process.Lookup): New public method.

2005-10-11  Martin Baulig  <martin@ximian.com>

	* arch/Disassembler.cs
	(Disassembler): New internal abstract class; replaces the
	`IDisassembler' interface.

	* interfaces/IDisassembler.cs: Removed.

2005-10-11  Martin Baulig  <martin@ximian.com>

	* classes/StackFrame.cs
	(SimpleStackFrame): Make this `internal', not `public'.

2005-10-11  Martin Baulig  <martin@ximian.com>

	* classes/MethodBase.cs: Renamed to Method.cs.
	(MethodBase): Renamed to `Method'.

	* classes/Method.cs (Method): This abstract base class now
	replaces the `IMethod' interface.

	* interfaces/IMethod.cs: Removed.

2005-10-11  Martin Baulig  <martin@ximian.com>

	* interfaces/IArchitecture.cs (IArchitecture): Replaced this
	interfaces with the abstract class `Architecture'.

	* arch/Architecture.cs (Architecture): New public abstract class;
	replaces the `IArchitecture' interface.  Make a few API entry
	points `internal' instead of `public'.

2005-10-11  Martin Baulig  <martin@ximian.com>

	* arch/Architecture_PowerPC.cs: Removed.

2005-10-11  Martin Baulig  <martin@ximian.com>

	* arch/*.cs: Removed the `Mono.Debugger.Architecture' namespace;
	use `Mono.Debugger.Backends' instead.

2005-10-11  Martin Baulig  <martin@ximian.com>

	* interfaces/IArchitecture.cs
	(IArchitecture.TrySpecialUnwind): New method.

	* arch/Architecture_X86_64.cs
	(Architecture_X86_64.TrySpecialUnwind): Support sigreturn trampolines.	

2005-10-10  Martin Baulig  <martin@ximian.com>

	* backends/server/x86_64-arch.c
	(x86_arch_child_stopped): Send a `CHILD_HIT_BREAKPOINT' event if
	we completed a debugging runtime-invoke.

	* backends/server/i386-arch.c (x86_arch_child_stopped): Likewise.

	* backends/MonoThreadManager.cs
	(MonoThreadManager.thread_abort): Don't kill the thread.

	* frontend/Expression.cs
	(RegisterExpression): Derive from PointerExpression.

2005-10-08  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(OperationRuntimeInvoke): If we're invoking a method from
	System.Object or System.ValueType on a valuetype instance, we need
	to box it.

2005-10-07  Martin Baulig  <martin@ximian.com>

	* languages/TargetClassType.cs
	(TargetClassType.GetStaticField): Take a `TargetFieldInfo' instead
	of an `int'.
	(TargetClassType.SetStaticField): Likewise.

	* languages/TargetClassObject.cs
	(TargetClassObject.GetField): Take a `TargetFieldInfo' instead of
	an `int'.
	(TargetClassObject.SetField): Likewise.

2005-10-07  Martin Baulig  <martin@ximian.com>

	* test/TestToString.cs: New test.
	* test/mono-debugger.test/TestToString.exp: New test.

2005-10-07  Martin Baulig  <martin@ximian.com>

	* languages/TargetObject.cs
	(TargetObject.HasAddress): Moved here from TargetPointerObject.
	(TargetObject.Address): Likewise.

2005-10-07  Martin Baulig  <martin@ximian.com>

	* frontend/Command.cs
	(Command.PrintCommand.format): Default to `DisplayFormat.Object'.

	* languages/Language.cs (Language.ObjectType): New property.

	* backends/SingleSteppingEngine.cs
	(OperationRuntimeInvoke): Don't call the `GetVirtualMethodFunc' if
	our instance is a valuetype.

2005-10-05  Martin Baulig  <martin@ximian.com>

	* frontend/ScriptingContext.cs
	(ScriptingContext.PrintObject): Try calling a MonoObject's
	"ToString()" method for `DisplayFormat.Object'.

2005-10-05  Martin Baulig  <martin@ximian.com>

	* classes/Style.cs (DisplayFormat): New public enum.
	(Style.FormatObject): Added `DisplayFormat format' argument.

2005-09-29  Martin Baulig  <martin@ximian.com>

	* languages/TargetEnumType.cs (TargetEnumType.GetMember): Removed.

	* languages/Language.cs
	(Language.CreateInstance): Removed the overloaded version taking a
	`StackFrame' and an `object'; the other one is now taking a
	`TargetAccess' and an `object'.

	* languages/mono/MonoEnumTypeInfo.cs: Removed.

	* languages/mono/MonoEnumType.cs: This is now working again.
	* languages/mono/MonoEnumObject.cs: This is now working again.

2005-09-29  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoClassType.cs
	(MonoClassType.ResolveClass): Resolve our parent first.

2005-09-28  Martin Baulig  <martin@ximian.com>

	* frontend/Expression.cs
	(Expression.ResolveMethod): New method.
	(MemberAccessExpression.ResolveMemberAccess): Allow accessing an
	instance member in static context if we're doing a method lookup.

	* frontend/Command.cs (SourceCommand.EvaluateMethod): use
	`expr.ResolveMethod ()' instead of `expr.Resolve ()'.

	* tests/mono-debugger.tests/TestBreakpoint.exp: Added test case
	for inserting a breakpoint on an instance method.

2005-09-28  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoPointerType.cs: New file.
	* languages/mono/MonoPointerObject.cs: New file.

	* languages/mono/MonoDebuggerSupport.cs
	(MonoDebuggerSupport.GetTypeFromSignature): Added support for
	`MONO_TYPE_PTR' and `MONO_TYPE_BYREF'.

	* languages/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.LookupMonoType): Create a `MonoPointerType'
	for `byref' types.

2005-09-28  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(OperationRuntimeInvoke.DoProcessEvent): Stop if we're in debug
	mode.	

2005-09-28  Martin Baulig  <martin@ximian.com>

	* tests/TestInheritance.cs: Added tests for abstract classes.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* backends/TargetAccess.cs
	(TargetAccess.RuntimeInvoke): Removed.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* backends/ThreadManager.cs
	(ThreadManager): Made this `internal'.
	(ThreadEventHandler): Moved to Debugger.cs and renamed to
	`DebuggerEventHandler'.
	(ThreadManager): Moved the `InitializedEvent',
	`MainThreadCreatedEvent', `ThreadCreatedEvent',
	`ThreadExitedEvent', `TargetExitedEvent' and `TargetEvent' into
	the `Debugger' class.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* backends/Debugger.cs
	(DebuggerBackend): Renamed to `Debugger'.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* languages/TargetClassObject.cs
	(TargetClassObject.Parent): Replaced the property with a
	`GetParentObject()' method.

	* languages/TargetObject.cs
	(TargetObject.GetDynamicSize): Added `TargetAccess' argument.

	* backends/classes/TargetLocation.cs
	(TargetLocation.TargetAccess): Removed.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* languages/TargetClassObject.cs
	(TargetClassObject.GetField): Added `TargetAccess' argument.
	(TargetClassObject.SetField): Likewise.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* languages/TargetPointerObject.cs
	(TargetPointerObject.CurrentType): Replaced the property with a
	`GetCurrentType()' method.
	(TargetPointerObject.DereferencedObject): Replaced the property
	with a `GetDereferencedObject()' method.
	(TargetPointerObject.DereferencedContents): Removed.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* backends/ptrace/PTrace.cs: Removed.
	(PTraceInferior): Merged with `Inferior'.

	* backends/Inferior.cs
	(Inferior): Don't make this abstract.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetAccess.cs: Removed.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* interfaces/ILanguage.cs: Removed.

	* languages/Language.cs: New file.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* interfaces/TargetObjectKind.cs: Moved to
	languages/TargetObjectKind.	

2005-09-25  Martin Baulig  <martin@ximian.com>

	* interfaces/IVariable.cs: Removed.

	* languages/TargetVariable.cs: New file.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetType.cs: Removed.

	* interfaces/ITargetObject.cs: Removed.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetTypeAlias.cs: Removed.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* languages/TargetClassType.cs: New file.
	* languages/TargetClassObject.cs: New file.

	* interfaces/ITargetStructType.cs: Removed.
	* interfaces/ITargetStructObject.cs: Removed.
	* interfaces/ITargetClassType.cs: Removed.
	* interfaces/ITargetClassObject.cs: Removed.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* languages/TargetEnumType.cs: New file.
	* languages/TargetEnumObject.cs: New file.

	* interfaces/ITargetEnumType.cs: Removed.
	* interfaces/ITargetEnumObject.cs: Removed.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* langauges/TargetMember.cs: New file.
	(TargetMemberInfo): New public abstract class.
	(TargetFieldInfo): New public abstract class.
	(TargetPropertyInfo): New public abstract class.
	(TargetEventInfo): New public abstract class.
	(TargetMethodInfo): New public abstract class.

	* interfaces/ITargetStructType.cs
	(ITargetStructType.ITargetMemberInfo): Removed.
	(ITargetStructType.ITargetFieldInfo): Removed.
	(ITargetStructType.ITargetPropertyInfo): Removed.
	(ITargetStructType.ITargetEventInfo): Removed.
	(ITargetStructType.ITargetMethodInfo): Removed.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* languages/TargetPointerType.cs: New file.
	* languages/TargetPointerObject.cs: New file.

	* interfaces/ITargetPointerType.cs: Removed.
	* interfaces/ITargetPointerObject.cs: Removed.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetFundamentalType.cs: Removed.
	* interfaces/ITargetFundamentalObject.cs: Removed.
	* interfaces/ITargetFunctionType.cs: Removed.
	* interfaces/ITargetArrayType.cs: Removed.
	* interfaces/ITargetArrayObject.cs: Removed.

2005-09-25  Martin Baulig  <martin@ximian.com>

	* languages/TargetArrayType.cs: New file.
	* languages/TargetArrayObject.cs: New file.

2005-09-24  Martin Baulig  <martin@ximian.com>

	* languages/TargetType.cs (TargetType): Made this public.

	* languages/TargetObject.cs (TargetObject): Made this public.
	(TargetObject.Location): Replaced the `location' field and the
	`Location' property with an `internal readonly' field `Location'.
	(TargetObject.GetDynamicSize): Made this `internal', not
	`protected'.	

	* languages/TargetFundamentalObject.cs
	(TargetFundamentalObject): Made this public.

	* languages/TargetFundamentalType.cs
	(TargetFundamentalType): Made this public.

	* languages/TargetFunctionType.cs
	(TargetFunctionType): Made this public.

2005-09-24  Martin Baulig  <martin@ximian.com>

	* backends/classes/TargetLocation.cs
	(TargetLocation.StackFrame): Removed.

	* backends/classes/MonoVariableLocation.cs
	(MonoVariableLocation..ctor): Take an `ITargeAccess' and a
	`Register' argument instead of a `StackFrame'.

2005-09-24  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetFundamentalObject.cs
	(ITargetFundamentalObject.SetObject): Added `ITargetAccess' arg.

2005-09-24  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetPointerObject.cs
	(ITargetPointerObject.GetArrayElement): Added `ITargetAccess' arg.

	* backends/classes/TargetLocation.cs
	(TargetLocation.GetLocationAtOffset): Removed the `bool
	dereference' argument.
	(TargetLocation.GetDereferencedLocation): New method.
	
2005-09-24  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetArrayObject.cs
	(ITargetArrayObject.this): Replaced the indexer with a
	`GetElement()' and a `SetElement()' method; both taking an
	`ITargetAccess' argument.

2005-09-24  Martin Baulig  <martin@ximian.com>

	* interfaces/IVariable.cs (IVariable.IsValid): Removed.

	* languages/TargetType.cs (TargetType.GetObject): Made this
	`internal', not `public'.

2005-09-24  Martin Baulig  <martin@ximian.com>

	* languages/TargetFunctionType.cs: New file.

2005-09-23  Martin Baulig  <martin@ximian.com>

	* languages/native/NativeFundamentalType.cs: Removed; use
	`TargetFundamentalType' instead.

	* languages/native/NativeFundamentalObject.cs: Removed; use
	`TargetFundamentalObject' instead.

2005-09-23  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoFundamentalType.cs: Moved to
	languages/TargetFundamentalType.cs
	(MonoFundamentalType): Renamed to `TargetFundamentalType'.

	* languages/mono/MonoFundamentalObject.cs: Moved to
	languages/TargetFundamentalObject.cs
	(MonoFundamentalObject): Renamed to `TargetFundamentalObject'.

2005-09-23  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoFundamentalObjectBase.cs
	(MonoFundamentalObjectBase): Merged into `MonoFundamentalObject'.

2005-09-23  Martin Baulig  <martin@ximian.com>

	* languages/native/NativeType.cs: Removed; use `TargetType' instead.

	* languages/native/NativeObject.cs: Removed; use `TargetObject' instead.

2005-09-23  Martin Baulig  <martin@ximian.com>

	* arch/StabsReader.cs: Removed for the moment until someone fully
	implements PowerPC support.

	* arch/Bfd.cs: Disabled PowerPC support.

2005-09-23  Martin Baulig  <martin@ximian.com>

	* languages/mono/MonoType.cs: Moved to languages/TargetType.cs.
	(MonoType): Renamed to `TargetType'.

	* languages/mono/MonoObject.cs: Moved to languages/TargetObject.cs.
	(MonoObject): Renamed to `TargetObject'.

2005-09-23  Martin Baulig  <martin@ximian.com>

	* languages/: New directory.

	* backends/mono/: Moved to languages/mono/.
	* backends/native/: Moved to languages/native/.

2005-09-23  Martin Baulig  <martin@ximian.com>

	* backends/mono/MonoFundamentalType.cs
	(MonoFundamentalType.ctor): Just take an `ILanguage' instead of a
	`MonoSymbolFile'; removed the `klass_address' argument.

	* backends/mono/MonoObjectType.cs
	(MonoObjectType.ctor): Removed the `klass_address' argument.

	* backends/mono/MonoStringType.cs
	(MonoStringtype.ctor): Removed the `klass_address' argument.

2005-09-23  Martin Baulig  <martin@ximian.com>

	* interfaces/ILanguage.cs
	(ILanguage.TargetInfo): New property.

2005-09-23  Martin Baulig  <martin@ximian.com>

	* interfaces/ILanguage.cs
	(ILanguage.AllocateMemory): New method.

	* backends/mono/MonoLanguageBackend.cs
	(MonoLanguageBackend.DataHeap): removed; use AllocateMemory()
	instead.	

2005-09-23  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetType.cs (ITargetType.IsByRef): New property.

	* backends/mono/MonoObject.cs
	(MonoObject.Type): Return an `ITargetType' instead of a
	`MonoType'.

	* backends/mono/MonoType.cs
	(MonoType.File): Removed.
	(MonoType..ctor): Take an `ILanguage' instead of a
	`MonoSymbolFile'.	

2005-09-23  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetFundamentalObject.cs
	(ITargetFundamentalObject.HasObject): Removed.
	(ITargetFundamentalObject.Object): Replaced the property with a
	`GetObject (ITargetAccess target)' method.

2005-09-23  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetObject.cs
	(ITargetObject.IsValid): Removed.
	(ITargetObject.RawContents): Removed.
	(ITargetObject.DynamicSize): Removed.
	(ITargetObject.GetRawDynamicContents): Removed.
	(ITargetObject.Print): Take an `ITargetAccess' argument.

2005-09-23  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(OperationRun): Derive from `Opeartion', not `OperationStepBase'.
	(OperationCompileMethod): Killed the nested operation.
	(OperationRuntimeInvoke.DoProcessEvent): Step over breakpoints
	during runtime-invoke.

	* test/mono-debugger.tests/TestBreakpoint.exp: Added test case: we
	step over breakpoints during runtime-invoke.

2005-09-22  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetStructType.cs
	(ITargetStructType.SetStaticField): New method.

	* interfaces/ITargetStructObject.cs
	(ITargetStructObject.SetField): New method.

	* frontend/Expression.cs (MemberExpression): New abstract class.
	(MethodGroupExpression): Derive from MemberExpression.
	(StructAccessExpression): Derive from MemberExpression.
	(StructAccessExpression.FindMember): Big cleanup; take
	`bool search_instance' and a `bool search_static' args, save the
	`ITargetStructObject instance' as `MemberExpression.InstanceObject'.

2005-09-22  Martin Baulig  <martin@ximian.com>

	* backends/remoting/DebuggerServer.cs: Big big FIXME; set the
	lease timeout to 3 hours to prevent the debugger from dying.

2005-09-22  Martin Baulig  <martin@ximian.com>

	* backends/SingleSteppingEngine.cs
	(OperationCallback): New operation; this replaces the old
	`Callback' mechanism.
	(Callback): Removed.
	(SingleSteppingEngine.ProcessChildEvent): Correctly emit the
	`TargetEventType.TargetHitBreakpoint' event when hitting a
	breakpoint instead of just `TargetEventType.TargetStopped'.
	(OperationStepOverBreakpoint): Improved and fixed a couple of
	problems.

	* test/mono-debugger.tests/*.exp: Reflect latest
	TargetHitBreakpoint changes.

	* test/mono-debugger.tests/TestBreakpoint.exp: Added some more
	test cases for stepping over breakpoints.

2005-09-21  Martin Baulig  <martin@ximian.com>

	* test/TestBreakpoint.cs: New test.
	* test/mono-debugger.tests/TestBreakpoint.exp: New test.

2005-09-21  Martin Baulig  <martin@ximian.com>

	* test/TestProperty.cs: New test.
	* test/mono-debugger.tests/TestProperty.exp: New test.

2005-09-20  Martin Baulig  <martin@ximian.com>

	* interfaces/ITargetStructType.cs
	(ITargetStructType.ResolveClass): New method.

	* interfaces/ITargetFunctionType.cs
	(ITargetFunctionType.DeclaringType): New property.

	* backends/mono/MonoLanguageBackend.cs
	(MonoDebuggerInfo.LookupClass): New field.
	(MonoLanguageBackend.LookupClass): New method.

	* wrapper/mono-debugger-jit-wrapper.h
	(MonoDebuggerInfo): Added `lookup_class'.

	* backends/mono/MonoClassType.cs
	(MonoClassType.ResolveClass): If we don't already have a
	`type_info', create it via MonoLanguageBackend.LookupClass();
	this'll effectively call `mono_class_get (image, token)' in the
	target and use the returned `MonoClass *' address.

	* frontend/ScriptingContext.cs (ProcessHandle.RuntimeInvoke): Call
	`func.DeclaringType.ResolveClass (process.TargetAccess)'.

2005-09-20  Martin Baulig  <martin@ximian.com>

	* backends/mono/MonoEnumType.cs: Unused; disable for the moment.
	* backends/mono/MonoEnumTypeInfo.cs: Likewise.
	* backends/mono/MonoEnumObject.cs: Likewise.

	* backends/mono/MonoTypeInfo.cs: Removed.

	* backends/mono/MonoType.cs
	(MonoType.GetTypeInfo): Removed.
	(MonoType.DoGetTypeInfo): Removed.
	(MonoType.Size): Made this abstract.
	(MonoType.GetObject): New public abstract method.

	* backends/mono/MonoClassInfo.cs
	(MonoClassInfo): Killed the `MonoTypeInfo' base classs; derive
	directly from `MarshalByRefObject'.

	* backends/mono/MonoObject.cs
